Package: enrichViewNet
Type: Package
Version: 1.8.0
Date: 2023-08-12
Title: From functional enrichment results to biological networks
Description: This package enables the visualization of functional 
    enrichment results as network graphs. First the package enables the 
    visualization of enrichment results, in a format corresponding to the one 
    generated by gprofiler2, as a customizable Cytoscape network. In those 
    networks, both gene datasets (GO terms/pathways/protein complexes) and 
    genes associated to the datasets are represented as nodes. While the 
    edges connect each gene to its dataset(s). The package also provides the 
    option to create enrichment maps from functional enrichment results. 
    Enrichment maps enable the visualization of enriched terms into a network 
    with edges connecting overlapping genes.
Authors@R: c(person("Astrid", "Deschênes", email = "adeschen@hotmail.com",
    role=c("aut", "cre"), comment=c(ORCID = "0000-0001-7846-6749")), 
    person("Pascal", "Belleau", email = "pascal_belleau@hotmail.com",
    role=c("aut"), comment = c(ORCID = "0000-0002-0802-1071")), 
    person("Robert L.", "Faure", email="robert.faure@crchudequebec.ulaval.ca",
    role=c("aut"), comment=c(ORCID="0000-0003-1798-4723")), 
    person("Maria J.", "Fernandes", 
    email="maria.fernandes@crchudequebec.ulaval.ca", role = c("aut"), 
    comment=c(ORCID="0000-0002-3973-025X")),
    person(given="Alexander", family="Krasnitz", email="krasnitz@cshl.edu",
    role=c("aut")),
    person(given="David A.", family="Tuveson",
    email="dtuveson@cshl.edu", 
    role=c("aut"), comment=c(ORCID="0000-0002-8017-2712")))
Encoding: UTF-8
License: Artistic-2.0
Depends: R (>= 4.2.0)
Imports: gprofiler2, strex, RCy3, jsonlite, stringr, enrichplot, DOSE,
        igraph, reshape2, methods
Suggests: BiocStyle, knitr, rmarkdown, ggplot2, scatterpie, ggtangle,
        ggrepel, testthat, ggnetwork, magick
biocViews: BiologicalQuestion, Software, Network, NetworkEnrichment, GO
VignetteBuilder: knitr
URL: https://github.com/adeschen/enrichViewNet,
        https://adeschen.github.io/enrichViewNet/
BugReports: https://github.com/adeschen/enrichViewNet/issues
RoxygenNote: 7.3.3
git_url: https://git.bioconductor.org/packages/enrichViewNet
git_branch: RELEASE_3_22
git_last_commit: 0359c98
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 03:49:10 UTC; biocbuild
Author: Astrid Deschênes [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7846-6749>),
  Pascal Belleau [aut] (ORCID: <https://orcid.org/0000-0002-0802-1071>),
  Robert L. Faure [aut] (ORCID: <https://orcid.org/0000-0003-1798-4723>),
  Maria J. Fernandes [aut] (ORCID:
    <https://orcid.org/0000-0002-3973-025X>),
  Alexander Krasnitz [aut],
  David A. Tuveson [aut] (ORCID: <https://orcid.org/0000-0002-8017-2712>)
Maintainer: Astrid Deschênes <adeschen@hotmail.com>

<!-- badges: start -->
[![R-CMD-check-bioc](https://github.com/adeschen/enrichViewNet/actions/workflows/check-bioc.yml/badge.svg)](https://github.com/adeschen/enrichViewNet/actions/workflows/check-bioc.yml)
[![codecov](https://codecov.io/gh/adeschen/enrichViewNet/graph/badge.svg?token=N3RA2934V5)](https://codecov.io/gh/adeschen/enrichViewNet)
[![License: Artistic-2.0](https://img.shields.io/badge/License-Artistic%202.0-0298c3.svg)](https://opensource.org/licenses/Artistic-2.0)
<!-- badges: end -->


The **enrichViewNet** package enables the transformation of 
functional enrichment results, formatted as the results obtained  by [gprofiler2](https://cran.r-project.org/web/packages/gprofiler2/vignettes/gprofiler2.html), 
into networks. 

First, the **enrichViewNet** package enables the 
visualization of enrichment results a [Cytoscape](https://cytoscape.org/) 
network where significant terms 
(Gene Ontology/Reactome/Transcription Factor/etc..) and 
genes are nodes. In this network, edges connect genes that are part of the
enrichment request to their terms. 

In addition, the **enrichViewNet** package also provides the option to 
create enrichment maps from functional enrichment results. 
Enrichment maps, as introduced in the Bioconductor 
[enrichplot](https://bioconductor.org/packages/release/bioc/html/enrichplot.html) package, 
enable the visualization of enriched terms 
into a network with edges connecting overlapping genes. Thus, enriched terms 
with overlapping genes cluster together.

## Bioconductor Package ##

[![Bioconductor Time](https://bioconductor.org/shields/years-in-bioc/enrichViewNet.svg)](https://bioconductor.org/packages/enrichViewNet)

The **enrichViewNet** package is now an official package 
of [Bioconductor](http://bioconductor.org/). 

The current Bioconductor release can be directly downloaded from their website:
[Current release](https://bioconductor.org/packages/enrichViewNet/)


## Authors ##

[Astrid Desch&ecirc;nes](http://ca.linkedin.com/in/astriddeschenes "Astrid Desch&ecirc;nes"), 
[Pascal Belleau](http://ca.linkedin.com/in/pascalbelleau "Pascal Belleau"), 
[Robert L Faure](https://www.crchudequebec.ulaval.ca/en/research/researchers/robert-l-faure/), 
[Maria J Fernandes](https://www.crchudequebec.ulaval.ca/en/research/researchers/maria-fernandes/),
[Alexander Krasnitz](https://www.cshl.edu/research/faculty-staff/alexander-krasnitz/) and 
[David A Tuveson](https://tuvesonlab.labsites.cshl.edu/)

## License ##

This package and the underlying **enrichViewNet** code are distributed under 
the Artistic license 2.0. You are free to use and redistribute this software. 

For more information on Artistic 2.0 License see
[http://opensource.org/licenses/Artistic-2.0](http://opensource.org/licenses/Artistic-2.0)


## Documentation ##

[enrichViewNet Website](https://adeschen.github.io/enrichViewNet/)

[enrichViewNet Get Started](https://adeschen.github.io/enrichViewNet/articles/enrichViewNet.html)


## Installation ##

To install the latest version accessible, the 
[devtools](https://cran.r-project.org/web/packages/devtools/index.html) 
package is required.

     ## Load required package
     library(devtools)

     ## Install the latest version of enrichViewNet
     devtools::install_github('adeschen/enrichViewNet')


To install this package 
from [Bioconductor](https://bioconductor.org), start R 
(version 4.3 or later) and enter: 

     if (!requireNamespace("BiocManager", quietly = TRUE))
        install.packages("BiocManager")

     BiocManager::install("enrichViewNet")


## Bugs/Feature requests ##

If you have any bugs or feature requests, 
[let us know](https://github.com/adeschen/enrichViewNet/issues). 

Thanks!

#' @title Validate arguments passed to createEnrichMap() function
#' 
#' @description Validate the arguments passed to createEnrichMap() function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObject a \code{list} created by \code{gprofiler2} that contains
#' the results from an enrichment analysis.
#' 
#' @param query a \code{character} string representing the name of the query 
#' that is going to be used to generate the graph. The query must exist in the 
#' \code{gostObject} object.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways. 
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains 
#' the term IDs retained for the creation of the network. This parameter is 
#' only used when \code{source} is set to "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). 
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing he amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. 
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(demoGOST)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapArguments(gostObject=demoGOST,
#'     query="query_1", source="GO:BP", termIDs=NULL, removeRoot=FALSE, 
#'     showCategory=20, groupCategory=FALSE, 
#'     categoryLabel=1.1, categoryNode=1, line=1.2)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapArguments <- function(gostObject, query, source, 
        termIDs, removeRoot, showCategory, groupCategory, 
        categoryLabel, categoryNode, line) {
    
    ## Test that gostObject is a gprofiler2 result 
    if (!(inherits(gostObject, "list") && "result" %in% names(gostObject) &&
            "meta" %in% names(gostObject)))   {
        stop("The gostObject object should be a list with meta ", 
                "and result as entries corresponding to gprofiler2 ", 
                "enrichment output.")
    } 
    
    if (!is.character(query) || length(query) > 1) {
        stop("The \'query\'must be a character string.")
    }
    
    ## Query must be in gost object
    gostResults <- as.data.frame(gostObject$result)
    if (!(query %in% unique(gostResults$query))) {
        stop("The \'query\' is not present in the results of the gost object.")
    }
    
    if (source != "TERM_ID") {
        if (sum(gostObject$result$source == source) < 1) {
            stop("There is no enriched term for the selected ", 
                    "source \'", source, "\'.")    
        }
    } else {
        if (is.null(termIDs)) {
            stop("A vector of terms should be given through the ",
                    "\'termIDs\' parameter when source is \'TERM_ID\'.")  
        }
        else {
            if(!all(termIDs %in% gostObject$result$term_id)) {
                stop("Not all listed terms are present in the  ",
                        "enrichment results.")
            }
        }
    }
    
    result <- validateCreateEnrichMapSubSectionArguments(
        showCategory=showCategory, groupCategory=groupCategory, 
        categoryLabel=categoryLabel, categoryNode=categoryNode, line=line)
    
    return(result)     
}

#' @title Validate arguments passed to createEnrichMapAsIgraph() function
#' 
#' @description Validate the arguments passed to createEnrichMapAsIgraph() 
#' function.First, the object containing the enrichment results must 
#' correspond to a 
#' object created by \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObject a \code{list} created by \code{gprofiler2} that contains
#' the results from an enrichment analysis.
#' 
#' @param query a \code{character} string representing the name of the query 
#' that is going to be used to generate the graph. The query must exist in the 
#' \code{gostObject} object.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways. 
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains 
#' the term IDs retained for the creation of the network. This parameter is 
#' only used when \code{source} is set to "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). 
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param similarityCutOff a positive \code{numeric} between 0 and 1 indicating 
#' the minimum level of similarity between two terms to have an edge linking 
#' the terms.
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(demoGOST)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapAsIgraphArg(
#'     gostObject=demoGOST, query="query_1", source="GO:BP", termIDs=NULL, 
#'     removeRoot=FALSE, showCategory=20, similarityCutOff=0.5)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapAsIgraphArg <- function(gostObject, query, source, 
        termIDs, removeRoot, showCategory, similarityCutOff) {
    
    ## Test that gostObject is a gprofiler2 result 
    if (!(inherits(gostObject, "list") && "result" %in% names(gostObject) &&
          "meta" %in% names(gostObject)))   {
        stop("The gostObject object should be a list with meta ", 
                "and result as entries corresponding to gprofiler2 ", 
                "enrichment output.")
    } 
    
    if (!is.character(query) || length(query) > 1) {
        stop("The \'query\' must be a character string.")
    }
    
    ## Query must be in gost object
    gostResults <- as.data.frame(gostObject$result)
    if (!(query %in% unique(gostResults$query))) {
        stop("The \'query\' is not present in the results of the gost object.")
    }
    
    if (source != "TERM_ID") {
        if (sum(gostObject$result$source == source) < 1) {
            stop("There is no enriched term for the selected ", 
                    "source \'", source, "\'.")    
        }
    } else {
        if (is.null(termIDs)) {
            stop("A vector of terms should be given through the ",
                    "\'termIDs\' parameter when source is \'TERM_ID\'.")  
        }
        else {
            if(!all(termIDs %in% gostObject$result$term_id)) {
                stop("Not all listed terms are present in the ",
                        "enrichment results.")
            }
        }
    }
    
    if (!is.logical(removeRoot)) {
        stop("The \'removeRoot\' parameter must a logical (TRUE or FALSE).")
    }
    
    if (!is.null(showCategory) && 
        !(is.numeric(showCategory) && (showCategory > 0))) {
        stop("The \'showCategory\' parameter must an positive integer or", 
                " NULL.")
    }
    
    if (!is.numeric(similarityCutOff) || (similarityCutOff <= 0.0) || 
        (similarityCutOff >= 1.0)) {
        stop("The \'similarityCutOff\' parameter must be a numeric superior",  
             " to zero and inferior to one.")
    }
    
    return(TRUE)     
}


#' @title Validate arguments passed to createEnrichMapMultiBasic() function
#' 
#' @description Validate the arguments passed to createEnrichMapMultiBasic() 
#' function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryList a \code{list} of \code{character} strings representing the 
#' names of the queries that are going to be used to generate the graph. 
#' The query names must exist in the associated \code{gostObjectList} objects 
#' and follow the same order. The number of entries must correspond to the 
#' number of entries for the \code{gostObjectList} parameter.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways. 
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains 
#' the term IDs retained for the creation of the network. This parameter is 
#' only used when \code{source} is set to "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). 
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing he amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. 
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiBasicArgs(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
#'     source="GO:BP", termIDs=NULL, removeRoot=FALSE, 
#'     showCategory=20, groupCategory=FALSE, 
#'     categoryLabel=1.1, categoryNode=1, line=1.2)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapMultiBasicArgs <- function(gostObjectList, queryList, 
    source, termIDs, removeRoot, showCategory, groupCategory, 
    categoryLabel, categoryNode, line) {
    
    ## Same subset of validations that for createEnrichMapMultiBasicAsIgraph()
    validateCreateEnrichMapMultiBasicGOSTArgs(gostObjectList=gostObjectList, 
        queryList=queryList, source=source, termIDs=termIDs, 
        removeRoot=removeRoot)

    result <- validateCreateEnrichMapSubSectionArguments(
        showCategory=showCategory, groupCategory=groupCategory, 
        categoryLabel=categoryLabel, categoryNode=categoryNode, line=line)
    
    return(result)   
}


#' @title Validate arguments passed to createEnrichMapMultiBasic() function
#' 
#' @description Validate the arguments passed to createEnrichMapMultiBasic() 
#' function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryList a \code{list} of \code{character} strings representing the 
#' names of the queries that are going to be used to generate the graph. 
#' The query names must exist in the associated \code{gostObjectList} objects 
#' and follow the same order. The number of entries must correspond to the 
#' number of entries for the \code{gostObjectList} parameter.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways. 
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains 
#' the term IDs retained for the creation of the network. This parameter is 
#' only used when \code{source} is set to "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). 
#' 
#' @param showCategory a positive \code{integer} representing the maximum 
#' number of terms to display.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms  
#' will be displayed. 
#'  
#' @param similarityCutOff a positive \code{numeric} between 0 and 1 indicating 
#' the minimum level of similarity between two terms to have an edge linking 
#' the terms.
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiBasicAsIgraphArgs(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
#'     source="GO:BP", termIDs=NULL, removeRoot=FALSE, 
#'     showCategory=20, similarityCutOff=0.3)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapMultiBasicAsIgraphArgs <- function(gostObjectList, 
    queryList, source, termIDs, removeRoot, showCategory, similarityCutOff) {
    
    ## Same subset of validations that for createEnrichMapMultiBasic()
    validateCreateEnrichMapMultiBasicGOSTArgs(gostObjectList=gostObjectList, 
        queryList=queryList, source=source, termIDs=termIDs, 
        removeRoot=removeRoot)
    
    if (!is.null(showCategory) && 
        !(is.numeric(showCategory) && (showCategory > 0))) {
        stop("The \'showCategory\' parameter must an positive integer or ", 
                "NULL.")
    }
    
    if (!is.numeric(similarityCutOff) || (similarityCutOff <= 0.0) || 
        (similarityCutOff >= 1.0)) {
        stop("The \'similarityCutOff\' parameter must be a numeric superior",  
                " to zero and inferior to one.")
    }
    
    return(TRUE)   
}


#' @title Validate arguments passed to createEnrichMapMultiBasic() function
#' 
#' @description Validate the arguments passed to createEnrichMapMultiBasic() 
#' function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryList a \code{list} of \code{character} strings representing the 
#' names of the queries that are going to be used to generate the graph. 
#' The query names must exist in the associated \code{gostObjectList} objects 
#' and follow the same order. The number of entries must correspond to the 
#' number of entries for the \code{gostObjectList} parameter.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways. 
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains 
#' the term IDs retained for the creation of the network. This parameter is 
#' only used when \code{source} is set to "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). 
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiBasicGOSTArgs(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
#'     source="GO:BP", termIDs=NULL, removeRoot=TRUE)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapMultiBasicGOSTArgs <- function(gostObjectList, 
    queryList, source, termIDs, removeRoot) {
    
    ## Test that gostObject is a list with minimum of 2 entries
    if (!inherits(gostObjectList, "list") || !(length(gostObjectList) > 1)) {
        stop("The gostObjectList object should be a list of enrichment", 
                " objects. At least 2 enrichment objects are required.")
    }
    
    ## Test that gostObject is a list of gprofiler2 result 
    if (!(all(unlist(lapply(gostObjectList, is.list))) && 
          all(unlist(lapply(gostObjectList, FUN = function(x) {
                "result" %in% names(x) && "meta" %in% names(x)})))))   {
        stop("The gostObjectList should only contain a list of enrichment ", 
                "results. Enrichment results are lists with meta ", 
                "and result as entries corresponding to gprofiler2 ", 
                "enrichment output.")
    } 
    
    ## Test that queryList is a list with 2 entries minimum
    if (!inherits(queryList, "list") || !(length(queryList) > 1) || 
        length(queryList) != length(gostObjectList)) {
        stop("The queryList object should be a list of query names. At least ", 
            "2 query names are required. The number of query names should", 
            " correspond to the number of enrichment objects.")
    }
    
    ## Test that queryList is a list of character strings
    if (!all(unlist(lapply(queryList, is.character)))) {
        stop("The queryList object should only contain a list of query names", 
                    " in character strings.")
    }
    
    ## Validate that all query names are present in the associated results
    if (!all(unlist(lapply(seq_len(length(queryList)), FUN = function(x, 
            queryL, gostL) {res <- as.data.frame(gostL[[x]]$result); 
            queryL[[x]] %in% unique(res$query)}, queryL=queryList, 
                           gostL=gostObjectList)))) {
        stop("Each query name present in the \'queryList'\ parameter ", 
                "must be present in the associated enrichment object.")
    }
    
    if (source != "TERM_ID") {
        if (!any(unlist(lapply(gostObjectList, FUN = function(x, source) {
                sum(x$result$source == source) > 1}, source=source)))) {
            stop("There is no enriched term for the selected ", 
                    "source \'", source, "\'.")    
        }
    } else {
        if (is.null(termIDs)) {
            stop("A vector of terms should be given through the ",
                    "\'termIDs\' parameter when source is \'TERM_ID\'.")
        }
    }
    
    ## Test that removeRoot should be logical
    if (!is.logical(removeRoot)) {
        stop("The \'removeRoot'\ should be a logical value (TRUE or FALSE).")
    }
    
    return(TRUE)   
}


#' @title Validate arguments passed to createEnrichMapMultiComplex() 
#' function
#' 
#' @description Validate the arguments passed to 
#' createEnrichMapMultiComplex() function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing he amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. 
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'     "rosa_napa_vs_DMSO"), source=c("KEGG", "WP"), removeRoot=c(TRUE, TRUE),
#'     termIDs=c("", ""), groupName=c("parental - KEGG", "rosa - WP"), 
#'     stringsAsFactors=FALSE)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiComplexArg(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryInfo=queryDataFrame,
#'     showCategory=20, groupCategory=FALSE, 
#'     categoryLabel=1.1, categoryNode=1, line=1.2)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
validateCreateEnrichMapMultiComplexArg <- function(gostObjectList, queryInfo, 
    showCategory, groupCategory, categoryLabel, categoryNode, line) {
    
    validateCreateEnrichMapMultiComplexGostPartOne(
        gostObjectList=gostObjectList, queryInfo=queryInfo)
    
    validateCreateEnrichMapMultiComplexGostPartTwo(
        gostObjectList=gostObjectList, queryInfo=queryInfo)
    
    result <- validateCreateEnrichMapSubSectionArguments(
        showCategory=showCategory, groupCategory=groupCategory, 
        categoryLabel=categoryLabel, categoryNode=categoryNode, line=line)
    
    return(result)   
}

#' @title Validate arguments passed to validateCreateEnrichMapMultiComplex() 
#' function
#' 
#' @description Validate the arguments passed to 
#' validateCreateEnrichMapMultiComplex() function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @param showCategory a positive \code{integer} or \code{NULL}. 
#' If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms will be 
#' displayed. 
#' 
#' @param similarityCutOff a positive \code{numeric}, larger than zero and
#' small than 1 that represent the minimum similarity level between two 
#' nodes (terms) to be linked by an edge.
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'     "rosa_napa_vs_DMSO"), source=c("KEGG", "WP"), removeRoot=c(TRUE, TRUE),
#'     termIDs=c("", ""), groupName=c("parental - KEGG", "rosa - WP"), 
#'     stringsAsFactors=FALSE)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiComplexAsIgraphArg(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryInfo=queryDataFrame, showCategory=20, similarityCutOff=0.2)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
validateCreateEnrichMapMultiComplexAsIgraphArg <- function(gostObjectList, 
        queryInfo, showCategory, similarityCutOff=similarityCutOff) {
    
    validateCreateEnrichMapMultiComplexGostPartOne(
        gostObjectList=gostObjectList, queryInfo=queryInfo)
    
    validateCreateEnrichMapMultiComplexGostPartTwo(
        gostObjectList=gostObjectList, queryInfo=queryInfo)
    
    if (!is.null(showCategory) && 
        !(is.numeric(showCategory) && (showCategory > 0))) {
        stop("The \'showCategory\' parameter must an positive integer or ", 
                "NULL.")
    }
    
    if (!is.numeric(similarityCutOff) || (similarityCutOff <= 0.0) || 
            (similarityCutOff >= 1.0)) {
        stop("The \'similarityCutOff\' parameter must be a numeric superior",  
                " to zero and inferior to one.")
    }
    
    return(TRUE)   
}


#' @title Validate arguments related to GOST passed to 
#' validateCreateEnrichMapMultiComplexArg() function
#' 
#' @description Validate the arguments passed to 
#' validateCreateEnrichMapMultiComplexArg() function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'     "rosa_napa_vs_DMSO"), source=c("KEGG", "WP"), removeRoot=c(TRUE, TRUE),
#'     termIDs=c("", ""), groupName=c("parental - KEGG", "rosa - WP"), 
#'     stringsAsFactors=FALSE)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiComplexGostPartOne(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryInfo=queryDataFrame)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapMultiComplexGostPartOne <- function(gostObjectList, 
    queryInfo) {
    
    ## Test that gostObject is a list with minimum of 2 entries
    if (!inherits(gostObjectList, "list") || !(length(gostObjectList) > 1)) {
        stop("The gostObjectList object should be a list of enrichment", 
                " objects. At least 2 enrichment objects are required.")
    }
    
    ## Test that gostObject is a list of gprofiler2 result 
    if (!(all(unlist(lapply(gostObjectList, is.list))) && 
          all(unlist(lapply(gostObjectList, FUN = function(x) {
                "result" %in% names(x) && "meta" %in% names(x)})))))   {
        stop("The gostObjectList should only contain a list of enrichment ", 
                "results. Enrichment results are lists with meta ", 
                "and result as entries corresponding to gprofiler2 ", 
                "enrichment output.")
    } 
    
    ## Test that queryInfo is a data.frame
    if (!inherits(queryInfo, "data.frame") || !(all(c("queryName", "source", 
            "removeRoot", "termIDs") %in% colnames(queryInfo)))) {
        stop("The queryInfo should a data.frame with those columns: ", 
                "queryName, source, removeRoot and termIDs.")
    }
    
    ## Test that queryInfo has the same number of entries than gostObjectList
    if (nrow(queryInfo) != length(gostObjectList)) {
        stop("The number of rows in queryInfo should ", 
                "correspond to the number of enrichment objects.")
    }
    
    ## Test that source should be character string
    if (!is.character(queryInfo$source)) {
        stop("The \'source'\ column of the \'queryInfo\' data frame ", 
                "should be in a character string format.")
    }
    
    return(TRUE)   
}


#' @title Validate arguments related to GOST passed to 
#' validateCreateEnrichMapMultiComplexArg() function
#' 
#' @description Validate the arguments passed to 
#' validateCreateEnrichMapMultiComplexArg() function.
#' First, the object containing the enrichment results must correspond to a 
#' object created by  \code{gprofiler2} software. Second, the selected 
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'     "rosa_napa_vs_DMSO"), source=c("KEGG", "WP"), removeRoot=c(TRUE, TRUE),
#'     termIDs=c("", ""), groupName=c("parental - KEGG", "rosa - WP"), 
#'     stringsAsFactors=FALSE)
#' 
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapMultiComplexGostPartTwo(
#'     gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'                             rosaNapaVsDMSOEnrichment),
#'     queryInfo=queryDataFrame)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapMultiComplexGostPartTwo <- function(gostObjectList, 
                queryInfo) {
    
    ## Test that the source values are valid choices in queryInfo data frame
    sources <- c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", 
                    "MIRNA", "HPA", "CORUM", "HP", "WP")
    if (!all(unlist(lapply(seq_len(nrow(queryInfo)), FUN=function(x, queryI, 
                sourcesL){ queryI$source[x] %in% sourcesL}, 
                            queryI=queryInfo, sourcesL=sources)))) {
        stop("The values in the \'source\' column of the \'queryInfo\' ", 
                "data frame should be one of those: \"TERM_ID\", \"GO:MF\", ", 
                "\"GO:CC\", \"GO:BP\", \"KEGG\", \"REAC\", \"TF\", ",
                "\"MIRNA\", \"HPA\", \"CORUM\", \"HP\", \"WP\".")
    }
    
    ## Test that queryName should be character string
    if (!is.character(queryInfo$queryName)) {
        stop("The \'queryName'\ column of the \'queryInfo\' data frame ", 
             "should be in a character string format.")
    }
    
    ## Test that source should be character string
    if (!is.character(queryInfo$termIDs)) {
        stop("The \'termIDs'\ column of the \'queryInfo\' data frame ", 
                "should be in a character string format.")
    }
    
    ## Test that removeRoot should be logical
    if (!is.logical(queryInfo$removeRoot)) {
        stop("The \'removeRoot'\ column of the \'queryInfo\' data frame ", 
                "should only contain logical values (TRUE or FALSE).")
    }
    
    ## Test that the query names are present in the associated enrichment
    if (!all(unlist(lapply(seq_len(nrow(queryInfo)), FUN = function(x, queryI, 
                gostL) {res <- as.data.frame(gostL[[x]]$result); 
                            queryI$queryName[x] %in% unique(res$query)}, 
                            queryI=queryInfo, gostL=gostObjectList)))) {
        stop("Each query name present in the \'queryName'\ column of the ", 
                "\'queryInfo\' data frame must be present in the ", 
                "associated enrichment object.")
    }
    
    if (length(which(queryInfo$source == "TERM_ID"))) {
        if(!all(unlist(lapply(which(queryInfo$source == "TERM_ID"), 
                FUN=function(i, queryI) {queryI$termIDs[i] != ""}, 
                                queryI=queryInfo)))) {
            stop("A string of terms should be present in the ",
                     "\'termIDs\' column when source is \'TERM_ID\'.")
        }
    }
    
    if (!is.character(queryInfo$groupName)) {
        stop("The \'groupName'\ column of the \'queryInfo\' data frame ", 
                "should be in a character string format.")
    }
    
    if (any(table(queryInfo$groupName) > 1)) {
        stop("The \'groupName'\ column of the \'queryInfo\' data frame ", 
                "should only contain unique group names.")
    }
    
    return(TRUE)   
}


#' @title Validate common arguments passed to createEnrichMap() and 
#' createEnrichMapMultiBasic() functions
#' 
#' @description Validate the common arguments passed to createEnrichMap() and 
#' createEnrichMapMultiBasic() functions.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing he amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. 
#' 
#' @return \code{TRUE} when all arguments are valid
#' 
#' @examples
#'
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateEnrichMapSubSectionArguments(
#'     showCategory=20, groupCategory=FALSE, categoryLabel=1.1, categoryNode=1, 
#'     line=0.5)
#' 
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @keywords internal
validateCreateEnrichMapSubSectionArguments <- function(showCategory, 
    groupCategory, categoryLabel, categoryNode, line) {
    
    if (!is.character(showCategory) && 
        !(is.numeric(showCategory) && (showCategory > 0))) {
        stop("The \'showCategory\' parameter must an positive integer or a ", 
            "vector of character strings representing terms.")
    }

    if (!is.logical(groupCategory)) {
        stop("The \'groupCategory\' parameter must a logical ", 
            "(TRUE or FALSE).")
    }

    if (!is.numeric(categoryLabel) || !(categoryLabel > 0)) {
        stop("The \'categoryLabel\' parameter must be a positive numeric.")
    }

    if (!is.numeric(categoryNode) || !(categoryNode > 0)) {
        stop("The \'categoryNode\' parameter must be a positive numeric.")
    }

    if (!is.numeric(line) || !(line > 0)) {
        stop("The \'line\' parameter must be a positive numeric.")
    }
    
    return(TRUE)   
}


#' @title Create a basic enrichment map
#' 
#' @description The function creates a basic enrichment map using functional 
#' enrichment results.
#' 
#' @param gostResults a \code{data.frame} containing the enrichment 
#' results to be plot.
#' 
#' @param backgroundGenes a \code{vector} of \code{character} string 
#' representing the name of the genes present in the request.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing the amount by 
#' which plotting category nodes should be scaled relative to the default (1). 
#' 
#' @param significantMethod a \code{character} string representing the name 
#' of the multiple testing correction method used on the results.
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. 
#' 
#' @param ... additional arguments that will be pass to the 
#' \code{\link[enrichplot]{emapplot}} function. 
#'
#' @return a \code{ggplot} object representing the enrichment map.
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Only retain the results section
#' gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
#' 
#' ## Limit the results to Wikipathways
#' ## and remove the root term
#' gostResults <- gostResults[which(gostResults$source == "WP"),]
#' gostResults <- gostResults[which(gostResults$term_name != "WIKIPATHWAYS"),]
#' 
#' ## Extract meta data information
#' meta <- parentalNapaVsDMSOEnrichment$meta
#' 
#' ## Get all background genes
#' backgroundGenes <- meta$query_metadata$queries[["parental_napa_vs_DMSO"]]
#' 
#' ## Get significant method
#' significantMethod <- meta$query_metadata$significance_threshold_method
#'
#' ## Create basic enrichment map using Wikipathways terms
#' enrichViewNet:::createBasicEmap(gostResults=gostResults, 
#'     backgroundGenes=backgroundGenes, showCategory=30L, 
#'     groupCategory=FALSE, categoryLabel=1, categoryNode=1,
#'     significantMethod=significantMethod, line=1)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is new
#' @importFrom stringr str_ends str_split str_replace_all
#' @importFrom enrichplot pairwise_termsim emapplot
#' @importClassesFrom DOSE enrichResult
#' @keywords internal
createBasicEmap <- function(gostResults, backgroundGenes, 
        showCategory, groupCategory, categoryLabel, categoryNode, 
        significantMethod, line, ...) {
    
    ## Extract gene list for each term
    geneSets <- lapply(seq_len(nrow(gostResults)), FUN=function(x, gostData) {
        str_split(gostData$intersection[x], pattern=",")[[1]]}, 
        gostData=gostResults
    )
    names(geneSets) <- gostResults$term_id
    
    resultDF <- data.frame(ID=gostResults$term_id, 
        Description=gostResults$term_name,
        GeneRatio=c(paste0(gostResults$intersection_size, "/", 
                                gostResults$query_size)), 
        BgRatio=c(paste0(gostResults$intersection_size, "/", 
                                gostResults$effective_domain_size)), 
        pvalues=gostResults$p_value,
        p.adjust=gostResults$p_value, 
        qvalue=gostResults$p_value, 
        geneID=str_replace_all(gostResults$intersection, ",", "/"),
        Count=c(gostResults$intersection_size), stringsAsFactors=FALSE)
    
    resultDF <- resultDF[order(resultDF$pvalues), ]
    
    ## Problem when identical description 
    if (any(table(resultDF$Description) > 1)) {
        resultDF <- manageNameDuplicationInEmap(clProfDF=resultDF)
    }
    
    rownames(resultDF) <- resultDF$ID
    
    res <- new("enrichResult", result=resultDF, pvalueCutoff=1, 
                pAdjustMethod="UNKNOWN", qvalueCutoff=1, 
                gene=as.character(backgroundGenes), 
                universe=as.character(backgroundGenes), 
                geneSets=geneSets, 
                organism="UNKNOWN", keytype="UNKNOWN", ontology="UNKNOWN", 
                readable=FALSE)
    
    ## Get similarity matrix
    comp <- pairwise_termsim(res)  
    
    graphEmap <- emapplot(x=comp, showCategory=showCategory,
        group=groupCategory, size_category=categoryNode, size_edge=line,  ...)
    
    return(graphEmap)
}



#' @title Create a basic enrichment map
#' 
#' @description The function creates a basic enrichment map using functional 
#' enrichment results.
#' 
#' @param gostResults a \code{data.frame} containing the enrichment 
#' results to be plot.
#' 
#' @param backgroundGenes a \code{vector} of \code{character} string 
#' representing the name of the genes present in the request.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param similarityCutOff a positive \code{numeric} between 0 and 1 indicating 
#' the minimum level of similarity between two terms to have an edge linking 
#' the terms.  
#' 
#' @return a \code{igraph} object representing the enrichment map.
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Only retain the results section
#' gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
#' 
#' ## Limit the results to Wikipathways
#' ## and remove the root term
#' gostResults <- gostResults[which(gostResults$source == "WP"),]
#' gostResults <- gostResults[which(gostResults$term_name != "WIKIPATHWAYS"),]
#' 
#' ## Extract meta data information
#' meta <- parentalNapaVsDMSOEnrichment$meta
#' 
#' ## Get all background genes
#' backgroundGenes <- meta$query_metadata$queries[["parental_napa_vs_DMSO"]]
#'
#' ## Create basic enrichment map, as an igraph, using Wikipathways terms
#' enrichViewNet:::createBasicEmapAsIgraph(gostResults=gostResults, 
#'     backgroundGenes=backgroundGenes, showCategory=30L, 
#'     similarityCutOff=0.2)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is new
#' @importFrom stringr str_ends str_split str_replace_all
#' @importFrom igraph make_empty_graph V add_vertices E add_edges E<- delete_edges
#' @importFrom reshape2 melt
#' @importClassesFrom DOSE enrichResult
#' @keywords internal
createBasicEmapAsIgraph <- function(gostResults, backgroundGenes, 
        showCategory, similarityCutOff) {
    
    ## Extract gene list for each term
    geneSets <- lapply(seq_len(nrow(gostResults)), FUN=function(x, gostData) {
                    str_split(gostData$intersection[x], pattern=",")[[1]]}, 
                    gostData=gostResults)
    names(geneSets) <- gostResults$term_id
    
    resultDF <- data.frame(ID=gostResults$term_id, 
                Description=gostResults$term_name,
                GeneRatio=c(paste0(gostResults$intersection_size, "/", 
                                            gostResults$query_size)), 
                BgRatio=c(paste0(gostResults$intersection_size, "/", 
                                            gostResults$effective_domain_size)), 
                pvalues=gostResults$p_value, 
                p.adjust=gostResults$p_value, 
                geneID=str_replace_all(gostResults$intersection, ",", "/"),
                Count=c(gostResults$intersection_size), stringsAsFactors=FALSE)
    
    resultDF <- resultDF[order(resultDF$pvalues, decreasing=FALSE), ]
    
    ## Select top category to show
    if (is.numeric(showCategory)) {
        if (nrow(resultDF) > showCategory) {
            resultDF <- resultDF[seq_len(showCategory), ]
        }
    }
    
    ## Problem when identical description 
    if (any(table(resultDF$Description) > 1)) {
        resultDF <- manageNameDuplicationInEmap(clProfDF=resultDF)
    }
    
    rownames(resultDF) <- resultDF$ID
    
    if (nrow(resultDF) == 1) {
        ## Create igraph with 1 entry
        g <- make_empty_graph(0, directed=FALSE)
        g <- add_vertices(g, nv=1)
        V(g)$name <- as.character(resultDF$Description)
        V(g)$size <- resultDF$Count
    } else {
        ## Create igraph with multiple entries
        
        ## Get similarity matrix 
        res <- similarityJaccard(resultDF=resultDF)
        
        ## Generated data frame with similarity information
        simData <- melt(res[as.character(resultDF$Description), 
                    as.character(resultDF$Description)], na.rm=TRUE, 
                    value.name="similarity")
        simData <- simData[which(simData[,1] != simData[,2]), ]
        simData <- simData[which(simData$similarity > 0), ]
        
        ## Each unique name will be a node
        g <- make_empty_graph(n=0, directed=FALSE)
        attrs <- list(name=resultDF$Description, 
                      size=resultDF$Count)
        g <- add_vertices(g, length(attrs$name), attr=attrs)
        
        ## Create links between nodes
        fromN <- as.character(simData[, 1])
        toN <- as.character(simData[, 2])
        edges <- rbind(match(fromN, attrs$name), match(toN, attrs$name))
        
        ## Add attributes (including similarity values) to the edges
        attrsE <- list()
        attrsE[["similarity"]] <- simData$similarity
        attrsE[["width"]] <- simData$similarity
        attrsE[["weight"]] <- simData$similarity
        g <- add_edges(g, edges, attr=attrsE)
        
        ## Remove edges with similarity lower than cut off
        g <- delete_edges(g, E(g)[simData$similarity < similarityCutOff])
    }
    return(g)
}

#' @title Create a basic enrichment map
#' 
#' @description The function creates a basic enrichment map using functional 
#' enrichment results.
#' 
#' @param gostResultsList a \code{list} of \code{data.frame} containing 
#' the enrichment results to be plot with different group identification.
#' 
#' @param queryList a \code{list} of \code{character} string 
#' representing the name of query retained for each enrichment results present 
#' in the \code{gostResultsList} parameter. The query should be present in its 
#' associated enrichment results.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1).
#' 
#' @param categoryNode a positive \code{numeric} representing the amount by 
#' which plotting category nodes should be scaled relative to the default (1). 
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width.
#' 
#' @param ... additional arguments that will be pass to the 
#' \code{\link[enrichplot]{emapplot}} function. 
#'
#' @return a \code{ggplot} object representing the enrichment map with 
#' different colors for each group of enrichment results.
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Only retain the results section
#' gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
#' 
#' ## Limit the results subsection of REACTOME and KEGG
#' gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
#' gostResultsREAC <- gostResultsREAC[1:13, ]
#' gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]
#' 
#' ## Extract meta data information
#' queryList <- list("parental - REACTOME", "parental - KEGG")
#' 
#' ## Create basic enrichment map using Wikipathways terms
#' enrichViewNet:::createMultiEmap(gostResultsList=list(gostResultsREAC, 
#'     gostResultsKEGG), queryList=queryList, showCategory=30L, 
#'     groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1.4)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is new
#' @importFrom stringr str_split str_replace_all
#' @importFrom enrichplot pairwise_termsim emapplot
#' @importClassesFrom DOSE compareClusterResult
#' @keywords internal
createMultiEmap <- function(gostResultsList, queryList, showCategory, 
    groupCategory, categoryLabel, categoryNode, line,  ...) {
    
    resF <- list()
    geneClusters <- list()
    
    ## Rename query names when duplicated names
    queryList <- manageQueryDuplicationInEmap(queryList=queryList)
    
    for(i in seq_len(length(gostResultsList))) {
        gostResults <- gostResultsList[[i]]
        resultDF <- data.frame(
            Cluster=rep(queryList[[i]], nrow(gostResults)),
            ID=gostResults$term_id,
            Description=gostResults$term_name,
            GeneRatio=c(paste0(gostResults$intersection_size, "/", 
                                gostResults$query_size)), 
            BgRatio=c(paste0(gostResults$intersection_size, "/", 
                                gostResults$effective_domain_size)), 
            pvalues=gostResults$p_value,
            p.adjust=gostResults$p_value, qvalue=gostResults$p_value, 
            geneID=str_replace_all(gostResults$intersection, ",", "/"),
            Count=c(gostResults$intersection_size), stringsAsFactors=FALSE)
        resF[[i]] <- resultDF
        
        geneClusters[[queryList[[i]]]] <- 
            unique(unlist(str_split(gostResults$intersection, ",")))
    }
    clProfDF <- do.call(rbind, resF)
    
    clProfDF$Cluster  <- factor(clProfDF$Cluster)
    clProfDF$geneID <- str_replace_all(string = clProfDF$geneID,
                                                pattern = ",", "/") 
    
    ## Problem when identical description 
    if (any(table(clProfDF$Description) > 1)) {
        clProfDF <- manageNameDuplicationInEmap(clProfDF=clProfDF)
    }
    
    res <- new("compareClusterResult",
                compareClusterResult = clProfDF,
                geneClusters = geneClusters,
                fun = "createMultiEmap",
                .call = call("createMultiEmap()")
    )
    res@keytype <- "UNKNOWN"
    res@readable <- FALSE
    
    compar <- pairwise_termsim(res)  
    
    graphEmap <- emapplot(compar, showCategory=showCategory, 
        group=groupCategory, size_category=categoryNode, size_edge=line, ...)
    
    return(graphEmap)
}


#' @title Create a complex enrichment map as an igraph
#' 
#' @description The function creates a complex enrichment map, as an igraph, 
#' using functional enrichment results.
#' 
#' @param gostResultsList a \code{list} of \code{data.frame} containing 
#' the enrichment results to be plot with different group identification.
#' 
#' @param queryList a \code{list} of \code{character} string 
#' representing the name of query retained for each enrichment results present 
#' in the \code{gostResultsList} parameter. The query should be present in its 
#' associated enrichment results.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, 
#' all terms will be displayed.
#' 
#' @param similarityCutOff a positive \code{numeric}, larger than zero and
#' small than 1 that represent the minimum similarity level between two 
#' nodes (terms) to be linked by an edge. 
#' 
#' @return a \code{igraph} object representing the enrichment map with 
#' different colors for each group of enrichment results.
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Only retain the results section
#' gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
#' 
#' ## Limit the results subsection of REACTOME and KEGG
#' ## Kegg is replicated to show shared results between queries
#' gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
#' gostResultsREAC <- gostResultsREAC[1:13, ]
#' gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]
#' gostResultsKEGG2 <- gostResultsKEGG[1:6,]
#' 
#' ## Extract meta data information
#' queryList <- list("parental - REACTOME", "parental - KEGG - v1", 
#'     "parental - KEGG - v2")
#' 
#' ## Create basic enrichment map using Wikipathways terms
#' igraph <- enrichViewNet:::createMultiEmapAsIgraph(
#'     gostResultsList=list(gostResultsREAC, gostResultsKEGG, 
#'             gostResultsKEGG2), 
#'     queryList=queryList, showCategory=30L, similarityCutOff=0.5)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom stringr str_replace_all
#' @importFrom igraph delete_edges V E add_edges V<-
#' @importFrom reshape2 melt
#' @keywords internal
createMultiEmapAsIgraph <- function(gostResultsList, queryList, showCategory, 
                similarityCutOff) {
    
    result <- createCompareResultDataFrame(queryList=queryList, 
                                    gostResultsList=gostResultsList)
    
    ## Limit the number of categories if specified by user
    ## Keep best results with best p-values
    if (!is.null(showCategory)) {
        tmp <- list()
        for (i in unique(as.character(result$Cluster))) {
            resTmp <- result[which(result$Cluster == i), ]
            if (nrow(resTmp) > showCategory) {
                resTmp <- resTmp[order(resTmp$pvalues, decreasing=FALSE), ]
                resTmp <- resTmp[seq_len(showCategory), ]
            }
            tmp[[length(tmp) + 1]] <- resTmp
        }
        result <- do.call(rbind, tmp)
    }
    ## Ensure no result with count to zero
    result <- result[which(as.numeric(result$Count) > 0), ]

    ## Transform description into factors
    result$Description <- as.character(result$Description)

    ## Manage when there are terms present in more than one cluster
    ## Count should include all unique genes 
    resultDF <- result[!duplicated(result$ID), ]
    for (i in seq_len(nrow(resultDF))) {
        tmpRes <- result[which(result$ID == resultDF$ID[i]), ]
        if (nrow(tmpRes) > 1) {
            uniqueGenes <- unique(unlist(strsplit(tmpRes$geneID, "/")))
            resultDF$geneID[i] <- paste0(uniqueGenes, collapse = "/")
            resultDF$Count[i] <- length(uniqueGenes)
        }
    }
    resultDF$Cluster <- NULL
        
    if (nrow(resultDF) == 1) {
        ## Create igraph with 1 entry
        g <- make_empty_graph(0, directed=FALSE)
        g <- add_vertices(g, nv=1)
        V(g)$name <- as.character(resultDF$Description)
        V(g)$size <- resultDF$Count
    } else {
        ## Create igraph with multiple entries
        
        ## Each unique name will be a node
        g <- make_empty_graph(n=0, directed=FALSE)
        vertex.pie <- list()
        vertex.pieName <- list()
        vertex.cluster <- list()
        for (i in seq_len(nrow(resultDF))) {
            e <- result[result$ID== resultDF$ID[i], ]
            vertex.pie[[length(vertex.pie) + 1]] <- 
                    as.integer(unlist(queryList) %in% e$Cluster)
            vertex.pieName[[length(vertex.pieName) + 1]] <-  unlist(queryList)
            vertex.cluster[[length(vertex.cluster) + 1]] <- 
                    as.character(e$Cluster)
        }
        
        attrs <- list(name=resultDF$Description, size=resultDF$Count, 
                        pie=vertex.pie, cluster=vertex.cluster, 
                        pieName=vertex.pieName)
        g <- add_vertices(g, length(attrs$name), attr=attrs)
        
        ## Get similarity matrix 
        res <- similarityJaccard(resultDF=resultDF)
        
        ## Generated data frame with similarity information
        ## Similarity of zero should be removed
        simData <- melt(res[as.character(resultDF$Description), 
                        as.character(resultDF$Description)], na.rm=TRUE, 
                        value.name="similarity")
        simData <- simData[which(simData[,1] != simData[,2]), ]
        simData <- simData[which(simData$similarity > 0), ]
            
        ## Create links between nodes
        fromNode <- as.character(simData[, 1])
        toNode <- as.character(simData[, 2])
        edges <- rbind(match(fromNode, attrs$name), match(toNode, attrs$name))
            
        ## Add attributes (including similarity values) to the edges
        attrsE <- list()
        attrsE[["similarity"]] <- simData$similarity
        attrsE[["width"]] <- simData$similarity
        attrsE[["weight"]] <- simData$similarity
        g <- add_edges(g, edges, attr=attrsE)
            
        ## Remove edges with similarity lower than cut off
        g <- delete_edges(g, E(g)[simData$similarity < similarityCutOff])
    }
    
    return(g)   
}


#' @title Calculate the Jaccard similarity coefficient for the terms present
#' in a data frame
#' 
#' @description The function calculates the Jaccard similarity coefficient for 
#' the enriched terms present i a data frame.  
#' 
#' @param resultDF a \code{data.frame} containing the enrichment 
#' terms that are going to be graphed as an enrichment map. The 
#' \code{data.frame} must contain the \code{geneID} and \code{Description} 
#' columns.
#' 
#' @return a \code{matrix} with the lower triangle section containing the 
#' Jaccard similarity coefficients as \code{numeric}. The upper triangle 
#' section is filled with \code{NA} as well as the diagonal. 
#' 
#' @examples
#'
#' ## Data frame with the enriched terms
#' resultData <- data.frame( 
#'     ID=c("REAC:R-HSA-9031628", "REAC:R-HSA-9648895", "REAC:R-HSA-9614085",
#'             "REAC:R-HSA-166520"),
#'     Description=c("NGF-stimulated transcription", 
#'             "Response of EIF2AK1 (HRI) to heme deficiency",
#'             "FOXO-mediated transcription", "Signaling by NTRKs"),
#'     geneID=c(paste0("ENSG00000120738/ENSG00000122877/ENSG00000125740/",
#'         "ENSG00000135625/ENSG00000170345/ENSG00000171223/ENSG00000173334/", 
#'         "ENSG00000179388/ENSG0000019857"),
#'         paste0("ENSG00000087074/ENSG00000128272/ENSG00000128965/", 
#'         "ENSG00000162772/ENSG00000172216/ENSG00000175197"),
#'         paste0("ENSG00000105327/ENSG00000113916/ENSG00000124762/", 
#'         "ENSG00000133639/ENSG00000136826/ENSG00000153094/ENSG00000175197"),
#'         paste0("ENSG00000105327/ENSG00000113916/ENSG00000124762/", 
#'         "ENSG00000133639/ENSG00000136826/ENSG00000153094/ENSG0000017519/",
#'         "ENSG00000120738/ENSG00000122877/ENSG00000125740/ENSG00000135625/",
#'         "ENSG00000170345/ENSG00000171223/ENSG00000173334/ENSG00000179388/", 
#'         "ENSG00000198576")))
#' 
#' ## Calculate the Jaccard similarity coefficient for all pairwise 
#' ## term combination
#' enrichViewNet:::similarityJaccard(resultDF=resultData)
#'     
#' @author Astrid Deschênes
#' @importFrom stringr str_split
#' @encoding UTF-8
#' @keywords internal
similarityJaccard <- function(resultDF) {
    res <- matrix(data=NA, nrow=nrow(resultDF), ncol=nrow(resultDF))
    for(i in seq_len(nrow(resultDF))) {
        tempI <- unique(unlist(str_split(resultDF$geneID[i], "/")))
        for(j in seq_len(i)) {
            if (i == j) break
            tempJ <- unique(unlist(str_split(resultDF$geneID[j], "/")))
            all <- c(tempI, tempJ)
            all <- all[which(all != "")]
            if (length(all) < 1) {
                res[i, j] <- 0
            } else {
                res[i, j] <- sum(table(all) > 1)/length(unique(all))
            }
        }
    }
    colnames(res) <- as.character(resultDF$Description)
    rownames(res) <- as.character(resultDF$Description)
    return(res)
}


#' @title Change name description in data frame when more than one term as 
#' the same name
#' 
#' @description The function adds the ID of the term at the name of the name 
#' description when terms with different ID share the same name. For example, 
#' "MAPK pathway" would become "MAPK pathway (KEGG:04010)". 
#' 
#' @param clProfDF a \code{data.frame} containing the enrichment 
#' terms that are going to be graphed as an enrichment map. The 
#' \code{data.frame} must contain at least one case of duplicated name 
#' descriptions for different term IDs.
#' 
#' @return a \code{data.frame} with the name descriptions modified for terms 
#' with duplicated name descriptions but different term IDs.
#' 
#' @examples
#'
#' ## Data frame with duplicated name descriptions for different IDs
#' clustData <- data.frame(Cluster=c("group 1" , "group 1", "group 2"), 
#'     ID=c("WP:WP4925", "WP:WP382", "KEGG:04010"),
#'     Description=c("Unfolded protein response", 
#'                     rep("MAPK signaling pathway", 2)),
#'     GeneRatio=c("4/157", "3/157", "3/157"),
#'     BgRatio=c("4/24022", "3/24022", "3/24022"),
#'     pvalues=c(1.55e-4, 8.13e-8, 4.33e-5),
#'     p.adjust=c(1e-3, 1e-3, 1.4e-3), qvalue=c(1e-3, 1e-3, 1.4e-3), 
#'     geneID=c("ENSG000107968/ENSG000120129/ENSG000123358/ENSG000158050",
#'         "ENSG000107968/ENSG000120129/ENSG000158050",
#'         "ENSG000107968/ENSG000120129/ENSG000158050"),
#'     Count=c(4, 3, 3))
#' 
#' ## Change the name descriptions for the duplicated terms
#' enrichViewNet:::manageNameDuplicationInEmap(clProfDF=clustData)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
manageNameDuplicationInEmap <- function(clProfDF) {
    
    ## Problem when identical description 
    test <- which(table(clProfDF$Description) > 1)
    for (i in names(test)) {
        resTest <- clProfDF[clProfDF$Description == i, ]
        if (length(unique(resTest$ID)) != 1) {
            clProfDF$Description[clProfDF$Description == i] <- 
                paste0(clProfDF$Description[clProfDF$Description == i], 
                        " (", clProfDF$ID[clProfDF$Description == i], ")")   
        }
    }
    
    return(clProfDF)
}


#' @title Create a data frame containing the compiled enrichment results from
#' multiple queries
#' 
#' @description The function creates a data frame object using the
#' list of queries and list of enrichment results given be the user.
#' 
#' @param gostResultsList a \code{list} of \code{data.frame} containing 
#' the enrichment results to be plot with different group identification.
#' 
#' @param queryList a \code{list} containing the query names.
#' 
#' @return a \code{data.frame} object
#' 
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Only retain the results section
#' gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
#' 
#' ## Limit the results subsection of REACTOME and KEGG
#' ## Kegg is replicated to show shared results between queries
#' gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
#' gostResultsREAC <- gostResultsREAC[1:13, ]
#' gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]
#' gostResultsKEGG2 <- gostResultsKEGG[1:6,]
#' 
#' ## List of query names with duplicated names
#' queryList <- list("parental_vs_DMSO", "rosa_vs_DMSO", "parental_vs_DMSO", 
#'     "rosa_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO")
#'     
#' ## Extract meta data information
#' queryList <- list("parental - REACTOME", "parental - KEGG - v1", 
#'     "parental - KEGG - v2")
#' 
#' ## Change the query names for the duplicated names
#' enrichViewNet:::createCompareResultDataFrame(queryList=queryList,
#'     gostResultsList=list(gostResultsREAC, gostResultsKEGG, 
#'             gostResultsKEGG2))
#'     
#' @author Astrid Deschênes
#' @importFrom stringr str_replace_all str_split
#' @encoding UTF-8
#' @keywords internal
createCompareResultDataFrame <- function(queryList, gostResultsList) {
    
    resF <- list()
    geneClusters <- list()
    
    for(i in seq_len(length(gostResultsList))) {
        gostResults <- gostResultsList[[i]]
        resultDF <- data.frame(
            Cluster=rep(queryList[[i]], nrow(gostResults)),
            ID=gostResults$term_id,
            Description=as.character(gostResults$term_name), 
            pvalues=as.numeric(gostResults$p_value),
            geneID=str_replace_all(gostResults$intersection, ",", "/"),
            Count=c(as.numeric(gostResults$intersection_size)), 
            stringsAsFactors=FALSE)
        resF[[i]] <- resultDF
        
        geneClusters[[queryList[[i]]]] <- 
            unique(unlist(str_split(gostResults$intersection, ",")))
    }
    allDF <- do.call(rbind, resF)
    
    allDF$Cluster  <- factor(allDF$Cluster)
    allDF$geneID <- str_replace_all(string=allDF$geneID, pattern=",", "/") 
    
    ## Problem when identical description (ID added to description)
    if (any(table(allDF$Description) > 1)) {
        allDF <- manageNameDuplicationInEmap(clProfDF=allDF)
    }
    
    return(allDF)
}

#' @title Change query name when more than one queries have  
#' the same name
#' 
#' @description The function adds an unique ID at the name of the query when 
#' more than one query have the same name.
#' 
#' @param queryList a \code{list} containing the query names.
#' 
#' @return a \code{list} with the query names modified for queries   
#' with duplicated names.
#' 
#' @examples
#'
#' ## List of query names with duplicated names
#' queryList <- list("parental_vs_DMSO", "rosa_vs_DMSO", "parental_vs_DMSO", 
#'     "rosa_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO")
#' 
#' ## Change the query names for the duplicated names
#' enrichViewNet:::manageQueryDuplicationInEmap(queryList=queryList)
#'     
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
manageQueryDuplicationInEmap <- function(queryList) {
    
    ## Problem when identical query names
    test <- which(table(unlist(queryList)) > 1)
    if (length(test) > 0) {
        for (i in names(test)) {
            pos <- which(queryList == i)
            id <- 1
            for (j in pos) {
                queryList[[j]] <- paste0(queryList[[j]], " (", id, ")")
                id <- id + 1
            }
        }
    }
    
    return(queryList)
}

### Unit tests for methodsEmapInternal.R functions

library(enrichViewNet)
library(ggplot2)

data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)


### Tests validateCreateEnrichMapArguments() results

context("validateCreateEnrichMapArguments() results")

test_that("validateCreateEnrichMapArguments() must return expected result", {
    
    result <- enrichViewNet:::validateCreateEnrichMapArguments(
        gostObject=parentalNapaVsDMSOEnrichment, query="parental_napa_vs_DMSO", 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1, categoryNode=1, 
        line=1)
    
    expect_true(result)
})


### Tests validateCreateEnrichMapMultiBasicArgs() results

context("validateCreateEnrichMapMultiBasicArgs() results")

test_that("validateCreateEnrichMapMultiBasicArgs() must return expected result", {
    
    result <- enrichViewNet:::validateCreateEnrichMapMultiBasicArgs(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                                        rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE, showCategory=30, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1)
    
    expect_true(result)
})


### Tests validateCreateEnrichMapMultiBasicAsIgraphArgs() results

context("validateCreateEnrichMapMultiBasicAsIgraphArgs() results")

test_that("validateCreateEnrichMapMultiBasicAsIgraphArgs() must return expected result", {
    
    result <- enrichViewNet:::validateCreateEnrichMapMultiBasicAsIgraphArgs(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                            rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE, showCategory=30, 
        similarityCutOff=0.2)
    
    expect_true(result)
})


### Tests validateCreateEnrichMapMultiBasicGOSTArgs() results

context("validateCreateEnrichMapMultiBasicGOSTArgs() results")

test_that("validateCreateEnrichMapMultiBasicGOSTArgs() must return expected result", {
    
    result <- enrichViewNet:::validateCreateEnrichMapMultiBasicGOSTArgs(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                            rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE)
    
    expect_true(result)
})


### Tests validateCreateEnrichMapMultiComplexArg() results

context("validateCreateEnrichMapMultiComplexArg() results")

test_that("validateCreateEnrichMapMultiComplexArg() must return expected result", {
    
    queryDF <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source=c("GO:CC", "REAC", "GO:CC"), removeRoot=c(TRUE, TRUE, TRUE),
        groupName=c("parental GO:CC", "rosa Reactome", "rosa GO:CC"), 
        termIDs=c("", "", ""), stringsAsFactors=FALSE)
    
    result <- enrichViewNet:::validateCreateEnrichMapMultiComplexArg(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                rosaNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryInfo=queryDF, showCategory=30, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1)
    
    expect_true(result)
})


### Tests validateCreateEnrichMapSubSectionArguments() results

context("validateCreateEnrichMapSubSectionArguments() results")

test_that("validateCreateEnrichMapSubSectionArguments() must return expected result", {
    
    result <- enrichViewNet:::validateCreateEnrichMapSubSectionArguments(
        showCategory=30, groupCategory=FALSE, categoryLabel=1, categoryNode=1,
        line=2)
    
    expect_true(result)
})


### Tests manageNameDuplicationInEmap() results

context("manageNameDuplicationInEmap() results")

test_that("manageNameDuplicationInEmap() must return expected result", {
    
    clustData <- data.frame(Cluster=c("group 1" , "group 1", "group 2", 
                                        "group 2", "group 2", "group 1"), 
        ID=c("WP:WP4925", "WP:WP382", "KEGG:04010",  "KEGG:01010", 
                "KEGG:919191", "KEGG:101010"),
        Description=c("Unfolded protein response", 
            rep("MAPK signaling pathway", 2), "VEGFA-VEGFR2 signaling", 
            rep("Human T-cell pathway", 2)),
        GeneRatio=c("4/157", "3/157", "3/157", rep("2/157", 3)),
        BgRatio=c("4/24022", "3/24022", "3/24022", rep("2/24022", 3)),
        pvalues=c(1.55e-4, 8.13e-8, 4.33e-5, 3.2e-5, 3.1e-5, 3.5e-5),
        p.adjust=c(1e-3, 1e-3, 1.4e-3, 1e-3, 1e-3, 1e-3), 
        qvalue=c(1e-3, 1e-3, 1.4e-3, 1e-3, 1e-3, 1e-3), 
        geneID=c("ENSG000107968/ENSG000120129/ENSG000123358/ENSG000158050",
            "ENSG000107968/ENSG000120129/ENSG000158050",
            "ENSG000107968/ENSG000120129/ENSG000158050", 
            "ENSG000120129/ENSG000158050", "ENSG000120129/ENSG000158050",
            "ENSG000120129/ENSG000158050"),
        Count=c(4, 3, 3, 2, 2, 2))
    
    expected <- c("Unfolded protein response", 
        "MAPK signaling pathway (WP:WP382)", 
        "MAPK signaling pathway (KEGG:04010)", 
        "VEGFA-VEGFR2 signaling",  "Human T-cell pathway (KEGG:919191)", 
        "Human T-cell pathway (KEGG:101010)")
    
    result <- enrichViewNet:::manageNameDuplicationInEmap(clProfDF=clustData)

    expect_equal(result$Description, expected)
})


### Tests manageQueryDuplicationInEmap() results

context("manageQueryDuplicationInEmap() results")

test_that("manageQueryDuplicationInEmap() must return expected result", {
    
    queryList <- list("parental_vs_DMSO", "rosa_vs_DMSO", "parental_vs_DMSO", 
                    "rosa_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO", 
                    "Mia_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO")
    
    expected <- list("parental_vs_DMSO (1)", "rosa_vs_DMSO (1)", 
        "parental_vs_DMSO (2)", "rosa_vs_DMSO (2)", "parental_vs_Control (1)", 
        "rosa_vs_DMSO (3)", "Mia_vs_DMSO", "parental_vs_Control (2)", 
        "rosa_vs_DMSO (4)")
    
    result <- enrichViewNet:::manageQueryDuplicationInEmap(queryList=queryList)
    
    expect_equal(result, expected)
})


### Tests createBasicEmap() results

context("createBasicEmap() results")

test_that("createBasicEmap() must return expected result", {
    
    gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
    gostResults <- gostResults[which(gostResults$source == "KEGG"),]
    gostResults <- gostResults[which(gostResults$term_id != "KEGG:00000"),]
    
    backgroundGenes <- parentalNapaVsDMSOEnrichment$meta$query_metadata$queries[["parental_napa_vs_DMSO"]]
    
    set.seed(111)
    
    graphRes <- enrichViewNet:::createBasicEmap(gostResults=gostResults, 
        backgroundGenes=backgroundGenes, showCategory=30L, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1,
        significantMethod="FDR", line=1)
    
    expect_true(is_ggplot(graphRes))
    
    expect_true(all(graphRes$data$name %in% gostResults$term_name))
    
    expect_true(all(graphRes$data$size[order(graphRes$data$size, 
        decreasing=TRUE)] == 
        gostResults$intersection_size[order(gostResults$intersection_size, 
                                                decreasing=TRUE)]))
})


### Tests createMultiEmap() results

context("createMultiEmap() results")

test_that("createMultiEmap() must return expected result when 2 different enrichment analyses", {
    
    gostResults1 <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
    gostResults1 <- gostResults1[which(gostResults1$source == "KEGG"),]
    gostResults1 <- gostResults1[which(gostResults1$term_id != "KEGG:00000"),]
    
    gostResults2 <- as.data.frame(rosaNapaVsDMSOEnrichment$result)
    gostResults2 <- gostResults2[which(gostResults2$source == "KEGG"),]
    gostResults2 <- gostResults2[which(gostResults2$term_id != "KEGG:00000"),]
    
    queryList <- list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO")
    
    set.seed(111)
    
    graphRes <- enrichViewNet:::createMultiEmap(gostResults=list(gostResults1, 
        gostResults2), queryList=queryList, showCategory=30L, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1,
        line=1)
    
    expect_true(is_ggplot(graphRes))
    
    expected_terms <- c("MAPK signaling pathway", 
        "Transcriptional misregulation in cancer", 
        "Parathyroid hormone synthesis, secretion and action",
        "Apoptosis", "Colorectal cancer", "TNF signaling pathway", 
        "p53 signaling pathway", "Human T-cell leukemia virus 1 infection", 
        "Non-alcoholic fatty liver disease", "Amphetamine addiction",
        "Estrogen signaling pathway", "Viral carcinogenesis",
        "IL-17 signaling pathway", "Fluid shear stress and atherosclerosis", 
        "Hepatitis B")
    
    expected_term_size <- c(14, 9, 6, 7, 6, 6, 5, 7, 7, 4, 5, 4, 3, 3, 3)
    expected_term_size <- expected_term_size[order(expected_term_size, 
                                                        decreasing=TRUE)]
    expect_true(all(graphRes$data$name %in% expected_terms))
})

test_that("createMultiEmap() must return expected result when same different enrichment analysis", {
    
    gostResults1 <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
    gostResults1 <- gostResults1[which(gostResults1$source == "KEGG"),]
    gostResults1 <- gostResults1[which(gostResults1$term_id != "KEGG:00000"),]
    
    gostResults2 <- as.data.frame(parentalNapaVsDMSOEnrichment$result)
    gostResults2 <- gostResults2[which(gostResults2$source == "REAC"),]
    gostResults2 <- gostResults2[1:10,]
    
    queryList <- list("parental_napa_vs_DMSO (1)", "parental_napa_vs_DMSO (2)")
    
    set.seed(111)
    
    graphRes <- enrichViewNet:::createMultiEmap(gostResults=list(gostResults1, 
        gostResults2), queryList=queryList, showCategory=30L, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1,
        line=1)
    
    expect_true(is_ggplot(graphRes))
    
    expected_terms <- c("MAPK signaling pathway", 
        "Transcriptional misregulation in cancer", 
        "Parathyroid hormone synthesis, secretion and action",
        "Apoptosis", "Colorectal cancer", "TNF signaling pathway", 
        "p53 signaling pathway", "Human T-cell leukemia virus 1 infection", 
        "Non-alcoholic fatty liver disease", "Amphetamine addiction",
        "Estrogen signaling pathway", "NGF-stimulated transcription",
        "Nuclear Events (kinase and transcription factor activation)",
        "Response of EIF2AK1 (HRI) to heme deficiency",                    
        "Signaling by NTRK1 (TRKA)", "FOXO-mediated transcription",                                     
        "Signaling by NTRKs", "Signal Transduction",                                              
        "ATF4 activates genes in response to endoplasmic reticulum  stress", 
        "Generic Transcription Pathway", "PERK regulates gene expression" )
    
    expected_term_size <- c(14, 8, 6, 7, 6, 6, 5, 7, 6, 4, 5, 9, 9, 6, 9, 
                                7, 9, 34, 5, 23, 5)
    expected_term_size <- expected_term_size[order(expected_term_size, 
                                                   decreasing=TRUE)]
    
    expect_true(all(graphRes$data$name %in% expected_terms))
})


### Tests validateCreateEnrichMapMultiComplexAsIgraphArg() results

context("validateCreateEnrichMapMultiComplexAsIgraphArg() results")

test_that("validateCreateEnrichMapMultiComplexAsIgraphArg() must return expected result", {
    
    gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
                            parentalNapaVsDMSOEnrichment)
    queryList <- list("parental_napa_vs_DMSO (1)", "parental_napa_vs_DMSO (2)")
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
        removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        groupName=c("parental - KEGG", "parental - Reactome"), 
        stringsAsFactors=FALSE)
    
    expect_true(enrichViewNet:::validateCreateEnrichMapMultiComplexAsIgraphArg(
        gostObjectList=gostObjectList, queryInfo=queryData, showCategory=20, 
        similarityCutOff=0.2))
})


### Tests similarityJaccard() results

context("similarityJaccard() results")

test_that("similarityJaccard() must return expected result", {
    
    resultData <- data.frame(Description=c("Term 1", "Term 2", "Term 3",
                                            "Term 4", "Term 5"), 
            geneID=c(
                paste0("ENSG001/ENSG002/ENSG003/ENSG004/ENSG005"), 
                paste0("ENSG001/ENSG002/ENSG003"),
                paste0("ENSG011/ENSG012/ENSG013"),
                paste0("ENSG001/ENSG002/ENSG003"),
                paste0("ENSG003/ENSG006/ENSG007/ENSG008/ENSG011")))
    
    exp <- matrix(data=NA, ncol=5, nrow=5)
    exp[2,1] <- 3.0/5.0
    exp[3,1] <- 0.0
    exp[3,2] <- 0.0
    exp[4,1] <- 3.0/5.0
    exp[4,2] <- 1.0
    exp[4,3] <- 0.0
    exp[5,1] <- 1.0/9.0
    exp[5,2] <- 1.0/7.0
    exp[5,3] <- 1.0/7.0
    exp[5,4] <- 1.0/7.0
    
    colnames(exp) <- c("Term 1", "Term 2", "Term 3", "Term 4", "Term 5")
    rownames(exp) <- c("Term 1", "Term 2", "Term 3", "Term 4", "Term 5")
     
    result <- enrichViewNet:::similarityJaccard(resultDF=resultData)
    
    expect_equivalent(result, exp)
})

test_that("similarityJaccard() must return expected result when zero", {
    
    resultData <- data.frame(Description=c("Term 1", "Term 21", "Term 3",
                                            "Term 4", "Term 5"), 
            geneID=c(
                paste0("ENSG001/ENSG002/ENSG003/ENSG004/ENSG005"), 
                paste0("ENSG001/ENSG002/ENSG003"),
                paste0("ENSG011/ENSG012/ENSG013/ENSG001"),
                paste0(""),
                paste0("")))
    
    exp <- matrix(data=NA, ncol=5, nrow=5)
    exp[2,1] <- 3.0/5.0
    exp[3,1] <- 1.0/8.0
    exp[3,2] <- 1.0/6.0
    exp[4,1] <- 0.0
    exp[4,2] <- 0.0
    exp[4,3] <- 0.0
    exp[5,1] <- 0.0
    exp[5,2] <- 0.0
    exp[5,3] <- 0.0
    exp[5,4] <- 0.0
    
    colnames(exp) <- c("Term 1", "Term 21", "Term 3", "Term 4", "Term 5")
    rownames(exp) <- c("Term 1", "Term 21", "Term 3", "Term 4", "Term 5")
    
    result <- enrichViewNet:::similarityJaccard(resultDF=resultData)
    
    expect_equivalent(result, exp)
})

    

#' @title Using functional enrichment results in  gprofiler2 format to create  
#' an enrichment map
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph.
#' 
#' @param gostObject a \code{list} corresponding to gprofiler2 enrichment 
#' output that contains and that contains 
#' the results from an enrichment analysis.
#' 
#' @param query a \code{character} string representing the name of the query 
#' that is going to be used to generate the graph. The query must exist in the 
#' \code{gostObject} object.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). Default: \code{TRUE}.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network. Default: \code{NULL}.
#' 
#' @param showCategory a positive \code{integer} representing the maximum 
#' number of terms to display.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms  
#' will be displayed. Default: \code{30L}.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped. Default: \code{FALSE}.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1). Default: \code{1}.s
#' 
#' @param categoryNode a positive \code{numeric} representing the amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' Default: \code{1}.
#'
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. Default: \code{1}.
#'
#' @param ... additional arguments that will be pass to the 
#' \code{\link[enrichplot]{emapplot}} function. 
#' 
#' @return a \code{ggplot} object which is the enrichment map for enrichment 
#' results.
#' 
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Extract query information (only one in this dataset)
#' query <- unique(parentalNapaVsDMSOEnrichment$result$query)
#' 
#' ## Create graph for Gene Ontology - Cellular Component related results
#' createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
#'     query=query, source="GO:CC", removeRoot=TRUE)
#' 
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom strex match_arg
#' @encoding UTF-8
#' @export
createEnrichMap <- function(gostObject, query, source=c("TERM_ID", "GO:MF", 
        "GO:CC", "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA", "CORUM", 
        "HP", "WP"), termIDs=NULL, removeRoot=TRUE,  
        showCategory=30L, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1, ...) {
    
    ## Validate source is among the possible choices
    source <- match_arg(source, ignore_case=TRUE)
    
    ## Validate parameters
    ## TODO update showCategory
    validateCreateEnrichMapArguments(gostObject=gostObject, query=query, 
        source=source, termIDs=termIDs, removeRoot=removeRoot, 
        showCategory=showCategory, categoryLabel=categoryLabel,
        groupCategory=groupCategory, categoryNode=categoryNode, 
        line=line)
    
    ## Extract results
    gostResults <- gostObject$result
    
    ## Retain results associated to query
    gostResults <- gostResults[gostResults$query == query,]
    
    ## Filter results
    if (source == "TERM_ID") {
        gostResults <- gostResults[gostResults$term_id %in% termIDs,]
    } else {
        gostResults <- gostResults[gostResults$source == source,]
    }
    
    ## Remove root term if required
    if (removeRoot) {
        gostResults <- removeRootTerm(gostResults)
        if (nrow(gostResults) == 0) {
            stop("With removal of the root term, there is no ", 
                    "enrichment term left")
        }
    }
    
    meta <- gostObject$meta
    
    backgroundGenes <- meta$query_metadata$queries[[query]]
    
    significantMethod <- meta$query_metadata$significance_threshold_method
    
    ## Create basic emap
    emap <- createBasicEmap(gostResults=gostResults, 
                backgroundGenes=backgroundGenes, 
                showCategory=showCategory, categoryLabel=categoryLabel,
                groupCategory=groupCategory, categoryNode=categoryNode, 
                significantMethod=significantMethod, line=line,  ...)
    
    return(emap)
}


#' @title Using functional enrichment results in  gprofiler2 format to create  
#' an enrichment map in an igraph format
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph. The output is an \code{igraph}.
#' 
#' @param gostObject a \code{list} corresponding to gprofiler2 enrichment 
#' output that contains and that contains 
#' the results from an enrichment analysis.
#' 
#' @param query a \code{character} string representing the name of the query 
#' that is going to be used to generate the graph. The query must exist in the 
#' \code{gostObject} object.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). Default: \code{TRUE}.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network. Default: \code{NULL}.
#' 
#' @param showCategory a positive \code{integer} representing the maximum 
#' number of terms to display.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms  
#' will be displayed. Default: \code{30L}.
#'  
#' @param similarityCutOff a positive \code{numeric} between 0 and 1 indicating 
#' the minimum level of similarity between two terms to have an edge linking 
#' the terms. Default: \code{0.20}.  
#' 
#' @return a \code{igraph} object which is the enrichment map for enrichment 
#' results. The node have 2 attributes: "name" and "size". The "name" 
#' corresponds to the term description. While the "size" corresponds to the 
#' number of genes found in the specific gene set. The edges have 
#' 3 attributes: "similarity", "width", and "weight". All those 3 attributes 
#' correspond to the Jaccard coefficient.
#' 
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Extract query information (only one in this dataset)
#' query <- unique(parentalNapaVsDMSOEnrichment$result$query)
#' 
#' ## Create graph for Gene Ontology - Cellular Component related results
#' mapG <- createEnrichMapAsIgraph(gostObject=parentalNapaVsDMSOEnrichment, 
#'     query=query, source="GO:CC", removeRoot=TRUE, 
#'     showCategory=30L, similarityCutOff=0.20)
#' 
#' ## Required library igraph to show the graph
#' if(requireNamespace("igraph", quietly=TRUE)) {
#'     ## Using library igraph to show the graph
#'     library(igraph)
#'     plot(mapG)
#' }
#' 
#' if (requireNamespace("ggplot2", quietly=TRUE) &&
#'         requireNamespace("igraph", quietly=TRUE) &&
#'         requireNamespace("ggtangle", quietly=TRUE) &&
#'         requireNamespace("ggnetwork", quietly=TRUE)) {
#'     ## Using more complex set of libraries to display personalized graph
#'     library(ggplot2)
#'     library(igraph)
#'     library(ggnetwork)
#'     library(ggtangle)
#'     emapG <- ggplot(mapG, layout=layout_with_fr) +
#'                 geom_edge(color="gray", linewidth=1) + 
#'                 geom_nodes(aes(size=size)) + 
#'                 geom_nodetext(aes(label=name), color="black", size=3) +
#'                 theme_void()
#'     emapG
#' }
#' 
#' @author Astrid Deschênes
#' @importFrom strex match_arg
#' @encoding UTF-8
#' @export
createEnrichMapAsIgraph <- function(gostObject, query, source=c("TERM_ID", 
    "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA", "CORUM", 
    "HP", "WP"), termIDs=NULL, removeRoot=TRUE,  
    showCategory=30L, similarityCutOff=0.20) {
    
    ## Validate source is among the possible choices
    source <- match_arg(source, ignore_case=TRUE)
    
    ## Validate parameters
    validateCreateEnrichMapAsIgraphArg(gostObject=gostObject, query=query, 
        source=source, termIDs=termIDs, removeRoot=removeRoot, 
        showCategory=showCategory, similarityCutOff=similarityCutOff)
    
    ## Extract results
    gostResults <- gostObject$result
    
    ## Retain results associated to query
    gostResults <- gostResults[gostResults$query == query,]
    
    ## Filter results
    if (source == "TERM_ID") {
        gostResults <- gostResults[gostResults$term_id %in% termIDs,]
    } else {
        gostResults <- gostResults[gostResults$source == source,]
    }
    
    ## Remove root term if required
    if (removeRoot) {
        gostResults <- removeRootTerm(gostResults)
        if (nrow(gostResults) == 0) {
            stop("With removal of the root term, there is no ", 
                    "enrichment term left")
        }
    }
    
    backgroundGenes <- gostObject$meta$query_metadata$queries[[query]]
    
    ## Create basic enrichment map in igraph format
    emapIgraph <- createBasicEmapAsIgraph(gostResults=gostResults, 
                backgroundGenes=backgroundGenes, showCategory=showCategory,
                similarityCutOff=similarityCutOff)
    
    return(emapIgraph)
}


#' @title Using functional enrichment results in gprofiler2 format to create  
#' an enrichment map with multiple groups from different enrichment analyses
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryList a \code{list} of \code{character} strings representing the 
#' names of the queries that are going to be used to generate the graph. 
#' The query names must exist in the associated \code{gostObjectList} objects 
#' and follow the same order. The number of entries must correspond to the 
#' number of entries for the \code{gostObjectList} parameter.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). Default: \code{TRUE}.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network. Default: \code{NULL}.
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed. Default: \code{30L}.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped. Default: \code{FALSE}.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1). Default: \code{1}.
#' 
#' @param categoryNode a positive \code{numeric} representing the amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' Default: \code{1}.
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. Default: \code{1}.
#' 
#' @param ... additional arguments that will be pass to the 
#' \code{\link[enrichplot]{emapplot}} function. 
#'
#' @return a \code{ggplot} object which is the enrichment map for enrichment 
#' results.
#' 
#' @examples
#'
#' ## Loading dataset containing results from 2 enrichment analyses done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#'
#' ## Extract query information (only one in each dataset)
#' query1 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
#' query2 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
#' 
#' ## Create graph for KEGG related results from 
#' ## 2 enrichment analyses
#' createEnrichMapMultiBasic(gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'     rosaNapaVsDMSOEnrichment), 
#'     queryList=list(query1, query2), source="KEGG", removeRoot=TRUE)
#' 
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom strex match_arg
#' @encoding UTF-8
#' @export
createEnrichMapMultiBasic <- function(gostObjectList, queryList, 
    source=c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", 
    "MIRNA", "HPA", "CORUM", "HP", "WP"), termIDs=NULL, removeRoot=TRUE, 
    showCategory=30L, groupCategory=FALSE, categoryLabel=1, 
    categoryNode=1, line=1, ...) {
    
    ## Validate source is among the possible choices
    source <- match_arg(source, ignore_case=TRUE)
    
    ## Validate parameters
    validateCreateEnrichMapMultiBasicArgs(gostObjectList=gostObjectList, 
        queryList=queryList, source=source, termIDs=termIDs, 
        removeRoot=removeRoot, showCategory=showCategory, 
        categoryLabel=categoryLabel, groupCategory=groupCategory, 
        categoryNode=categoryNode, line=line)
    
    ## Extract results
    gostResultsList <- lapply(gostObjectList, FUN=function(x) {x$result})
    
    ## Retain results associated to query
    gostResultsList <- lapply(seq_len(length(queryList)), 
        FUN=function(i, queryL, gostL) {
            gostL[[i]][gostL[[i]]$query == queryL[[i]], ]}, 
        queryL=queryList, gostL=gostResultsList)
    
    ## Filter results
    if (source == "TERM_ID") {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x, termIDs) {
            x[x$term_id %in% termIDs,]}, termIDs=termIDs)
    } else {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x, source) {
            x[x$source == source,]}, source=source)
    }
    
    ## Remove root term if required
    if (removeRoot) {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x) {
            removeRootTerm(x)})
    }
    
    ## Validate that at least one term is left
    if (sum(unlist(lapply(gostResultsList,  FUN=function(x) {nrow(x)})))  
            == 0) {
        stop("With removal of the root term, there is no ", 
                    "enrichment term left")
    }
    
    ## Create multi categories emap
    emap <- createMultiEmap(gostResultsList=gostResultsList, 
                queryList=queryList, showCategory=showCategory, 
                categoryLabel=categoryLabel, groupCategory=groupCategory, 
                categoryNode=categoryNode, line=line, ...)
    
    return(emap)
}


#' @title Using functional enrichment results in gprofiler2 format to create  
#' an enrichment map with multiple groups from different enrichment analyses as
#' an igraph
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph. The output is an enrichment map in igraph format.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryList a \code{list} of \code{character} strings representing the 
#' names of the queries that are going to be used to generate the graph. 
#' The query names must exist in the associated \code{gostObjectList} objects 
#' and follow the same order. The number of entries must correspond to the 
#' number of entries for the \code{gostObjectList} parameter.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). Default: \code{TRUE}.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network. Default: \code{NULL}.
#' 
#' @param showCategory a positive \code{integer} representing the maximum 
#' number of terms to display.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms  
#' will be displayed. Default: \code{30L}.
#'  
#' @param similarityCutOff a positive \code{numeric} between 0 and 1 indicating 
#' the minimum level of similarity between two terms, calculated 
#' using the Jaccard coefficient, to have an edge linking 
#' the terms. Default: \code{0.20}.  
#' 
#' @return a \code{igraph} object which is the enrichment map for enrichment 
#' results. The node have 5 attributes: "name", "size", "pie", "cluster", 
#' and "pieName". The "name" corresponds to the term description. While the 
#' "size" corresponds to the number of unique genes found in the specific 
#' gene set when looking at all the experiments.
#' The edges have 3 attributes: "similarity", "width", and 
#' "weight". All those 3 attributes correspond to the Jaccard coefficient.
#' 
#' @examples
#'
#' ## Loading dataset containing results from 2 enrichment analyses done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#'
#' ## Extract query information (only one in each dataset)
#' query1 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
#' query2 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
#' 
#' ## Create graph for KEGG related results from 
#' ## 2 enrichment analyses
#' emapG <- createEnrichMapMultiBasicAsIgraph(gostObjectList=
#'     list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
#'     queryList=list(query1, query2), source="KEGG", removeRoot=TRUE, 
#'     similarityCutOff=0.3)
#' 
#' if (requireNamespace("ggplot2", quietly=TRUE) && 
#'         requireNamespace("igraph", quietly=TRUE) && 
#'         requireNamespace("scatterpie", quietly=TRUE) && 
#'         requireNamespace("ggtangle", quietly=TRUE) && 
#'         requireNamespace("ggrepel", quietly=TRUE)) {
#'     ## Create a visual representation of the enrichment map
#'     ## by default
#'     library(igraph)
#'     plot(emapG)
#'     
#'     ## Add see to reproduce the same graph
#'     set.seed(12)
#'     
#'     library(ggplot2)
#'     library(ggtangle)
#'     library(scatterpie)
#'     library(ggrepel)
#'     
#'     emapGraph <- ggplot(emapG, layout=layout_with_fr) + 
#'                 geom_edge(color="gray", linewidth=1)
#'     
#'     pieInfo <- as.data.frame(do.call(rbind, V(emapG)$pie))
#'     colnames(pieInfo) <- V(emapG)$pieName[[1]]
#'     
#'     ## Add information about the groups associated with each node in the 
#'     ## ggplot object so that the node can be colored accordingly
#'     for (i in seq_len(ncol(pieInfo))) {
#'         emapGraph$data[colnames(pieInfo)[i]] <- pieInfo[, i]
#'     }
#'     
#'     ## Using scatterpie, ggtangle and ggrepel to generate the graph
#'     ## geom_scatterpie() allows to have scatter pie plot
#'     ## geom_text_repel() allows to have minimum overlying terms
#'     ## coord_fixed() forces the plot to have a 1:1 aspect ratio
#'     emapGraph + 
#'         geom_scatterpie(aes(x=x, y=y, r=size/50), 
#'             cols=c(colnames(pieInfo)), legend_name = "Group", color=NA) +
#'         geom_scatterpie_legend(radius=emapGraph$data$size/50, n=4, 
#'             x=max(emapGraph$data$x), y=min(emapGraph$data$y),
#'             labeller=function(x) {round(x*50)}, label_position="right") +
#'         geom_text_repel(aes(x=x, y=y, label=label), max.overlaps=20) +
#'         coord_fixed()
#' }
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom strex match_arg
#' @encoding UTF-8
#' @export
createEnrichMapMultiBasicAsIgraph <- function(gostObjectList, queryList, 
    source=c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", 
    "MIRNA", "HPA", "CORUM", "HP", "WP"), termIDs=NULL, removeRoot=TRUE, 
    showCategory=30L, similarityCutOff=0.2) {
    
    ## Validate source is among the possible choices
    source <- match_arg(source, ignore_case=TRUE)
    
    ## Validate parameters
    validateCreateEnrichMapMultiBasicAsIgraphArgs(gostObjectList=gostObjectList, 
        queryList=queryList, source=source, termIDs=termIDs, 
        removeRoot=removeRoot, showCategory=showCategory, 
        similarityCutOff=similarityCutOff)
    
    ## Extract results
    gostResultsList <- lapply(gostObjectList, FUN=function(x) {x$result})
    
    ## Retain results associated to query
    gostResultsList <- lapply(seq_len(length(queryList)), 
        FUN=function(i, queryL, gostL) {
            gostL[[i]][gostL[[i]]$query == queryL[[i]], ]}, 
            queryL=queryList, gostL=gostResultsList)
    
    ## Filter results
    if (source == "TERM_ID") {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x, termIDs) {
            x[x$term_id %in% termIDs,]}, termIDs=termIDs)
    } else {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x, source) {
            x[x$source == source,]}, source=source)
    }
    
    ## Remove root term if required
    if (removeRoot) {
        gostResultsList <- lapply(gostResultsList,  FUN=function(x) {
            removeRootTerm(x)})
    }
    
    ## Validate that at least one term is left
    if (sum(unlist(lapply(gostResultsList,  FUN=function(x) {nrow(x)})))  
        == 0) {
        stop("With removal of the root term, there is no ", 
                "enrichment term left")
    }
    
    ## Create multi categories emap
    emap <- createMultiEmapAsIgraph(gostResultsList=gostResultsList, 
        queryList=queryList, showCategory=showCategory, 
        similarityCutOff=similarityCutOff)
    
    return(emap)
}


#' @title Using functional enrichment results in gprofiler2 format to create  
#' an enrichment map with multiple groups from same or different enrichment 
#' analyses
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @param showCategory a positive \code{integer} or a \code{vector} of 
#' \code{characters} representing terms.  If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{vector} of terms, 
#' the selected terms will be displayed. Default: \code{30L}.
#' 
#' @param groupCategory a \code{logical} indicating if the categories should 
#' be grouped. Default: \code{FALSE}.
#' 
#' @param categoryLabel a positive \code{numeric} representing the amount by 
#' which plotting category nodes label size should be scaled relative 
#' to the default (1). Default: \code{1}.
#' 
#' @param categoryNode a positive \code{numeric} representing the amount by 
#' which plotting category nodes should be scaled relative to the default (1).
#' Default: \code{1}.
#' 
#' @param line a non-negative \code{numeric} representing the scale of line 
#' width. Default: \code{1}.
#' 
#' @param ... additional arguments that will be pass to the 
#' \code{\link[enrichplot]{emapplot}} function. 
#'
#' @return a \code{ggplot} object which is the enrichment map for enrichment 
#' results.
#' 
#' @examples
#'
#' ## Loading dataset containing results from 2 enrichment analyses done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#'
#' ## Create list of enrichment objects required to generate the enrichment map
#' gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'     parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment, 
#'     rosaNapaVsDMSOEnrichment)
#'     
#' ## Create data frame containing required information enabling the 
#' ## selection of the retained enriched terms for each enrichment analysis.
#' ## One line per enrichment analyses present in the gostObjectList parameter
#' ## With this data frame, the enrichment results will be split in 4 groups:
#' ## 1) KEGG significant terms from parental napa vs DMSO (no root term)
#' ## 2) REACTOME significant terms from parental napa vs DMSO (no root term)
#' ## 3) KEGG significant terms from rosa napa vs DMSO (no root term)
#' ## 4) REACTOME significant terms from rosa napa vs DMSO (no root term)
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'         "parental_napa_vs_DMSO", "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
#'     source=c("KEGG", "REAC", "KEGG", "REAC"), 
#'     removeRoot=c(TRUE, TRUE, TRUE, TRUE), termIDs=c("", "", "", ""), 
#'     groupName=c("parental - KEGG", "parental - Reactome", 
#'         "rosa - KEGG", "rosa - Reactome"), stringsAsFactors=FALSE)
#'     
#' ## Create graph for KEGG and REACTOME significant results from 
#' ## 2 enrichment analyses
#' createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
#'     queryInfo=queryDataFrame, line=1.5)
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom strex match_arg
#' @importFrom stringr str_split str_trim
#' @encoding UTF-8
#' @export
createEnrichMapMultiComplex <- function(gostObjectList, queryInfo,  
    showCategory=30L, groupCategory=FALSE, categoryLabel=1, 
    categoryNode=1, line=1, ...) {
    
    ## Validate parameters
    validateCreateEnrichMapMultiComplexArg(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, showCategory=showCategory, 
        categoryLabel=categoryLabel, groupCategory=groupCategory, 
        categoryNode=categoryNode, line=line)
    
    ## Extract results
    gostResultsList <- lapply(gostObjectList, FUN=function(x) {x$result})
    
    ## Retain results associated to query
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
        FUN=function(i, queryI, gostL) {
            gostL[[i]][gostL[[i]]$query == queryI$queryName[[i]], ]}, 
            queryI=queryInfo, gostL=gostResultsList)
    
    ## Filter results
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
        FUN=function(i, queryI, gostL) {
            if (queryI$source[i] == "TERM_ID") {
                terms <- unlist(str_split(queryI$termIDs[i], ","))
                terms <- str_trim(terms)
                return(gostL[[i]][gostL[[i]]$term_id %in% terms, ])
            } else {
                return(gostL[[i]][gostL[[i]]$source == queryI$source[i], ])
            }
        }, queryI=queryInfo, gostL=gostResultsList)
    
    
    ## Remove root terms when requested
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
        FUN=function(i, queryI, gostL) {
            if (queryI$removeRoot[i]) {
                return(removeRootTerm(gostL[[i]]))
            } else {
                return(gostL[[i]])
            }
        }, queryI=queryInfo, gostL=gostResultsList)
    
    ## Validate that at least one term is left
    if (sum(unlist(lapply(gostResultsList,  FUN=function(x) {nrow(x)})))
            == 0) {
        stop("With removal of the root term, there is no ",
                "enrichment term left")
    }
    
    ## Create multi categories emap
    emap <- createMultiEmap(gostResultsList=gostResultsList, 
                queryList=queryInfo$groupName, showCategory=showCategory, 
                categoryLabel=categoryLabel, groupCategory=groupCategory, 
                categoryNode=categoryNode, line=line,  ...)
    
    return(emap)
}


#' @title Using functional enrichment results in gprofiler2 format to create  
#' an enrichment map with multiple groups from same or different enrichment 
#' analyses in an igraph format
#' 
#' @description User selected enrichment terms are used to create an enrichment 
#' map. The selection of the term can by specifying by the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The map is only generated when there is at least on 
#' significant term to graph.
#' 
#' @param gostObjectList a \code{list} of \code{gprofiler2} objects that 
#' contain the results from an enrichment analysis. The list must contain at 
#' least 2 entries. The number of entries must correspond to the number of 
#' entries for the \code{queryList} parameter.
#' 
#' @param queryInfo a \code{data.frame} contains one row per group being 
#' displayed. The number of rows must correspond to the 
#' number of entries for the \code{gostObjectList} parameter. 
#' The mandatory columns are:
#' \itemize{
#' \item{\code{queryName}: a \code{character} string representing the name 
#' of the query retained for this group). The query names must exist in the 
#' associated \code{gostObjectList} objects and follow the same order. }
#' \item{\code{source}: a \code{character} string representing the selected 
#' source that will be used to generate the network. To hand-pick the terms to 
#' be used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID". }
#' \item{\code{removeRoot}: a \code{logical} that specified if the root terms 
#' of the selected source should be removed (when present). }
#' \item{\code{termIDs}: a \code{character} strings that contains the
#' term IDS retained for the creation of the network separated by a comma ',' 
#' when the "TERM_ID" source is selected. Otherwise, it should be a empty 
#' string (""). }
#' \item{\code{groupName}: a \code{character} strings that contains the 
#' name of the group to be shown in the legend. Each group has to have a 
#' unique name. }
#' }
#' 
#' @param showCategory a positive \code{integer} or \code{NULL}. 
#' If a \code{integer}, the first 
#' \code{n} terms will be displayed. If \code{NULL}, all terms will be 
#' displayed. Default: \code{30L}.
#'
#' @param similarityCutOff a positive \code{numeric}, larger than zero and
#' small than 1 that represent the minimum similarity level between two 
#' nodes (terms) to be linked by an edge. Default: \code{0.2}. 
#' 
#' @return  a \code{igraph} object which is the enrichment map for enrichment 
#' results. The node have 5 attributes: "name", "size", "pie", "cluster", 
#' and "pieName". The "name" corresponds to the term description. While the 
#' "size" corresponds to the number of unique genes found in the specific 
#' gene set when looking at all the experiments. 
#' The edges have 3 attributes: "similarity", "width", and 
#' "weight". All those 3 attributes correspond to the Jaccard coefficient.
#' 
#' @examples
#'
#' ## Loading dataset containing results from 2 enrichment analyses done with
#' ## gprofiler2 queries
#' data(parentalNapaVsDMSOEnrichment)
#' data(rosaNapaVsDMSOEnrichment)
#'
#' ## The graph will be split in 4 groups
#' ## Groups 1 and 2 are using the parental Napa vs DMSO dataset
#' ## Group 3 and 4 are using the rosa Napa vs DMSO dataset
#' gostObjectList=list(parentalNapaVsDMSOEnrichment, 
#'     parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment, 
#'     rosaNapaVsDMSOEnrichment)
#'     
#' ## Create data frame containing required information enabling the 
#' ## selection of the retained enriched terms for each enrichment analysis.
#' ## One line per enrichment analyses present in the gostObjectList parameter
#' ## With this data frame, the enrichment results will be split in 4 groups:
#' ## 1) KEGG significant terms from parental napa vs DMSO (no root term)
#' ## 2) REACTOME significant terms from parental napa vs DMSO (no root term)
#' ## 3) KEGG significant terms from rosa napa vs DMSO (no root term)
#' ## 4) REACTOME significant terms from rosa napa vs DMSO (no root term)
#' queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
#'         "parental_napa_vs_DMSO", "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
#'     source=c("KEGG", "REAC", "KEGG", "REAC"), 
#'     removeRoot=c(TRUE, TRUE, TRUE, TRUE), termIDs=c("", "", "", ""), 
#'     groupName=c("parental - KEGG", "parental - Reactome", 
#'         "rosa - KEGG", "rosa - Reactome"), stringsAsFactors=FALSE)
#'     
#' ## Create graph for KEGG and REACTOME significant results from 
#' ## 2 enrichment analyses in an igraph format
#' emap <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
#'     queryInfo=queryDataFrame, showCategory=5)
#' 
#' if (requireNamespace("ggplot2", quietly=TRUE) && 
#'         requireNamespace("igraph", quietly=TRUE) && 
#'         requireNamespace("scatterpie", quietly=TRUE) && 
#'         requireNamespace("ggtangle", quietly=TRUE) && 
#'         requireNamespace("ggrepel", quietly=TRUE)) {
#'     ## Create a visual representation of the enrichment map
#'     ## by default
#'     library(igraph)
#'     plot(emap)
#'     
#'     ## Add see to reproduce the same graph
#'     set.seed(12)
#'     
#'     library(ggplot2)
#'     library(ggtangle)
#'     library(scatterpie)
#'     library(ggrepel)
#'     
#'     emapG <- ggplot(emap, layout=layout_with_fr) + 
#'                 geom_edge(color="gray", linewidth=1)
#'     
#'     pieInfo <- as.data.frame(do.call(rbind, V(emap)$pie))
#'     colnames(pieInfo) <- V(emap)$pieName[[1]]
#'     
#'     ## Add information about the groups associated with each node in the 
#'     ## ggplot object so that the node can be colored accordingly
#'     for (i in seq_len(ncol(pieInfo))) {
#'         emapG$data[colnames(pieInfo)[i]] <- pieInfo[, i]
#'     }
#'     
#'     ## Using scatterpie, ggtangle and ggrepel to generate the graph
#'     ## geom_scatterpie() allows to have scatter pie plot
#'     ## geom_text_repel() allows to have minimum overlying terms
#'     ## coord_fixed() forces the plot to have a 1:1 aspect ratio
#'     emapG + 
#'         geom_scatterpie(aes(x=x, y=y, r=size/50), 
#'             cols=c(colnames(pieInfo)), legend_name = "Group", color=NA) +
#'         geom_scatterpie_legend(radius=emapG$data$size/50, n=4, 
#'             x=max(emapG$data$x), y=max(emapG$data$y),
#'             labeller=function(x) {round(x*50)}, label_position="right") +
#'         geom_text_repel(aes(x=x, y=y, label=label), max.overlaps=20) +
#'         coord_fixed()
#' }
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom strex match_arg
#' @importFrom stringr str_split str_trim
#' @encoding UTF-8
#' @export
createEnrichMapMultiComplexAsIgraph <- function(gostObjectList, queryInfo,  
    showCategory=30L, similarityCutOff=0.2) {
    
    ## Validate parameters
    validateCreateEnrichMapMultiComplexAsIgraphArg(
        gostObjectList=gostObjectList, queryInfo=queryInfo, 
        showCategory=showCategory, similarityCutOff=similarityCutOff)
    
    ## Extract results
    gostResultsList <- lapply(gostObjectList, FUN=function(x) {x$result})
    
    ## Retain results associated to query
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
            FUN=function(i, queryI, gostL) {
                    gostL[[i]][gostL[[i]]$query == queryI$queryName[[i]], ]}, 
                    queryI=queryInfo, gostL=gostResultsList)
    
    ## Filter results
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
        FUN=function(i, queryI, gostL) {
            if (queryI$source[i] == "TERM_ID") {
                    terms <- unlist(str_split(queryI$termIDs[i], ","))
                    terms <- str_trim(terms)
                    return(gostL[[i]][gostL[[i]]$term_id %in% terms, ])
            } else {
                    return(gostL[[i]][gostL[[i]]$source == queryI$source[i], ])
            }
        }, queryI=queryInfo, gostL=gostResultsList)
    
    ## Remove root terms when requested
    gostResultsList <- lapply(seq_len(length(gostObjectList)), 
            FUN=function(i, queryI, gostL) {
                if (queryI$removeRoot[i]) {
                    return(removeRootTerm(gostL[[i]]))
                } else {
                    return(gostL[[i]])
                }
        }, queryI=queryInfo, gostL=gostResultsList)
    
    ## Validate that at least one term is left
    if (sum(unlist(lapply(gostResultsList,  FUN=function(x) {nrow(x)})))
        == 0) {
        stop("With removal of the root term, there is no ",
                "enrichment term left")
    }
    
    ## Create multi categories emap in a igraph format
    emap <- createMultiEmapAsIgraph(gostResultsList=gostResultsList, 
        queryList=queryInfo$groupName, showCategory=showCategory, 
        similarityCutOff=similarityCutOff)
    
    return(emap)
}

### Unit tests for methodsEmap.R functions

library(enrichViewNet)
library(igraph)

data(demoGOST)
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

### Tests createEnrichMap() results

context("createEnrichMap() results")

test_that("createEnrichMap() must return error when gostObject is a number", {
    
    error_message <- paste0("The gostObject object should be a list ", 
                        "with meta and result as entries corresponding ", 
                        "to gprofiler2 enrichment output.")
    
    expect_error(createEnrichMap(gostObject=33, query="TEST", 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE,
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when gostObject is a string character", {
    
    error_message <- paste0("The gostObject object should be a list ", 
                        "with meta and result as entries corresponding ", 
                        "to gprofiler2 enrichment output.")
    
    expect_error(createEnrichMap(gostObject="TEST", query="TEST", 
        source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when query is a number", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    error_message <- paste0("The \'query\'must be a character string.")
    
    expect_error(createEnrichMap(gostObject=gostObject, query=33, 
        source="KEGG", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when query is a vector of strings", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    error_message <- paste0("The \'query\'must be a character string.")
    
    expect_error(createEnrichMap(gostObject=gostObject, query=c("1", "2"), 
        source="KEGG", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when query is not in gost", {
  
    error_message <- paste0("The \'query\' is not present in the ", 
                                    "results of the gost object.")
    
    expect_error(createEnrichMap(gostObject=demoGOST, query="CANADA", 
        source="KEGG", termIDs=NULL, removeRoot=TRUE,
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when source is a number", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    error_message <- paste0("Assertion on 'arg' failed: Must be of type ", 
                                "'character', not 'double'.")
    
    expect_error(createEnrichMap(gostObject=gostObject, query="toto", 
        source=333, termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1),  error_message)
})

test_that("createEnrichMap() must return error when source is a wrong name", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    expect_error(createEnrichMap(gostObject=gostObject, query="toto",  
        source="test", termIDs=NULL, removeRoot=TRUE, title="network", 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1))
})


test_that("createEnrichMap() must return error when source is GO", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    expect_error(createEnrichMap(gostObject=gostObject, query="toto", 
        source="GO",
        termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1))
})


test_that("createEnrichMap() must return error when removeRoot remove last enriched term", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- paste0("With removal of the root term, there is no ", 
                                "enrichment term left")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
                    source="WP", removeRoot=TRUE, 
                    showCategory=30, groupCategory=FALSE, categoryLabel=1,
                    categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when removeRoot remove last enriched term from term list", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- paste0("With removal of the root term, there is no ", 
                                "enrichment term left")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=TRUE, showCategory=30, 
        groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when showCategory negative value", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'showCategory\' parameter must an positive ", 
            "integer or a vector of character strings representing terms.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
                    source="WP", removeRoot=TRUE, showCategory=-30, 
                    groupCategory=FALSE, categoryLabel=1,
                    categoryNode=1, line=2), error_message)
})


test_that("createEnrichMap() must return error when showCategory is boolean", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'showCategory\' parameter must an positive ", 
            "integer or a vector of character strings representing terms.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
                    source="WP", removeRoot=TRUE, showCategory=TRUE, 
                    groupCategory=FALSE, categoryLabel=1,
                    categoryNode=1, line=1), error_message)
})


test_that("createEnrichMap() must return error when groupCategory is integer", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'groupCategory\' parameter must a logical ", 
                                "(TRUE or FALSE).")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
            source="WP", removeRoot=TRUE, showCategory=30, 
            groupCategory=22, categoryLabel=1,
            categoryNode=1, line=1), error_message, fixed=TRUE)
})


test_that("createEnrichMap() must return error when categoryLabel is string", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'categoryLabel\' parameter ", 
                                "must be a positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
            source="WP", removeRoot=TRUE, showCategory=30, 
            groupCategory=FALSE, categoryLabel="test",
            categoryNode=1, line=2), error_message, fixed=TRUE)
})


test_that("createEnrichMap() must return error when cexLabelCategory is negative", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'categoryLabel\' parameter ", 
                                "must be a positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
            source="WP", removeRoot=TRUE, showCategory=30, 
            groupCategory=FALSE, categoryLabel=-1.1,
            categoryNode=1, line=2), error_message, fixed=TRUE)
})


test_that("createEnrichMap() must return error when categoryNode is negative", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'categoryNode\' parameter ", 
                                "must be a positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
                    source="WP", removeRoot=TRUE, showCategory=30, 
                    groupCategory=FALSE, categoryLabel=2,
                    categoryNode=-1), error_message, fixed=TRUE)
})


test_that("createEnrichMap() must return error when categoryNode is string", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'categoryNode\' parameter ", 
                                "must be a positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
            source="WP", removeRoot=TRUE, showCategory=30, 
            groupCategory=FALSE, categoryLabel=2,
            categoryNode="te", line=1), error_message, fixed=TRUE)
})

test_that("createEnrichMap() must return error when line is a string", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'line\' parameter must be a ", 
                                "positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="WP", removeRoot=TRUE,  showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1, line="HI"), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMap() must return error when line is a negative number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'line\' parameter must be a ", 
                                "positive numeric.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="WP", removeRoot=TRUE,  showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1, line=-0.3), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMap() must return error when not term for selected source", {
    
    gostTerm <- demoGOST
    gostTerm$result <- gostTerm$result[gostTerm$result$source != "WP", ]
    
    error_message <- paste0("There is no enriched term for the selected ", 
                                "source \'WP'.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="WP", removeRoot=TRUE,  showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1, line=1), error_message, 
                 fixed=TRUE)
})

test_that("createEnrichMap() must return error when not term id and TERM_ID selected", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("A vector of terms should be given through the ",
                        "\'termIDs\' parameter when source is \'TERM_ID\'.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="TERM_ID", removeRoot=TRUE,  showCategory=30, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMap() must return error when not all term ids are present", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("Not all listed terms are present in the  ",
                                    "enrichment results.")
    
    expect_error(createEnrichMap(gostObject=gostTerm, query="query_1", 
        source="TERM_ID", termIDs = c("GO:0051173", "GO:0065004", "GO:1905898"), 
        removeRoot=TRUE,  showCategory=30, 
        groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1), 
        error_message, fixed=TRUE)
})


### Tests createEnrichMapMultiBasic() results

context("createEnrichMapMultiBasic() results")

test_that("createEnrichMapMultiBasic() must return error when gostObjectList is a number", {
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=33, 
        queryList=c("TEST", "Test2"),  source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1, line=1), error_message)
})

test_that("createEnrichMapMultiBasic() must return error when gostObjectList has only one element", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm), 
        queryList=list("TEST"), source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message)
})

test_that("createEnrichMapMultiBasic() must return error when queryList is a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should be a list of query ", 
        "names. At least 2 query names are required. The number of query ", 
        "names should correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
        queryList=33, source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message)
})

test_that("createEnrichMapMultiBasic() must return error when queryList is longer than gostObjectList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should be a list of query ", 
        "names. At least 2 query names are required. The number of query ", 
        "names should correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
    queryList=list("TEST", "TEST2", "TEST3"), source="GO:CC", termIDs=NULL, 
    removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
    categoryNode=1), error_message)
})

test_that("createEnrichMapMultiBasic() must return error when one query in queryList is not in gostObject", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("Each query name present in the ", 
        "\'queryList\' parameter must be present in the associated ", 
        "enrichment object.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "TEST"), source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasic() must return error when one object in gostObjectList in a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The gostObjectList should only contain a list ", 
        "of enrichment results. Enrichment results are lists with meta ", 
        "and result as entries corresponding to gprofiler2 ", 
        "enrichment output.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, 33), 
        queryList=list("query_1", "query_1"), source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasic() must return error when no enriched term for selected source", {
    
    gostTerm <- demoGOST
    gostTerm$result <- gostTerm$result[which(gostTerm$result$source != "WP"), ]
    
    error_message <- paste0("There is no enriched term for the selected ", 
                                "source \'WP\'.")   
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "query_1"), source="WP", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasic() must return error when number in queryList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should only contain a list ", 
                                "of query names in character strings.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", 33), source="WP", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasic() must return error when number in queryList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("A vector of terms should be given through the ",
                "\'termIDs\' parameter when source is \'TERM_ID\'.")
    
    expect_error(createEnrichMapMultiBasic(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "query_1"), source="TERM_ID", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, groupCategory=FALSE, categoryLabel=1,
        categoryNode=1), error_message, fixed=TRUE)
})


### Tests createEnrichMapMultiBasicAsIgraph() results

context("createEnrichMapMultiBasicAsIgraph() results")

test_that("createEnrichMapMultiBasicAsIgraph() must return error when gostObjectList is a number", {
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=33, 
        queryList=c("TEST", "Test2"),  source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.2), error_message)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when gostObjectList has only one element", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm), 
        queryList=list("TEST"), source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, similarityCutOff=0.1), error_message)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when queryList is a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should be a list of query ", 
        "names. At least 2 query names are required. The number of query ", 
        "names should correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=33, source="GO:CC", termIDs=NULL, removeRoot=TRUE, 
        showCategory=30, similarityCutOff=0.2), error_message)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when queryList is longer than gostObjectList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should be a list of query ", 
        "names. At least 2 query names are required. The number of query ", 
        "names should correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("TEST", "TEST2", "TEST3"), source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.1), error_message)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when one query in queryList is not in gostObject", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("Each query name present in the ", 
        "\'queryList\' parameter must be present in the associated ", 
        "enrichment object.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "TEST"), source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.2), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when one object in gostObjectList in a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The gostObjectList should only contain a list ", 
        "of enrichment results. Enrichment results are lists with meta ", 
        "and result as entries corresponding to gprofiler2 ", 
        "enrichment output.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, 33), 
        queryList=list("query_1", "query_1"), source="GO:CC", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.2), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when no enriched term for selected source", {
    
    gostTerm <- demoGOST
    gostTerm$result <- gostTerm$result[which(gostTerm$result$source != "WP"), ]
    
    error_message <- paste0("There is no enriched term for the selected ", 
        "source \'WP\'.")   
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "query_1"), source="WP", termIDs=NULL, 
        removeRoot=TRUE, similarityCutOff=0.2), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when number in queryList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryList object should only contain a list ", 
                            "of query names in character strings.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", 33), source="WP", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.1), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when number in queryList", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("A vector of terms should be given through the ",
        "\'termIDs\' parameter when source is \'TERM_ID\'.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(gostObjectList=list(gostTerm, gostTerm), 
        queryList=list("query_1", "query_1"), source="TERM_ID", termIDs=NULL, 
        removeRoot=TRUE, showCategory=30, similarityCutOff=0.2), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when removeRoot is numeric", {
    
    error_message <- paste0("The \'removeRoot\' should be a logical value (TRUE or FALSE).")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:MF", termIDs=NULL, 
        removeRoot=33, showCategory=30, similarityCutOff=0.2), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when showCategory is negative", {
    
    error_message <- paste0("The \'showCategory\' parameter must an positive integer or NULL.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:MF", termIDs=NULL, 
        removeRoot=FALSE, showCategory=-1, similarityCutOff=0.2), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when similarityCutOff is negative", {
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be ", 
                        "a numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:MF", termIDs=NULL, 
        removeRoot=FALSE, showCategory=2, similarityCutOff=-0.01), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when similarityCutOff above one", {
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
                        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:MF", termIDs=NULL, 
        removeRoot=FALSE, showCategory=2, similarityCutOff=1.01), 
        error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return expected result", {
    
    result <- createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="GO:MF", termIDs=NULL, removeRoot=T, showCategory=5, 
        similarityCutOff=0.4)
    
    exp_v_name <- c("DNA-binding transcription factor activity",
        "DNA-binding transcription factor activity, RNA polymerase II-specific",
        "RNA polymerase II transcription regulatory region sequence-specific DNA binding",
        "transcription cis-regulatory region binding",
        "transcription regulatory region nucleic acid binding",
        "DNA binding", 
        "RNA polymerase II cis-regulatory region sequence-specific DNA binding",
        "cis-regulatory region sequence-specific DNA binding")
    
    exp_size <- c(31, 30, 30, 31, 31, 13, 10, 10)
    exp_name <- c("name",   "size", "pie",  "cluster", "pieName")
    exp_sim <- c(0.9677419354838710, 0.9677419354838710, 0.9375000000000000, 
                 0.9375000000000000, 0.9354838709677419, 0.9062500000000000,
                 0.9062500000000000, 0.9677419354838710, 0.9677419354838710,
                 1.0000000000000000, 0.7692307692307693, 0.7692307692307693,
                 1.0000000000000000)
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 8)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(length(E(result)), 13)
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(names(edge.attributes(result)), 
                    c("similarity", "width", "weight"))
    expect_equal(E(result)$similarity, exp_sim)
    expect_equal(E(result)$width, exp_sim)
    expect_equal(E(result)$weight, exp_sim)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when no term left", {
    
    message_error <- paste0("There is no enriched term for the selected ", 
                        "source \'TF\'.")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="TF", termIDs=NULL, removeRoot=T, showCategory=5, 
        similarityCutOff=0.4), error=message_error)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return error when no term left after removal of root term", {
    
    message_error <- paste0("With removal of the root term, there is no ", 
                                "enrichment term left")
    
    expect_error(createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="TERM_ID", termIDs=c("WP:000000"), removeRoot=T, showCategory=5, 
        similarityCutOff=0.4), error=message_error)
})

test_that("createEnrichMapMultiBasicAsIgraph() must return expected result when using term IDs", {
    
    result <- createEnrichMapMultiBasicAsIgraph(
        gostObjectList=list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
        queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source="TERM_ID", 
        termIDs=c("GO:0006357", "GO:0009892", "GO:0007275", "GO:0034654"), 
        removeRoot=T, showCategory=5, 
        similarityCutOff=0.5)
    
    exp_v_name <- c("regulation of transcription by RNA polymerase II",
        "multicellular organism development",
        "negative regulation of metabolic process",
        "nucleobase-containing compound biosynthetic process")
    
    exp_size <- c(39, 46, 41, 47)
    exp_name <- c("name",   "size", "pie",  "cluster", "pieName")
    exp_sim <- c(0.829787234042553)
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 4)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(length(E(result)), 1)
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(names(edge.attributes(result)), 
                 c("similarity", "width", "weight"))
    expect_equal(E(result)$similarity, exp_sim)
    expect_equal(E(result)$width, exp_sim)
    expect_equal(E(result)$weight, exp_sim)
})


### Tests createEnrichMapMultiComplex() results

context("createEnrichMapMultiComplex() results")

test_that("createEnrichMapMultiComplex() must return error when gostObjectList is a number", {
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    queryDF <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
        source=c("GO:CC", "REAC", "GO:CC"), removeRoot=c(TRUE, TRUE, TRUE),
        termIDs=c("", "", ""), stringsAsFactors=FALSE)
    
    expect_error(createEnrichMapMultiComplex(gostObjectList=33, 
        queryInfo=queryDF,  showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1, line=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when gostObjectList has only one element", {
    
    gostTerm <- demoGOST
    
    queryDF <- data.frame(queryName=c("query_1"), 
            source=c("GO:CC"), removeRoot=c(TRUE),
            termIDs=c(""), stringsAsFactors=FALSE)
    
    error_message <- paste0("The gostObjectList object should be a list ", 
        "of enrichment objects. At least 2 enrichment objects are required.")
    
    expect_error(createEnrichMapMultiComplex(gostObjectList=list(gostTerm), 
        queryInfo=queryDF, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when gostObjectList is a list of numbers", {
    
    error_message <- paste0("The gostObjectList should only contain a list ", 
        "of enrichment results. Enrichment results are lists with meta and", 
        " result as entries corresponding to gprofiler2 enrichment", 
        " output.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(3, 4), 
        queryInfo=33, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when queryInfo is a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The queryInfo should a data.frame with ", 
            "those columns: queryName, source, removeRoot and termIDs.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=33, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when queryInfo shorter than gostObjectList", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1"), 
        source=c("KEGG"), removeRoot=c(TRUE), termIDs=c(""), 
        stringsAsFactors=FALSE)
        
    error_message <- paste0("The number of rows in queryInfo should ", 
        "correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when source in queryInfo is not in list of sources", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "TEST"), removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The values in the \'source\' column of the \'queryInfo\' ", 
        "data frame should be one of those: \"TERM_ID\", \"GO:MF\", ", 
        "\"GO:CC\", \"GO:BP\", \"KEGG\", \"REAC\", \"TF\", ",
        "\"MIRNA\", \"HPA\", \"CORUM\", \"HP\", \"WP\".")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when source in queryInfo is number", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c(33, 22), removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'source'\ column of the \'queryInfo\' ", 
        "data frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when queryName in queryInfo is number", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c(22, 33), 
        source=c("KEGG", "REAC"), removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'queryName'\ column of the \'queryInfo\' ", 
                    "data frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when termIDs in queryInfo is number", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "REAC"), removeRoot=c(TRUE, TRUE), termIDs=c(33, 22), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'termIDs'\ column of the \'queryInfo\' ", 
    "data frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message)
})

test_that("createEnrichMapMultiComplex() must return error when removeRoot in queryInfo is number", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "REAC"), removeRoot=c(33, 22), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'removeRoot'\ column of the \'queryInfo\' ", 
        "data frame should only contain logical values (TRUE or FALSE).")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when query name in queryInfo not in enrichment object", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_2"), 
        source=c("KEGG", "REAC"), removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("Each query name present in the \'queryName'\ ", 
        "column of the \'queryInfo\' data frame must be present in the ", 
        "associated enrichment object.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when TERM_ID in queryInfo but not term ids", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "TERM_ID"), removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("A string of terms should be present in the ",
        "\'termIDs\' column when source is \'TERM_ID\'.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when termIDs column in queryInfo contains numbers", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "TERM_ID"), removeRoot=c(TRUE, TRUE), termIDs=c(33, 22), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'termIDs\' column of the 'queryInfo' data ", 
        "frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, 
        fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when removeRoot column in queryInfo contains numbers", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "TERM_ID"), removeRoot=c(33, 22), termIDs=c("", ""), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'removeRoot\' column of the 'queryInfo' ", 
        "data frame should only contain logical values (TRUE or FALSE).")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, 
        fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when groupName column in queryInfo contains numbers", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "REAC"), removeRoot=c(TRUE, TRUE), 
        termIDs=c("", ""), groupName=c(22, 33),  
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'groupName\' column of the 'queryInfo' ", 
        "data frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, 
        fixed=TRUE)
})

test_that("createEnrichMapMultiComplex() must return error when groupName column contain identical names", {
    
    gostTerm <- demoGOST
    
    queryDataFrame <- data.frame(queryName=c("query_1", "query_1"), 
        source=c("KEGG", "REAC"), removeRoot=c(TRUE, TRUE), 
        termIDs=c("", ""), groupName=c("REAC", "REAC"),  
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'groupName\' column of the 'queryInfo' ", 
        "data frame should only contain unique group names.")
    
    expect_error(createEnrichMapMultiComplex(
        gostObjectList=list(gostTerm, gostTerm), 
        queryInfo=queryDataFrame, showCategory=30, groupCategory=FALSE, 
        categoryLabel=1, categoryNode=1), error_message, 
        fixed=TRUE)
})


### Tests createEnrichMapMultiComplexAsIgraph() results

context("createEnrichMapMultiComplexAsIgraph() results")

test_that("createEnrichMapMultiComplexAsIgraph() must return error when gostObjectList is numerical list", {
    
    gostObjL <- list(33, 22)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
                        "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
                        removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
                        groupName=c("parental - KEGG", "parental - Reactome"), 
                        stringsAsFactors=FALSE)

    error_message <- paste0("The gostObjectList should only contain a list ", 
        "of enrichment results. Enrichment results are lists with meta and ", 
        "result as entries corresponding to gprofiler2 enrichment output.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
            queryInfo=queryData, showCategory=20, similarityCutOff=0.25), 
            error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when queryInfo missing the groupName field", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                                    parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
                        "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
                        removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
                        test=c("parental - KEGG", "parental - Reactome"), 
                        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'groupName\' column of the \'queryInfo\' ", 
        "data frame should be in a character string format.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=20, similarityCutOff=0.25), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when queryInfo contains more elements than the gostObjectList", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                                parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO", "test"), source=c("KEGG", "REAC", "GO:BP"), 
        removeRoot=c(TRUE, TRUE, TRUE), termIDs=c("", "", ""), 
        groupName=c("parental - KEGG", "parental - Reactome", "toto"), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The number of rows in queryInfo should", 
                        " correspond to the number of enrichment objects.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=20, similarityCutOff=0.25), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when showCategory is a string", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                            parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
            "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
            removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
            groupName=c("parental - KEGG", "parental - Reactome"), 
            stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'showCategory\' parameter must an ", 
                                    "positive integer or NULL.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory="TEST", similarityCutOff=0.25), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when showCategory is negative", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                        parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
                    "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
                    removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
                    groupName=c("parental - KEGG", "parental - Reactome"), 
                    stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'showCategory\' parameter must an ", 
                                    "positive integer or NULL.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=-2L, similarityCutOff=0.25), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when similarityCutOff is a string", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                                parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
        removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
        groupName=c("parental - KEGG", "parental - Reactome"), 
        stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
            queryInfo=queryData, showCategory=20L, similarityCutOff="BEST"), 
            error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when not term left", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                        parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO"), source=c("TERM_ID", "TERM_ID"), 
        removeRoot=c(TRUE, TRUE), termIDs=c("WP:000000", "KEGG:00000"), 
        groupName=c("parental - KEGG", "parental - Reactome"), 
            stringsAsFactors=FALSE)
    
    error_message <- paste0("With removal of the root term, there is ", 
                                "no enrichment term left")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=20L, similarityCutOff=0.2), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when similarityCutOff is negative numeric", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                            parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
            "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
            removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
            groupName=c("parental - KEGG", "parental - Reactome"), 
            stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=20L, similarityCutOff=-0.1), 
        error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return error when similarityCutOff is superior to 1", {
    
    gostObjL <- list(parentalNapaVsDMSOEnrichment, 
                            parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
            "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
            removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
            groupName=c("parental - KEGG", "parental - Reactome"), 
            stringsAsFactors=FALSE)
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjL, 
        queryInfo=queryData, showCategory=20L, similarityCutOff=1.1), 
                 error_message=error_message)
})

test_that("createEnrichMapMultiComplexAsIgraph() must return expected result", {
    
    gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
                           parentalNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
                    "parental_napa_vs_DMSO"), source=c("KEGG", "REAC"), 
                    removeRoot=c(TRUE, TRUE), termIDs=c("", ""), 
                    groupName=c("parental - KEGG", "parental - Reactome"), 
                    stringsAsFactors=FALSE)
    
    result <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryData, showCategory=20, similarityCutOff=0.25)
    
    exp_size <- c(14, 8, 6, 7, 6, 6, 5, 7, 6, 4, 5, 9, 9, 6, 9, 7, 9, 34, 5, 
                    23, 5, 4, 23, 13, 17, 17, 5, 4, 6, 23, 3)
    exp_name <- c("name",   "size",   "pie",  "cluster", "pieName")
    
    expect_equal(class(result), "igraph")
    expect_equal(length(igraph::V(result)), 31)
    expect_equal(length(igraph::E(result)), 63)
    expect_equal(igraph::V(result)$size, exp_size)
    expect_equal(names(igraph::vertex.attributes(result)), exp_name)
    expect_equal(names(igraph::edge.attributes(result)), 
                            c("similarity", "width", "weight"))
})

test_that("createEnrichMapMultiComplexAsIgraph() must return expected result", {
    
    gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
                                rosaNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
                "rosa_napa_vs_DMSO"), source=c("TERM_ID", "TERM_ID"), 
                removeRoot=c(FALSE, FALSE), 
                termIDs=c(c("WP:WP4925,WP:WP3613,WP:WP382,WP:WP395"), 
                        c("WP:WP4925,WP:WP3613,WP:WP382,WP:WP3287")), 
                groupName=c("parental - WP", "rosa - WP"), 
                stringsAsFactors=FALSE)
    
    result <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
            queryInfo=queryData, showCategory=20, similarityCutOff=0.3)
    
    exp_v_name <- c("Photodynamic therapy-induced unfolded protein response", 
            "Unfolded protein response", "MAPK signaling pathway", 
            "IL-4 signaling pathway", "Overview of nanoparticle effects")
    
    exp_size <- c(7, 6, 10, 4, 2)
    exp_name <- c("name",   "size",   "pie",  "cluster", "pieName")
    
    exp_pie <- list()
    exp_pie[[1]] <- c(1, 1)
    exp_pie[[2]] <- c(1, 1)
    exp_pie[[3]] <- c(1, 1)
    exp_pie[[4]] <- c(1, 0)
    exp_pie[[5]] <- c(0, 1)
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 5)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(V(result)$pie, exp_pie)
    expect_equal(length(E(result)), 1)
    expect_equal(E(result)$similarity, c(0.625))
    expect_equal(E(result)$width, c(0.625))
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(names(edge.attributes(result)), 
                    c("similarity", "width", "weight"))
})

test_that("createEnrichMapMultiComplexAsIgraph() must return expected result when one node", {
    
    gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
                           rosaNapaVsDMSOEnrichment)
    
    queryData <- data.frame(queryName=c("parental_napa_vs_DMSO", 
            "rosa_napa_vs_DMSO"), source=c("TERM_ID", "TERM_ID"), 
            removeRoot=c(TRUE, TRUE), 
            termIDs=c(c("WP:WP4925"), c("WP:WP4925")), 
            groupName=c("parental - WP", "rosa - WP"), 
            stringsAsFactors=FALSE)
    
    result <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
                queryInfo=queryData, showCategory=20, similarityCutOff=0.3)
    
    exp_v_name <- c("Unfolded protein response")
    
    exp_size <- c(6)
    exp_name <- c("name",   "size")
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 1)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(length(E(result)),0)
    expect_equal(names(vertex.attributes(result)), exp_name)
})


### Tests createEnrichMapAsIgraph() results

context("createEnrichMapAsIgraph() results")

test_that("createEnrichMapAsIgraph() must return error when gostObjectList is numerical list", {
    
    gostObjL <- list(33, 22)
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0("The gostObject object should be a list with ", 
        "meta and result as entries corresponding to gprofiler2 enrichment ", 
        "output.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=20, source="GO:CC", 
        similarityCutOff=0.25), error_message=error_message)
})

test_that("createEnrichMapAsIgraph() must return error when similarityCutOff is superior to 1", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=20L, source="GO:CC", removeRoot=TRUE, 
        similarityCutOff=1.1), error_message=error_message)
})

test_that("createEnrichMapAsIgraph() must return error when similarityCutOff is inferior to zero", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0("The \'similarityCutOff\' parameter must be a ", 
                        "numeric superior to zero and inferior to one.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=20L, source="GO:CC", removeRoot=TRUE, 
        similarityCutOff=-0.01), error_message=error_message)
})

test_that("createEnrichMapAsIgraph() must return error when removeRoot is a string", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0("The \'removeRoot\' parameter must a ", 
                        "logical (TRUE or FALSE).)")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=20L, source="GO:CC", removeRoot="test", 
        similarityCutOff=0.1), error_message=error_message, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when query is a numeric", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    error_message <- paste0("The 'query' must be a character string")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=3, showCategory=20L, source="GO:CC", removeRoot=TRUE, 
        similarityCutOff=0.1), error_message=error_message, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when showCategory is a string", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0("The 'showCategory' parameter must an ", 
                                "positive integer or NULL.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory="ROMEO", source="GO:CC", removeRoot=TRUE, 
        similarityCutOff=0.1), error_message=error_message, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when source has not result", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    error_message <- paste0(" There is no enriched term for the selected ", 
                                "source 'TF'.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=NULL, source="TF", removeRoot=TRUE, 
        similarityCutOff=0.1), error_message=error_message, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when not all listed terms exist", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    errorM <- paste0("Not all listed terms are present in the ", 
                        "enrichment results.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=NULL, source="TERM_ID",
        termIDs=c("WP:WP3613,REAC:R-HSA-9614085,TEST,GO:0008140"), 
        removeRoot=TRUE, similarityCutOff=0.1), error_message=errorM, 
        fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when term list null", {
    
    errorM <- paste0("A vector of terms should be given through the ",
                        "\'termIDs\' parameter when source is \'TERM_ID\'.")
    
    expect_error(createEnrichMapAsIgraph(
            gostObject=parentalNapaVsDMSOEnrichment, 
            query="parental_napa_vs_DMSO", showCategory=NULL, source="TERM_ID",
            termIDs=NULL, removeRoot=TRUE, similarityCutOff=0.1), 
            error_message=errorM, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when query not in enrichment object", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "ttee"
    
    errorM <- paste0("The 'query' is not present in the results of the", 
                        " gost object.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=NULL, source="TERM_ID",
        termIDs=c("WP:WP3613,REAC:R-HSA-9614085,GO:0008140"), 
        removeRoot=TRUE, similarityCutOff=0.1), error_message=errorM, 
        fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return expected result", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    termIds <- c("WP:WP516", "WP:WP4970", "WP:WP4211", "WP:WP4216")
    
    result <- createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=NULL, source="TERM_ID", 
        termIDs=termIds, similarityCutOff=0.3)
    
    exp_v_name <- c("Transcriptional cascade regulating adipogenesis", 
        "Chromosomal and microsatellite instability in colorectal cancer ", 
        "Galanin receptor pathway", "Hypertrophy model")
    
    exp_size <- c(5, 6, 3, 3)
    exp_name <- c("name",   "size")
    
    exp_pie <- list()
    exp_pie[[1]] <- c(1, 1)
    exp_pie[[2]] <- c(1, 1)
    exp_pie[[3]] <- c(1, 1)
    exp_pie[[4]] <- c(1, 0)
    exp_pie[[5]] <- c(0, 1)
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 4)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(length(E(result)), 1)
    expect_equal(E(result)$similarity, c(0.5))
    expect_equal(E(result)$width, c(0.5))
    expect_equal(names(vertex.attributes(result)), exp_name)
    expect_equal(names(edge.attributes(result)), 
                    c("similarity", "width", "weight"))
})

test_that("createEnrichMapAsIgraph() must return error when query not in enrichment object", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "ttee"
    
    errorM <- paste0("The 'query' is not present in the results of the", 
                        " gost object.")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
            query=queryData, showCategory=NULL, source="TERM_ID",
            termIDs=c("WP:WP3613,REAC:R-HSA-9614085,GO:0008140"), 
            removeRoot=TRUE, similarityCutOff=0.1), error_message=errorM, 
            fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return error when query not in enrichment object", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    errorM <- paste0("With removal of the root term, there is no enrichment", 
                            " term left")
    
    expect_error(createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=NULL, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=TRUE, similarityCutOff=0.1), 
        error_message=errorM, fixed=TRUE)
})

test_that("createEnrichMapAsIgraph() must return expected result when one entry", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    termIds <- c("WP:WP516")
    
    result <- createEnrichMapAsIgraph(gostObject=gostObjL, 
            query=queryData, showCategory=NULL, source="TERM_ID", 
            termIDs=termIds, similarityCutOff=0.3)
    
    exp_v_name <- c("Hypertrophy model")
    
    exp_size <- c(3)
    exp_name <- c("name",   "size")
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 1)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(length(E(result)), 0)
    expect_equal(names(vertex.attributes(result)), exp_name)
})

test_that("createEnrichMapAsIgraph() must return expected result when limit number of nodes", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    queryData <- "parental_napa_vs_DMSO"
    
    result <- createEnrichMapAsIgraph(gostObject=gostObjL, 
            query=queryData, showCategory=6, source="WP", removeRoot=TRUE,
            termIDs=termIds, similarityCutOff=0.3)
    
    exp_v_name <- c("Photodynamic therapy-induced unfolded protein response",
        "Unfolded protein response" , "VEGFA-VEGFR2 signaling",
        "Transcriptional cascade regulating adipogenesis", 
        "White fat cell differentiation", "Pre-implantation embryo")
    
    exp_size <- c(7, 6, 16, 5, 6, 6)
    exp_name <- c("name",   "size")
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 6)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(length(E(result)), 2)
    expect_equal(E(result)$similarity, c(0.62500000000000, 0.8333333333333333))
    expect_equal(names(vertex.attributes(result)), exp_name)
})

test_that("createEnrichMapAsIgraph() must return expected result when term names duplicated", {
    
    gostObjL <- parentalNapaVsDMSOEnrichment
    
    ## Duplicate name
    gostObjL$result$term_name[
        gostObjL$result$term_name == "VEGFA-VEGFR2 signaling"] <- 
                    "Unfolded protein response"
    queryData <- "parental_napa_vs_DMSO"
    
    result <- createEnrichMapAsIgraph(gostObject=gostObjL, 
        query=queryData, showCategory=6, source="WP", removeRoot=TRUE,
            termIDs=termIds, similarityCutOff=0.7)
    
    exp_v_name <- c("Photodynamic therapy-induced unfolded protein response",
        "Unfolded protein response (WP:WP4925)" , 
        "Unfolded protein response (WP:WP3888)",
        "Transcriptional cascade regulating adipogenesis", 
        "White fat cell differentiation", "Pre-implantation embryo")
    
    exp_size <- c(7, 6, 16, 5, 6, 6)
    exp_name <- c("name",   "size")
    
    expect_equal(class(result), "igraph")
    expect_equal(length(V(result)), 6)
    expect_equal(V(result)$name, exp_v_name)
    expect_equal(V(result)$size, exp_size)
    expect_equal(length(E(result)), 1)
    expect_equal(E(result)$similarity, c(0.8333333333333333))
    expect_equal(names(vertex.attributes(result)), exp_name)
})

## ----style, echo = FALSE, results = 'hide', warning=FALSE, message=FALSE------
BiocStyle::markdown()

suppressPackageStartupMessages({
    library(knitr)
    library(enrichViewNet)
    library(gprofiler2)
    library(ggplot2)
    library(igraph)
    library(ggtangle)
    library(ggrepel)
})

## Set it globally
options(ggrepel.max.overlaps = 100)

set.seed(1214)

## ----graphDemo01, echo = FALSE, fig.align="center", fig.cap="A network where significant GO terms and genes are presented as nodes while edges connect each gene to its associated term(s).", out.width = '90%'----
knitr::include_graphics("demo01.jpeg")

## ----graphDemo02, echo=FALSE, fig.align="center", fig.cap="An enrichment map using significant Kegg terms where edges are connecting terms with overlapping genes.", out.width = '95%'----
knitr::include_graphics("demo_KEGG_emap_v03.jpg")

## ----installDemo01, eval=FALSE, warning=FALSE, message=FALSE------------------
# if (!requireNamespace("BiocManager", quietly = TRUE))
#         install.packages("BiocManager")
# 
# BiocManager::install("enrichViewNet")

## ----graphWorkflow, echo=FALSE, fig.align="center", fig.cap="The enrichViewNet general workflow", out.width = '100%'----
knitr::include_graphics("Figure_enrichViewNet_workflow_v05.jpg")

## ----graphListToGraph01, echo = FALSE, fig.align="left", fig.cap="From an enrichment list (A) to a Cytoscape network (B).", out.width = '100%'----
knitr::include_graphics("FromListToGraph_v03.jpg")

## ----gprofiler, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE----

## Required library
library(gprofiler2)

## The dataset of differentially expressed genes done between 
## napabucasin treated and DMSO control parental (Froeling et al 2019)
## All genes tested are present
data("parentalNapaVsDMSODEG")

## Retain significant results 
## (absolute fold change superior to 1 and adjusted p-value inferior to 0.05)
retained <- which(abs(parentalNapaVsDMSODEG$log2FoldChange) > 1 & 
                            parentalNapaVsDMSODEG$padj < 0.05)
signRes <-  parentalNapaVsDMSODEG[retained, ]

## Run one functional enrichment analysis using all significant genes
## The species is homo sapiens ("hsapiens")
## The g:SCS multiple testing correction method (Raudvere U et al 2019)
## The WikiPathways database is used
## Only the significant results are retained (significant=TRUE)
## The evidence codes are included in the results (evcodes=TRUE)
## A custom background included the tested genes is used
gostres <- gprofiler2::gost(
                query=list(parental_napa_vs_DMSO=unique(signRes$EnsemblID)),
                organism="hsapiens",
                correction_method="g_SCS",
                sources=c("WP"),
                significant=TRUE,
                evcodes=TRUE,
                custom_bg=unique(parentalNapaVsDMSODEG$EnsemblID))

## ----gostResult, echo=TRUE, eval=TRUE-----------------------------------------
## The 'gostres' object is a list of 2 entries
## The 'result' entry contains the enrichment results
## The 'meta' entry contains the metadata information

## Some columns of interest in the results
gostres$result[1:4, c("query", "p_value", "term_size", 
                    "query_size", "intersection_size", "term_id")]

## The term names can be longer than the one shown
gostres$result[19:22, c("term_id", "source", "term_name")]


## ----cytoscapeLogo01, echo = FALSE, fig.align="center", fig.cap="Cytoscape software logo.", out.width = '55%'----
knitr::include_graphics("cy3sticker.png")

## ----runCreateNetwork, echo=TRUE, eval=TRUE, message=FALSE--------------------
## Load saved enrichment results between parental Napa vs DMSO
data("parentalNapaVsDMSOEnrichment")

## Create network for REACTOME significant terms
## The 'removeRoot=TRUE' parameter removes the root term from the network
## The network will either by created in Cytoscape (if the application is open)
## or a CX file will be created in the temporary directory
createNetwork(gostObject=parentalNapaVsDMSOEnrichment,  source="REAC", 
        removeRoot=TRUE, title="REACTOME_All", 
        collection="parental_napa_vs_DMSO", 
        fileName=file.path(tempdir(), "parentalNapaVsDMSOEnrichment.cx"))

## ----networkInCytoscape, echo=FALSE, fig.align="center", fig.cap="All reactome terms in a gene-term network loaded in Cytoscape.", out.width = '110%'----
knitr::include_graphics("cytoscape_reactome_all_parental_napa_vs_DMSO.png")

## ----runCreateNetworkSelected, echo=TRUE, eval=TRUE, message=FALSE------------
## Load saved enrichment results between parental Napa vs DMSO
data("parentalNapaVsDMSOEnrichment")

## List of terms of interest
reactomeSelected <- c("REAC:R-HSA-9031628", "REAC:R-HSA-198725", 
                        "REAC:R-HSA-9614085", "REAC:R-HSA-9617828",
                        "REAC:R-HSA-9614657", "REAC:R-HSA-73857",
                        "REAC:R-HSA-74160", "REAC:R-HSA-381340")

## All enrichment results
results <- parentalNapaVsDMSOEnrichment$result

## Retain selected results
selectedRes <- results[which(results$term_id %in% reactomeSelected), ]

## Print the first selected terms
selectedRes[, c("term_name")]


## ----runCreateNetworkSelected2, echo=TRUE, eval=TRUE, message=FALSE, fig.align="center", fig.cap="Enrichment map."----

## Create network for REACTOME selected terms
## The 'source="TERM_ID"' parameter enable to specify a personalized 
## list of terms of interest
## The network will either by created in Cytoscape (if the application is open)
## or a CX file will be created in the temporary directory
createNetwork(gostObject=parentalNapaVsDMSOEnrichment,  source="TERM_ID", 
        termIDs=selectedRes$term_id, title="REACTOME_Selected", 
        collection="parental_napa_vs_DMSO",
        fileName=file.path(tempdir(), "parentalNapaVsDMSO_REACTOME.cx"))

## ----networkInCytoscapeSelected, echo=FALSE, fig.align="center", fig.cap="Selected Reactome terms in a gene-term network loaded in Cytoscape.", out.width = '110%'----
knitr::include_graphics("cytoscape_with_selected_REACTOME_v01.png")

## ----networkFinalReactome, echo=FALSE, fig.align="center", fig.cap="Final Reactome network after customization inside Cytoscape.", out.width = '100%'----
knitr::include_graphics("REACTOME_Selected.jpeg")

## ----gprofiler2, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE----

## Required library
library(gprofiler2)

## The dataset of differentially expressed genes done between 
## napabucasin treated and DMSO control parental (Froeling et al 2019)
## All genes tested are present
data("parentalNapaVsDMSODEG")

## Retain significant results 
## (absolute fold change superior to 1 and adjusted p-value inferior to 0.05)
retained <- which(abs(parentalNapaVsDMSODEG$log2FoldChange) > 1 & 
                        parentalNapaVsDMSODEG$padj < 0.05)
signRes <- parentalNapaVsDMSODEG[retained, ]

## Run one functional enrichment analysis using all significant genes
## The species is homo sapiens ("hsapiens")
## The g:SCS multiple testing correction method (Raudvere U et al 2019)
## The WikiPathways database is used
## Only the significant results are retained (significant=TRUE)
## The evidence codes are included in the results (evcodes=TRUE)
## A custom background included the tested genes is used
gostres <- gprofiler2::gost(
                query=list(parental_napa_vs_DMSO=unique(signRes$EnsemblID)),
                organism="hsapiens",
                correction_method="g_SCS",
                sources=c("WP"),
                significant=TRUE,
                evcodes=TRUE,
                custom_bg=unique(parentalNapaVsDMSODEG$EnsemblID))

## ----gostResult2, echo=TRUE, eval=TRUE----------------------------------------
## The 'gostres' object is a list of 2 entries
## The 'result' entry contains the enrichment results
## The 'meta' entry contains the metadata information

## Some columns of interest in the results
gostres$result[1:4, c("query", "p_value", "term_size", 
                    "query_size", "intersection_size", "term_id")]

## The term names can be longer than the one shown
gostres$result[19:22, c("term_id", "source", "term_name")]


## ----runCreateEmap01, echo=TRUE, eval=TRUE, fig.cap="A Kegg enrichment map where terms with overlapping genes cluster together.", fig.align="center"----

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## Create network for all Kegg terms
## All terms will be shown even if there is overlapping
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", source="KEGG")
    

## ----runCreateEmapTerms, echo=TRUE, eval=TRUE, fig.cap="An enrichment map showing only the user selected terms.", fig.align="center"----

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## The term IDs must correspond to the IDs present in the "term_id" column
head(parentalNapaVsDMSOEnrichment$result[, c("query", "term_id", "term_name")], 
     n=3)

## List of selected terms from different sources
termID <- c("KEGG:04115", "WP:WP4963", "KEGG:04010", 
                "REAC:R-HSA-5675221", "REAC:R-HSA-112409", "WP:WP382")

## Create network for all selected terms
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", 
                    source="TERM_ID", termIDs=termID)
    

## ----runCreateEmap03, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with personalized colors.", fig.align="center"----

## The ggplot2 library is required
library(ggplot2)
## Create network for all Kegg terms
graphKegg <- createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", source="KEGG")

## Nodes with lowest p-values will be in orange and highest p-values in black
## The title of the legend is also modified
graphKegg + scale_color_continuous(name="P-value adjusted", low="orange", 
                                    high="black")
    

## ----runCreateEmapIgraph01, echo=TRUE, eval=TRUE, fig.cap="A Reactome (12 top terms) enrichment map where terms with overlapping  genes cluster together.", fig.align="center"----

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## Create network for all Reactome terms
## All terms will be shown even if there is overlapping
## The similarity cut off is set to 0.3
## The top 10 terms with best p-values are shown
emapGraph <- createEnrichMapAsIgraph(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", similarityCutOff=0.3,
                    source="REAC", showCategory=12)

## Set seed to ensure reproducible results
set.seed(121)

## The igraph library is required
library(igraph)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black", vertex.color="lightblue2")   

## ----runCreateEmapIgraph02, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with a different seed.", fig.align="center"----

## Set seed to ensure reproducible results
set.seed(12)

## The igraph library is required
library(igraph)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black", vertex.color="lightblue2")   

## ----runCreateEmapIgraph03, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with personalized visualization options.", fig.align="center"----

## The required libraries
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)

## Create network for all Reactome terms
## Minimum similarity to have a edge is set to 0.4
## Only the top 15 terms with the bestp-values are shown 
graphReac <- createEnrichMapAsIgraph(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", similarityCutOff=0.4,
                    source="REAC", showCategory=10)

## Set seed to ensure reproducible results
set.seed(92)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(graphReac, layout=layout_with_fr)

## Move right the node related to Signal Transduction
graphEmap$data$x[graphEmap$data$label == 
            "Signal Transduction"] <- 2.3

## Using ggtangle and ggrepel libraries to personalize output
## Set the color of the text, the nodes and the edges 
## Set the node size using size value present in the igraph object
## The edge width is associated to the similarity value
## the coord_fixed() function is used to fix 1:1 ratio
graphEmap + geom_edge(aes(linewidth=weight), color="blue1") + 
    geom_point(aes(size=size), colour="gray40") +
    geom_text_repel(aes(x=x, y=y, label=label), nudge_x=0.5, 
                 nudge_y=0.2, col="darkviolet", min.segment.length=0.1, 
                 max.overlaps=10) +
    scale_size_continuous(range=c(4, 12)) + 
    scale_linewidth_binned(range=c(1, 3)) + coord_fixed() 
    

## ----emapMulti01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg enrichment results for 2 different experiments.", fig.align="center"----

## Set seed to ensure reproducible results
set.seed(2121)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control parental and
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("parentalNapaVsDMSOEnrichment")
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## The queryList is a list of query names retained for each of the enrichment 
## object (same order). Beware that a enrichment object can contain more than 
## one query.
query_01 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
queryList <- list(query_01, query_02)

## Enrichment map where the groups are the KEGG results for the 2 different
## experiments
createEnrichMapMultiBasic(gostObjectList=gostObjectList,
    queryList=queryList, source="KEGG", removeRoot=TRUE)
    


## ----emapMultiCustom, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map using KEGG terms from two enrichment analyses with personalized colors and legend."----

## Required library
library(ggplot2)

## Enrichment map where the groups are the KEGG results for the 2 different
## experiments
createEnrichMapMultiBasic(gostObjectList=gostObjectList,
    queryList=queryList, source="KEGG", removeRoot=TRUE) +
        scale_fill_manual(name="Groups",
                breaks=queryList,
                values=c("cyan4", "bisque3"),
                labels=c("parental", "rosa")) +
        theme(legend.title=element_text(face="bold"))


## ----emapMultiAsIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing GO Molecular Function enrichment results (top 10) for 2 different experiments.", fig.align="center"----

## Set seed to ensure reproducible results
set.seed(2121)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control parental and
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("parentalNapaVsDMSOEnrichment")
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## The queryList is a list of query names retained for each of the enrichment 
## object (same order). Beware that a enrichment object can contain more than 
## one query.
query_01 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
queryList <- list(query_01, query_02)

## Enrichment map where the groups are the GO Molecular Function results 
## for the 2 different experiments
## Only the top 10 terms for each experiments (based on p-value) are shown
## Minimum Jaccard coefficient between 2 nodes is set to 0.6
emapGraph <- createEnrichMapMultiBasicAsIgraph(gostObjectList=gostObjectList,
    queryList=queryList, source="GO:MF", removeRoot=TRUE, showCategory=5,
    similarityCutOff=0.6)
    
library(igraph)
plot(emapGraph)


## ----emapMultiAsIgraph02, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map using GO Molecular Function terms from two enrichment analyses with personalized colors and legend."----

## The required libraries
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

set.seed(11)

graphEmap <- ggplot(emapGraph, layout=layout_with_fr) 

## Extract information from igraph object about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapGraph)$pie))
colnames(pieInfo) <- V(emapGraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("darkorange", "darkviolet")

## Using ggtangle, scatterpie and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="black") +
    geom_scatterpie(aes(x=x, y=y, r=size/100), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/100, n=4, 
            x=max(graphEmap$data$x)+1, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*100)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 3)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="blue2", 
            max.overlaps=10) +
    coord_fixed()

## ----emapMultiComplex01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis.", fig.align="center"----

## Set seed to ensure reproducible results
set.seed(3221)

## The dataset of functional enriched terms for one experiment:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01), 
                            source=c("KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE),
                            termIDs=c("", ""), 
                            groupName=c("Kegg", "Reactome"),
                            stringsAsFactors=FALSE)

## Enrichment map where the groups are the KEGG and Reactome results for the 
## same experiment
createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
        queryInfo=queryInfo)
    

## ----emapMultiCustom2, echo=TRUE, warning=FALSE, message=FALSE, collapse=FALSE, eval=TRUE, fig.cap="An enrichment map using selected terms related to MAP kinases and interleukin in two different experiments."----

## Set seed to ensure reproducible results
set.seed(28)

## The datasets of functional enriched terms for the two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector and
## napabucasin treated and DMSO control parental MiaPaCa2 cells
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
## The order of the objects must respect the order on the queryInfo data frame
## In this case: 
##   1. rosa dataset (for MAP kinases)
##   2. parental dataset (for MAP kinases)
##   3. rosa dataset (for interleukin)
##   4. parental dataset (for interleukin)
gostObjectList <- list(rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_rosa <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_parental <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]


## List of selected terms that will be shown in each group
rosa_mapk <- "GO:0017017,GO:0033549,KEGG:04010,WP:WP382"
rosa_il <- "KEGG:04657,WP:WP4754" 
parental_mapk <- paste0("GO:0017017,GO:0033549,KEGG:04010,", 
                            "REAC:R-HSA-5675221,REAC:R-HSA-112409,WP:WP382")
parental_il <- "WP:WP4754,WP:WP395"


## The query information is a data frame containing the information required 
## to extract the specific terms for each enrichment object
## The number of rows must correspond to the number of enrichment objects
## The query name must be present in the enrichment object
## The source is set to "TERM_ID" so that the terms present in termIDs column 
##  will be used
## The group name will be used for the legend, the same name cannot be 
##  used twice
queryInfo <- data.frame(queryName=c(query_rosa, query_parental, 
                    query_rosa, query_parental), 
        source=c("TERM_ID", "TERM_ID", "TERM_ID", "TERM_ID"),
        removeRoot=c(FALSE, FALSE, FALSE, FALSE),
        termIDs=c(rosa_mapk, parental_mapk, rosa_il, parental_il),
        groupName=c("rosa - MAP kinases", "parental - MAP kinases", 
                        "rosa - Interleukin", "parental - Interleukin"),
        stringsAsFactors=FALSE)

## Enrichment map where the groups TODO
createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
        queryInfo=queryInfo)


## ----emapMultiComplexIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis.", fig.align="center"----

## The dataset of functional enriched terms for one experiment:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01), 
                            source=c("KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE),
                            termIDs=c("", ""), 
                            groupName=c("Kegg", "Reactome"),
                            stringsAsFactors=FALSE)


## Enrichment map where the groups are the KEGG and Reactome results for the 
## same experiment
## Minimum similarity coefficient to have 2 terms linked is set to 0.5
emapGraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, similarityCutOff=0.5)

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(3221)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")   
    

## ----changeSeedIgraph02, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis with a different seed.", fig.align="center"----

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(911)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")  


## ----personalizedIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO and parental vs DMSO analyses as a ggplot graph.", fig.align="center"----

## Visualization libraries is required
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

## Set seed to ensure reproducible results
set.seed(21)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(emapGraph, layout=layout_with_fr) 

## Extract information about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapGraph)$pie))
colnames(pieInfo) <- V(emapGraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("blue", "darkviolet")
    
## Using scatterpie, ggtangle and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="lightblue3") +
    geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/50, n=3, 
            x=max(graphEmap$data$x)+0.5, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*50)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 3)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="black", 
            max.overlaps=10) +
    coord_fixed()


## ----createEnrichMapMultiComplexAsIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO, and parenteal vs DMSO analyses.", fig.align="center"----

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, each enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01, query_02, query_02), 
                            source=c("GO:BP", "GO:CC", "GO:BP", "GO:CC"),
                            removeRoot=c(TRUE, TRUE, TRUE, TRUE),
                            termIDs=c("", "", "", ""), 
                            groupName=c("GO:BP - Napa", "GO:CC - Napa",
                                    "GO:BP - Parental", "GO:CC - Parental"),
                            stringsAsFactors=FALSE)


## Enrichment map where there are 2 groups generated from each 
## experiment
## Minimum similarity coefficient to have 2 terms linked is set to 0.5
## The 10 terms with the best p-value are selected for each group
emapGraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, similarityCutOff=0.5, showCategory=10)

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(3221)

## Use library igraph to create the visual representation
## Unfortunately, the output does not generate a scatter pie plot
## See next topic to generate a scatter pie plot
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")   
    

## ----personalized01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO and parental vs DMSO analyses as a ggplot graph.", fig.align="center"----

## Visualization libraries is required
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, each enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01, query_02, query_02), 
                            source=c("KEGG", "REAC", "KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE, TRUE, TRUE),
                            termIDs=c("", "", "", ""), 
                            groupName=c("Kegg - Rosa", "Reactome - Rosa",
                                "Kegg - Parental", "Reactome - Parental"),
                            stringsAsFactors=FALSE)

## Enrichment map where the groups are the KEGG and Reactome results for 
## two enrichment analyses
## Minimum similarity coefficient to have 2 terms linked is set to 0.3
## Only the 7 terms with best p-value are going to be shown in each group
emapIgraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, showCategory=5, similarityCutOff=0.3)

## Set seed to ensure reproducible results
set.seed(21)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(emapIgraph, layout=layout_with_fr) 

## Extract information about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapIgraph)$pie))
colnames(pieInfo) <- V(emapIgraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("darkorange", "violet", "darkorange4", "darkviolet")
    
## Using scatterpie, ggtangle and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="blue3") +
    geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/50, n=3, 
            x=max(graphEmap$data$x)+0.5, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*50)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 2)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="black", 
            max.overlaps=10) +
    coord_fixed()


## ----sessionInfo, echo=FALSE--------------------------------------------------
sessionInfo()

#' @title Verifying that Cytoscape is running
#'
#' @description Verifying that Cytoscape is running
#'
#' @return a \code{logical} indicating if Cytoscape is running.
#'
#' @examples
#'
#' ## Test if Cytoscape is running
#' enrichViewNet:::isCytoscapeRunning()
#'
#' @author Astrid Deschênes
#' @importFrom RCy3 cytoscapePing
#' @encoding UTF-8
#' @keywords internal
isCytoscapeRunning <- function() {
    
    out <- tryCatch(
        {
            cytoscapePing()
            return(TRUE)
        },
        error=function(cond) {
            message("Unable to connect to Cytoscape. \n",
                        "CX JSON file will be created.\n")
            return(FALSE)
        },
        warning=function(cond) {
            message("Unable to connect to Cytoscape. \n",
                        "CX JSON file will be created.")
            return(FALSE)
        }
    )
    
    return(out)
}


#' @title Validate arguments passed to creatNetwork() function
#'
#' @description Validate the arguments passed to creatNetwork() function.
#' First, the object containing the enrichment results must correspond to a
#' object created by  \code{gprofiler2} software. Second, the selected
#' source must at least have one enriched term in the results. Then, if the
#' source is 'TERM_ID', the listed terms must be present in the enrichment
#' results.
#'
#' @param gostObject a \code{list} created by \code{gprofiler2} that contains
#' the results from an enrichment analysis.
#'
#' @param source a \code{character} string representing the selected source
#' that will be used to generate the network. To hand-pick the terms to be
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function,
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.
#'
#' @param termIDs a \code{vector} of \code{character} strings that contains
#' the term IDs retained for the creation of the network. This parameter is
#' only used when \code{source} is set to "TERM_ID".
#'
#' @param removeRoot a \code{logical} that specified if the root terms of
#' the selected source should be removed (when present).
#'
#' @param query a \code{character} string that specified the retained query to 
#' generate the network or \code{NULL}. 
#' 
#' @param title a \code{character} string representing the name assigned to 
#' the network.
#' 
#' @param collection a \code{character} string representing the collection 
#' name assigned to the network.
#' 
#' @param fileName a \code{character} string representing the name of the
#' CX JSON file that is created when Cytoscape is not running. The name
#' must have a '.cx' extension.
#' 
#' 
#' @return \code{TRUE} when all arguments are valid
#'
#' @examples
#'
#' ## Load the result of an enrichment analysis done with gprofiler2
#' data(demoGOST)
#'
#' ## Check that all arguments are valid
#' enrichViewNet:::validateCreateNetworkArguments(gostObject=demoGOST,
#'     source="GO:BP", termIDs=NULL, removeRoot=FALSE, query=NULL, 
#'     title="Network graph Test",
#'     collection="test collection", fileName="test.cx")
#'
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @importFrom methods is
#' @importFrom stringr str_ends
#' @keywords internal
validateCreateNetworkArguments <- function(gostObject, source, termIDs,
                        removeRoot, query, title, collection, fileName) {
    
    ## Test that gostObject is a gprofiler2 result
    if (!(inherits(gostObject, "list") && "result" %in% names(gostObject) &&
            "meta" %in% names(gostObject))) {
        stop("The gostObject object should be a list with meta ",
                "and result as entries corresponding to gprofiler2 ",
                "enrichment output.")
    }
    
    if (!is.null(query) & !is.character(query)) {
        stop("The \'query\' parameter must be a character string or \'NULL\'.")
    }
    
    if (source != "TERM_ID") {
        if (sum(gostObject$result$source == source) < 1) {
            stop("There is no enriched term for the selected ",
                    "source \'", source, "\'.")
        }
    } else {
        if (is.null(termIDs)) {
            stop("A vector of terms should be given through the ",
                    "\'termIDs\' parameter when source is \'TERM_ID\'.")
        }
        else {
            if(!all(termIDs %in% gostObject$result$term_id)) {
                stop("Not all listed terms are present in the  ",
                        "enrichment results.")
            }
        }
    }
    
    if (!is.logical(removeRoot)) {
        stop("The \'removeRoot\' parameter must be the logical ",
                "value TRUE or FALSE.")
    }
    
    if (!is.character(title)) {
        stop("The \'title\' parameter must a character string.")
    }
    
    if (!is.character(collection)) {
        stop("The \'collection\' parameter must a character string.")
    }
    
    if (!is.character(fileName)) {
        stop("The \'fileName\' parameter must a character string.")
    }
    
    if (str_ends(fileName, ".cx", negate = TRUE)) {
        stop("The \'fileName\' parameter must have \'.cx\' extension.")
    }
    
    return(TRUE)
}


#' @title Filter the results to retain only the selected terms
#'
#' @description Filter the enrichment results to retain only the selected 
#' terms and remove root term if requested.
#'
#' @param gostResults a \code{data.frame} containing the enriched terms that 
#' should be filtered.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network or \code{NULL}.
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present).
#'
#' @return a \code{data.frame} of filtered terms with or without the root term.
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(demoGOST)
#'
#' ## Only retained the GO - Molecular Function results
#' results <- demoGOST$result
#'
#' ## Remove WIKIPATHWAYS root term
#' selected <- enrichViewNet:::filterResults(gostResults=results, source="WP", 
#'     termIDs=NULL, removeRoot=TRUE)
#'
#'
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
filterResults <- function(gostResults, source, termIDs, removeRoot) {
    
    ## Filter results
    if (source == "TERM_ID") {
        gostResults <- gostResults[gostResults$term_id %in% termIDs,]
    } else {
        gostResults <- gostResults[gostResults$source == source,]
    }
    
    ## Remove root term if required
    if (removeRoot) {
        gostResults <- removeRootTerm(gostResults)
    }
    
    return(gostResults)
}


#' @title Remove root term if present in the list of selected terms
#'
#' @description Remove root term if present in the list of selected terms
#'
#' @param gostResult a \code{data.frame} containing the terms retained
#' for the creation of the network.
#'
#' @return a \code{data.frame} of selected terms without the root term.
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(demoGOST)
#'
#' ## Only retained the WikiPathways results
#' results <- demoGOST$result[demoGOST$result$source == "WP", ]
#'
#' ## Remove WIKIPATHWAYS root term
#' enrichViewNet:::removeRootTerm(gostResult=results)
#'
#'
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
removeRootTerm <- function(gostResult) {
    
    ## Root terms that should be removed
    
    term_id <- c("WP:000000", "KEGG:00000", "REAC:0000000",
                    "CORUM:0000000", "TF:M00000", "MIRNA:000000",
                    "HPA:0000000", "GO:0008150", "GO:0005575", "GO:0003674")
    
    
    test <- which(gostResult$term_id %in% term_id)
    if (length(test) > 0) {
        gostResult <- gostResult[-c(test), ]
    }
    
    ## Reset row names
    rownames(gostResult) <- NULL
    
    return(gostResult)
}


#' @title Extract node and edge information from the enrichment results
#'
#' @description Create a list containing all node and edge information needed
#' to create the network
#'
#' @param gostResults a \code{data.frame} containing the terms retained
#' for the creation of the network. The \code{data.frame} does not contain a
#' column called "intersection".
#'
#' @param gostObject a \code{list} created by gprofiler2 that contains
#' the results from an enrichment analysis.
#'
#' @return \code{list} containing 2 entries:
#' \itemize{
#' \item{\code{"geneNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are genes.}
#' \item{\code{"termNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are terms.}
#' \item{\code{"edges"}: a \code{data.frame} containing the information about
#' the edges present in the network. The edges connect one gene to one term.}
#' }
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Only retained the GO Molecular Function results
#' results <- parentalNapaVsDMSOEnrichment$result[
#'         parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]
#'
#' ## Extract node and edge information
#' information <-
#'     enrichViewNet:::extractNodesAndEdgesInformation(
#'         gostResults=results, gostObject=parentalNapaVsDMSOEnrichment)
#'
#' @author Astrid Deschênes
#' @importFrom stringr str_split
#' @encoding UTF-8
#' @keywords internal
extractNodesAndEdgesInformation <- function(gostResults, gostObject) {

    
    ## Extract node and edge information to be used to create network
    if (! "intersection" %in% colnames(gostResults)) {
        entriesL <- extractInformationWhenNoIntersection(
            gostResults=gostResults, gostObject=gostObject)
    } else {
        entriesL <- extractInformationWhenIntersection(
            gostResults=gostResults)
    }

    return(entriesL)       
}

#' @title Extract node and edge information to be used to create network 
#' when interaction column is present
#'
#' @description Create a list containing all node and edge information needed
#' to create the network
#'
#' @param gostResults a \code{data.frame} containing the terms retained
#' for the creation of the network. The \code{data.frame} must contain a
#' column called "intersection".
#'
#' @return \code{list} containing 2 entries:
#' \itemize{
#' \item{\code{"geneNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are genes.}
#' \item{\code{"termNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are terms.}
#' \item{\code{"edges"}: a \code{data.frame} containing the information about
#' the edges present in the network. The edges connect one gene to one term.}
#' }
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Only retained the GO Molecular Function results
#' results <- parentalNapaVsDMSOEnrichment$result[
#'         parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]
#'
#' ## Extract node and edge information
#' information <-
#'     enrichViewNet:::extractInformationWhenIntersection(
#'         gostResults=results)
#'
#' @author Astrid Deschênes
#' @importFrom stringr str_split
#' @encoding UTF-8
#' @keywords internal
extractInformationWhenIntersection <- function(gostResults) {
    
    geneInter <- unique(unlist(str_split(gostResults$intersection, ",")))
    
    resEdge <- do.call(rbind, lapply(seq_len(nrow(gostResults)),
        FUN=function(x, gostResults){
            genes <- geneInter[geneInter %in% 
                        unlist(str_split(gostResults$intersection[x], ","))]
            nbEntries <- length(genes)
            df <- NULL
            if (gostResults$intersection_size[x] > 0) {
                df <- data.frame(term=rep(gostResults$term_id[x], nbEntries),
                        termName=rep(gostResults$term_name[x], nbEntries),
                        gene=genes,
                        geneName=genes,
                        query=gostResults$query[x], stringsAsFactors=FALSE)
            }
            return(df)
        }, gostResults=gostResults))
    
    ## Create node entries for the genes
    geneUnique <- resEdge[!duplicated(resEdge$gene),]
    geneNodes <- data.frame(id=geneUnique$gene,
                                group=rep("GENE", nrow(geneUnique)),
                                alias=c(geneUnique$geneName),
                                stringsAsFactors=FALSE)
    
    ## Create node entries for the term
    termUnique <- resEdge[!duplicated(resEdge$term),]
    termNodes <- data.frame(id=termUnique$term,
                                group=rep("TERM", nrow(termUnique)),
                                alias=termUnique$termName,
                                stringsAsFactors=FALSE)
    
    ## Create an edge connecting term (source) to gene (target)
    edges <- data.frame(source=resEdge$term,
                            target=resEdge$gene,
                            interaction=rep("contains", nrow(resEdge)),
                            stringsAsFactors=FALSE)
    
    return(list(geneNodes=geneNodes, termNodes=termNodes, edges=edges))
}

#' @title Extract information about nodes and edges to be used to create 
#' network when interaction column is missing
#'
#' @description Create a list containing all node and edge information needed
#' to create the network
#'
#' @param gostResults a \code{data.frame} containing the terms retained
#' for the creation of the network. The \code{data.frame} does not contain a
#' column called "intersection".
#'
#' @param gostObject a \code{list} created by gprofiler2 that contains
#' the results and meta-data from an enrichment analysis.
#'
#' @return \code{list} containing 2 entries:
#' \itemize{
#' \item{\code{"geneNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are genes.}
#' \item{\code{"termNodes"}: a \code{data.frame} containing the information 
#' about the nodes present in the network. The nodes are terms.}
#' \item{\code{"edges"}: a \code{data.frame} containing the information about
#' the edges present in the network. The edges connect one gene to one term.}
#' }
#' 
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(demoGOST)
#'
#' ## Only retained the WikiPathways results
#' results <- demoGOST$result[demoGOST$result$source == "WP", ]
#'
#' information <- enrichViewNet:::extractInformationWhenNoIntersection(
#'                 gostResults=results, gostObject=demoGOST)
#'
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @encoding UTF-8
#' @keywords internal
extractInformationWhenNoIntersection <- function(gostResults, gostObject) {
    
    listQuery <- unique(gostResults$query)
    
    query <- listQuery[1]
    
    ## List of Ensembl genes
    listGenes <- unique(gostObject$meta$genes_metadata$query[[query]]$ensgs)
    
    ## Extract information about the enriched terms from database
    gostQuery <- gostResults[which(gostResults$query == query),]
    listTerm <- gostQuery[!duplicated(gostQuery$term_id), 
                                            c("term_id", "term_name")]
    res <- gconvert(query=c(listTerm$term_id), 
                    organism=gostObject$meta$query_metadata$organism)
    
    ## Create a data.frame linking gene and term
    resEdge <- do.call(rbind, lapply(seq_len(nrow(listTerm)),
        FUN=function(x, listTerm, listGenes, resTerm=res, query){
            tmp <- which(resTerm$input == listTerm$term_id[x] & 
                                resTerm$target %in% listGenes)
            df <- NULL
            if(length(tmp) > 0) {
                res <- resTerm[tmp,]
                df <- data.frame(term=rep(listTerm$term_id[x], nrow(res)),
                            termName=rep(listTerm$term_name[x], nrow(res)),
                            gene=res$target,
                            geneName=res$name,
                            query=query,
                            stringsAsFactors = FALSE)
            }
            return(df)
        },
        listTerm=listTerm,
        listGenes=listGenes,
        resTerm=res,
        query=query))
    
    geneUnique <- resEdge[!duplicated(resEdge$gene),]
    
    ## Create node entries for the genes
    geneNodes <- data.frame(id=geneUnique$gene, group="GENE",
                                alias=geneUnique$geneName,
                                stringsAsFactors=FALSE,
                                check.names=FALSE)
    
    termUnique <- resEdge[!duplicated(resEdge$term),]
    
    ## Create node entries for the terms
    termNodes <- data.frame(id=termUnique$term, group="TERM",
                                alias=termUnique$termName,
                                stringsAsFactors=FALSE,
                                check.names=FALSE)
    
    ## Create an edge connecting term to gene
    edges <- data.frame(source=resEdge$term, target=resEdge$gene,
                            interaction="contains",
                            stringsAsFactors=FALSE,
                            check.names=FALSE)
    
    rownames(geneNodes) <- NULL
    rownames(termNodes) <- NULL
    rownames(edges) <- NULL
    
    return(list(geneNodes=geneNodes, termNodes=termNodes, edges=edges))
}


#########################################################################
## CX JSON section
#########################################################################


#' @title Create meta data section for the CX JSON file
#'
#' @description Create meta data section for the CX JSON file that contains
#' the network information
#'
#' @return a \code{JSON} object that contains the meta data section related
#' to the network
#'
#' @examples
#'
#' ## Create the JSON object that contains the meta data information
#' enrichViewNet:::createMetaDataSectionCXJSON()
#'
#' @author Astrid Deschênes
#' @importFrom jsonlite toJSON
#' @encoding UTF-8
#' @keywords internal
createMetaDataSectionCXJSON <- function() {
    
    name <- c("nodes", "edges", "edgeAttributes", "nodeAttributes",
                "cyHiddenAttributes", "cyNetworkRelations", "cyGroups",
                "networkAttributes", "cyTableColumn", "cySubNetworks")
    
    metaData <- data.frame(name=name, version=rep("1.0", length(name)),
                            stringsAsFactors=FALSE)
    
    return(toJSON(list(metaData=metaData)))
}


#' @title Create network and load it into Cytoscape
#'
#' @description Create network from gprofiler2 results and load it
#' into Cytoscape
#'
#' @param nodeEdgeInfo a TODO
#' @param title a \code{character} string representing the name assigned to
#' the network.
#'
#' @param collection a \code{character} string representing the collection
#' name assigned to the network.
#'
#' @return \code{TRUE}
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Only retained the GO Molecular Function results
#' results <- parentalNapaVsDMSOEnrichment$result[
#'         parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]
#'
#' ## Extract node and edge information
#' information <- enrichViewNet:::extractInformationWhenIntersection(
#'         gostResults=results)
#'     
#' ## The creation of the network can only be done when Cytoscape
#' ## is up and running
#' ## A network using GO - Molecular Function enriched terms will be
#' ## generated and loaded into Cytoscape
#' if (enrichViewNet:::isCytoscapeRunning()) {
#'     enrichViewNet:::createNetworkForCytoscape(nodeEdgeInfo=information, 
#'         title="Test", collection="New Collection")
#' }
#'
#' @author Astrid Deschênes
#' @importFrom RCy3 createNetworkFromDataFrames setNodeColorMapping
#' @importFrom RCy3 setNodeLabelBypass setNodeWidthMapping
#' @encoding UTF-8
#' @keywords internal
createNetworkForCytoscape <- function(nodeEdgeInfo, title, collection) {
    
    nodes <- rbind(nodeEdgeInfo$termNodes, nodeEdgeInfo$geneNodes)
    
    ## Create the network using JSON data format and posting it to Cytoscape
    createNetworkFromDataFrames(nodes=nodes, 
        edges=nodeEdgeInfo$edges, title=title, collection=collection)
    
    ## Assign different colors to terms and genes
    column <- 'group'
    control.points <- c("TERM", "GENE")
    setNodeColorMapping(table.column=column,
        table.column.values=control.points, colors=c('#ffba42', '#99CCFF'),
        mapping.type="discrete", style.name="default")
    
    ## Override the node labels to use the term descriptions and gene names
    setNodeLabelBypass(node.names=nodes$id, new.labels=nodes$alias)
    
    ## Assign larger node widths to terms and smaller ones to genes
    setNodeWidthMapping(table.column=column,
        table.column.values=control.points, widths=c(100, 75),
        mapping.type="discrete", style.name="default")
    
    return(TRUE)
}


#' @title Transform the node and edge information into a format easy to process 
#' to create a CX JSON text file
#'
#' @description Extract information about nodes and edges that is necessary
#' to create the CX JSON text representing the network
#'
#' @param results a \code{list} containing the information about the 
#' nodes and edges present in the network. TODOS
#'
#' @return a \code{list} containing 4 entries:
#' \itemize{
#' \item{\code{"nodes"}: a \code{data.frame} containing the information about
#' the nodes present in the network.}
#' \item{\code{"edges"}: a \code{data.frame} containing the information about
#' the edges present in the network.}
#' \item{\code{"nodeAttributes"}: a \code{data.frame} containing the attributes
#' associated to the nodes present in the network.}
#' \item{\code{"edgesAttributes"}: a \code{data.frame} containing the 
#' attributes associated to the edges present in the network}
#' }
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Only retained the GO Molecular Function results
#' results <- parentalNapaVsDMSOEnrichment$result[
#'         parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]
#'
#' ## Extract node and edge information
#' info <- enrichViewNet:::extractNodesAndEdgesInformation(gostResults=results, 
#'             gostObject=parentalNapaVsDMSOEnrichment)
#'             
#' ## Format node and edge information
#' information <- enrichViewNet:::formatInformationForCXJSON(result=info)
#'
#' @author Astrid Deschênes
#' @encoding UTF-8
#' @keywords internal
formatInformationForCXJSON <- function(results) {

    #####################    
    ## Gene section
    
    nbGenes <- nrow(results$geneNodes)
    results$geneNodes$gene_id <- seq_len(nbGenes)
        
    ## Create node entries for the gene
    geneNodes <- data.frame('@id'=results$geneNodes$gene_id,
        n=results$geneNodes$id, stringsAsFactors=FALSE, check.names=FALSE)
    
    ## Create node attribute entries for the gene alias and group
    geneAttributes  <- data.frame(
        po=rep(seq_len(nbGenes), 2),
        n=c(rep("alias", nbGenes), rep("group", nbGenes)),
        v=c(results$geneNodes$alias, rep("GENE", nbGenes)),
        stringsAsFactors=FALSE)
    rownames(geneNodes) <- geneNodes$n
    
    #####################    
    ## Term section
    
    # Offset for the id
    termOffSet <- nbGenes
    nbTerms <- nrow(results$termNodes)
    results$termNodes$term_id <- seq_len(nbTerms) + termOffSet
    
    ## Create node entries for the term
    termNodes <- data.frame('@id'= results$termNodes$term_id,
        n=results$termNodes$id, stringsAsFactors=FALSE, check.names=FALSE)
    
    ## Create node attribute entries for the term alias and the term group
    termAttributes  <- data.frame(
        po=rep(results$termNodes$term_id, 2) ,
        n=c(rep("alias", nbTerms), rep("group", nbTerms)),
        v=c(results$termNodes$alias, rep("TERM", nbTerms)),
        stringsAsFactors=FALSE)
    rownames(termNodes) <- termNodes$n
    
    #####################    
    ## Edge section
    
    # Offset for the id
    edgeOffSet <- termOffSet + nbTerms
    nbEdges <- nrow(results$edges)
    
    edge_gene <- merge(results$edges, results$geneNodes[, c("id", "gene_id")], 
                        by.x="target", by.y="id", all.x=TRUE)
    edge_term <- merge(results$edges, results$termNodes[, c("id", "term_id")], 
                        by.x="source", by.y="id", all.x=TRUE)
    
    ## Create an edge connecting term to gene
    edges <- data.frame('@id'=seq_len(nbEdges) + edgeOffSet,
                        s=edge_term$term_id,
                        t=edge_gene$gene_id,
                        i=rep("contains", nbEdges),
                        stringsAsFactors=FALSE, check.names=FALSE)
    
    ## Create edge attributes
    edgeAttributes <- data.frame(
        po=rep(edges[,'@id'], 3),
        n=c(rep("name", nbEdges), rep("source", nbEdges),
            rep("target", nbEdges)),
        v=c(paste0(results$edges$source, " (contains) ", results$edges$target),
            results$edges$source, results$edges$target),
        stringsAsFactors=FALSE)
    
    rownames(geneNodes) <- NULL
    rownames(termNodes) <- NULL
    
    return(list(nodes=rbind(geneNodes, termNodes), edges=edges,
                nodeAttributes=rbind(geneAttributes, termAttributes),
                edgeAttributes=edgeAttributes))
}


#' @title Create CX JSON text representing the network
#'
#' @description Create a CX JSON text that represent the network which
#' includes information about nodes and edges present in the network.
#'
#' @param nodeEdgeInfo a \code{list} created by gprofiler2 that contains
#' the results from an enrichment analysis. TODO
#'
#' @param title a \code{character} string representing the name assigned to
#' the network.
#'
#' @return \code{character} string that represent the network in a CX JSON
#' format.
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#'
#' ## Only retained the GO Molecular Function results
#' results <- parentalNapaVsDMSOEnrichment$result[
#'         parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]
#'
#' ## Extract node and edge information
#' information <- enrichViewNet:::extractInformationWhenIntersection(
#'         gostResults=results)
#'
#' jsonFormat <- enrichViewNet:::createCXJSONForCytoscape(
#'                 nodeEdgeInfo=information, title="WikiPathways")
#'
#' @author Astrid Deschênes
#' @importFrom jsonlite toJSON
#' @encoding UTF-8
#' @keywords internal
createCXJSONForCytoscape <- function(nodeEdgeInfo, title) {

    entriesL <- formatInformationForCXJSON(results=nodeEdgeInfo)
    
    networkAttributes <- data.frame(n=c("name"), v=c(title), 
                                            stringsAsFactors=FALSE)
    
    cyHiddenAttributes <- data.frame(n=c("layoutAlgorithm"),
        y=c("yFiles Circular Layout"), stringsAsFactors=FALSE)
    
    metaData <- createMetaDataSectionCXJSON()
    
    ## Create the network using JSON data format and posting it to Cytoscape
    result <- paste0("[", metaData, ",",
            toJSON(list(networkAttributes=networkAttributes)), ",",
            toJSON(list(nodes=entriesL$nodes)), ",",
            toJSON(list(edges=entriesL$edges)), ",",
            toJSON(list(nodeAttributes=entriesL$nodeAttributes)), ",",
            toJSON(list(edgeAttributes=entriesL$edgeAttributes)), ",",
            toJSON(list(cyHiddenAttributes=cyHiddenAttributes)), ",",
            metaData, ",{\"status\":[{\"error\":\"\",\"success\":true}]}]")
    
    return(result)
}

### Unit tests for methods.R functions

library(enrichViewNet)

data("demoGOST")

### Tests createNetwork() results

context("createNetwork() results")

test_that("createNetwork() must return error when gostObject is a number", {

    error_message <- paste0("The gostObject object should be a list ", 
                        "with meta and result as entries corresponding ", 
                        "to gprofiler2 enrichment output.")
    
    expect_error(createNetwork(gostObject=33), error_message)
})

test_that("createNetwork() must return error when gostObject is a string character", {

    error_message <- paste0("The gostObject object should be a list ", 
                        "with meta and result as entries corresponding ", 
                        "to gprofiler2 enrichment output.")
    
    expect_error(createNetwork(gostObject="TEST"), error_message)
})

test_that("createNetwork() must return error when source is a number", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    error_message <- paste0("Assertion on 'arg' failed: Must be of type ", 
                                "'character', not 'double'.")
    
    expect_error(createNetwork(gostObject=gostObject, source=33), 
                    error_message)
})

test_that("createNetwork() must return error when source is a wrong name", {

    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    expect_error(createNetwork(gostObject=gostObject, source="test"))
})


test_that("createNetwork() must return error when source is GO", {
    
    gostObject <- list()
    gostObject[["meta"]] <- list()
    gostObject[["result"]] <- list()
    
    expect_error(createNetwork(gostObject=gostObject, source="GO"))
})


test_that("createNetwork() must return error when query not present in the GOST object", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("With selected query, there is no enrichment term")
    
    expect_error(createNetwork(gostObject=gostTerm, source="WP", 
                               query="Information",
                               removeRoot=TRUE), error_message)
})


test_that("createNetwork() must return error when query is a number", {
    
    gostTerm <- demoGOST
    
    error_message <- paste0("The \'query\' parameter must be a character ", 
                                "string or \'NULL\'.")
    
    expect_error(createNetwork(gostObject=gostTerm, source="WP", query=33, 
                               removeRoot=TRUE), error_message)
})


test_that("createNetwork() must return error when removeRoot remove last enriched term", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- paste0("After filtering on the enriched terms, there is ", 
                                    "no enrichment term left")
    
    expect_error(createNetwork(gostObject=gostTerm, source="WP", 
                    removeRoot=TRUE), error_message)
})


test_that("createNetwork() must return error when removeRoot remove last enriched term from term list", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- paste0("After filtering on the enriched terms, there is ", 
                                "no enrichment term left")
    
    expect_error(createNetwork(gostObject=gostTerm, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=TRUE), error_message)
})


test_that("createNetwork() must return error when collection is a number", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- "The \'collection\' parameter must a character string."
    
    expect_error(createNetwork(gostObject=gostTerm, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=FALSE, collection=33), error_message)
})


test_that("createNetwork() must return error when fileName is a number", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- "The \'fileName\' parameter must a character string."
    
    expect_error(createNetwork(gostObject=gostTerm, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=FALSE, fileName=33), error_message)
})


test_that("createNetwork() must return error when fileName is a logical", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- "The \'fileName\' parameter must a character string."
    
    expect_error(createNetwork(gostObject=gostTerm, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=FALSE, fileName=FALSE), 
        error_message)
})


test_that("createNetwork() must return error when fileName has .txt extension", {
    
    gostTerm <- demoGOST
    gostTerm$result <- demoGOST$result[54,]
    
    error_message <- "The \'fileName\' parameter must have \'.cx\' extension."
    
    expect_error(createNetwork(gostObject=gostTerm, source="TERM_ID",
        termIDs=c("WP:000000"), removeRoot=FALSE, fileName="toto.txt"), 
        error_message)
})


test_that("createNetwork() must return error when no query set and more than one query present", {
    
    gostTerm <- demoGOST
    gostTerm$result$query[1] <- "Test negative"
    
    error_message <- paste0("Multiple queries are present in the results, ",
        "the \'query\' parameter should be used to select one")
    
    expect_error(createNetwork(gostObject=gostTerm, source="CORUM", 
        removeRoot=FALSE, fileName="toto.cx"), error_message)
})


test_that("createNetwork() must return TRUE when all parameters ok and not cytoscape open", {
    
    gostTerm <- demoGOST
    
    tmpDir <- tempdir()
    tmpFile <- paste0(tmpDir, "/toto_0001.cx")
    
    
    if (!isCytoscapeRunning() && !file.exists(tmpFile)) {
        result <- createNetwork(gostObject=gostTerm, source="CORUM", 
                            removeRoot=FALSE, fileName=tmpFile)
    
        expect_true(result)
        expect_true(file.exists(tmpFile))
    }
    
    if (file.exists(tmpFile)) {
        file.remove(tmpFile)
    }
})

### Unit tests for methodsInternal.R functions

library(enrichViewNet)

data(demoGOST)
data(parentalNapaVsDMSOEnrichment)


### Tests isCytoscapeRunning() results

context("isCytoscapeRunning() results")

test_that("isCytoscapeRunning() must return an logical value", {
    
    expect_is(enrichViewNet:::isCytoscapeRunning(), "logical")
})


### Tests validateCreateNetworkArguments() results

context("validateCreateNetworkArguments() results")

test_that("validateCreateNetworkArguments() must return TRUE when all parameters are good", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                      term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    result <- enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source="GO:BP", termIDs=NULL, removeRoot=FALSE,
        query="test", title="Network", collection="test collection", 
        fileName="new.cx")
    
    expect_true(result)
})

test_that("validateCreateNetworkArguments() must return error when no enriched term and all parameters are good", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                        term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    source <- "REAC"
    
    error_message <- paste0("There is no enriched term for the selected ", 
                            "source \'", source, "\'.")
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source=source, termIDs=NULL, removeRoot=FALSE,
        fileName="hello.cx", query=NULL), error_message)
    
})

test_that("validateCreateNetworkArguments() must return error when source is TERM_ID and termIDs is NULL", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"),2), 
                                      term_id=c("GO:0051171","GO:0010604"))
    gostObj[["meta"]] <- list()
    
    source <- "TERM_ID"
    
    error_message <- paste0("A vector of terms should be given through", 
                    " the \'termIDs\' parameter when source is \'TERM_ID\'.")
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source=source, termIDs=NULL, removeRoot=FALSE, 
        fileName="toto.cx", query=NULL), error_message)
    
})

test_that("validateCreateNetworkArguments() must return error when not all term IDS exist", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"),2), 
                                      term_id=c("GO:0051171","GO:0010604"))
    gostObj[["meta"]] <- list()
    
    source <- "TERM_ID"
    
    error_message <- paste0("Not all listed terms are present in the  ",
                                "enrichment results.")
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source=source, 
        termIDs=c("GO:0051171","GO:0010999"), removeRoot=FALSE, 
        fileName="toto.cx", query=NULL), error_message)
})


test_that("validateCreateNetworkArguments() must return error when removeRoot is a string", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"),2), 
                                        term_id=c("GO:0051171","GO:0010604"))
    gostObj[["meta"]] <- list()
    
    source <- "TERM_ID"
    
    error_message <- paste0("The \'removeRoot\' parameter must be the logical ", 
                                "value TRUE or FALSE.")
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source=source, termIDs=c("GO:0051171"), 
        removeRoot="HI", fileName="test.cx", query=NULL), error_message)
})


test_that("validateCreateNetworkArguments() must return term IDs are good", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                        term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    result <- enrichViewNet:::validateCreateNetworkArguments(
            gostObject=gostObj, source="TERM_ID", 
            termIDs=c("GO:0051171", "GO:0010604"), removeRoot=FALSE, query=NULL, 
            collection="Collection", title="Network", fileName="test.cx")
    
    expect_true(result)
})


test_that("validateCreateNetworkArguments() must return error when Collection is not a string character", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                        term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    error_message <- "The \'collection\' parameter must a character string."
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject = gostObj, source = "GO:BP", termIDs = NULL, 
        removeRoot = FALSE, query=NULL, collection=22,
        title="Test", fileName="file.cx"), error_message)
})


test_that("validateCreateNetworkArguments() must return error when title is not a string character", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                      term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    error_message <- "The \'title\' parameter must a character string."
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject = gostObj, source = "GO:BP", termIDs = NULL, 
        removeRoot = FALSE, query=NULL, collection="Test",
        title=111, fileName="file.cx"), error_message)
})


test_that("validateCreateNetworkArguments() must return error when fileName is not a string character", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                        term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    error_message <- "The \'fileName\' parameter must a character string."
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject = gostObj, source = "GO:BP", termIDs = NULL, 
        removeRoot = FALSE, query=NULL, collection="Collection test",
        title="Test", fileName = 231), error_message)
})


test_that("validateCreateNetworkArguments() must return error when fileName not ending with .cx", {
    
    gostObj <- list()
    gostObj[["result"]] <- data.frame(source=c(rep("GO:BP"), 2), 
                                        term_id=c("GO:0051171", "GO:0010604"))
    gostObj[["meta"]] <- list()
    
    error_message <- "The \'fileName\' parameter must have \'.cx\' extension."
    
    expect_error(enrichViewNet:::validateCreateNetworkArguments(
        gostObject=gostObj, source="GO:BP", termIDs=NULL, 
        removeRoot=FALSE, query=NULL, collection="Collection test", 
        title="Test", fileName="toto.txt"), error_message)
})


### Tests removeRootTerm() results

context("removeRootTerm() results")

test_that("removeRootTerm() must return same list when not root term present", {
    
    demo <- data.frame(source=c(rep("GO:BP", 3)), 
                        term_id=c("GO:0051171", "GO:0010604", "GO:0014444"))
    
    result <- enrichViewNet:::removeRootTerm(gostResult=demo)
    
    expect_identical(result, demo)
})


test_that("removeRootTerm() must return KEGG root term", {
    
    demo <- data.frame(source=c(rep("GO:BP", 3), rep("KEGG", 2)), 
                       term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                    "KEGG:00000", "KEGG:00010"))
    
    expected <- data.frame(source=c(rep("GO:BP", 3), "KEGG"), 
                       term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                 "KEGG:00010"))
    
    result <- enrichViewNet:::removeRootTerm(gostResult=demo)
    
    expect_identical(result, expected)
})


test_that("removeRootTerm() must return MIRNA root term", {
    
    demo <- data.frame(source=c(rep("GO:BP", 3), "MIRNA", rep("KEGG", 2)), 
                       term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                 "MIRNA:000000", "KEGG:00044", "KEGG:00010"))
    
    expected <- data.frame(source=c(rep("GO:BP", 3), rep("KEGG", 2)), 
                           term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                     "KEGG:00044", "KEGG:00010"))
    
    result <- enrichViewNet:::removeRootTerm(gostResult=demo)
    
    expect_identical(result, expected)
})


test_that("removeRootTerm() must return GO:MF root term", {
    
    demo <- data.frame(source=c(rep("GO:BP", 3), "GO:MF", rep("KEGG", 2)), 
                       term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                 "GO:0003674", "KEGG:00044", "KEGG:00010"))
    
    expected <- data.frame(source=c(rep("GO:BP", 3), rep("KEGG", 2)), 
                           term_id=c("GO:0051171", "GO:0010604", "GO:0014444",
                                     "KEGG:00044", "KEGG:00010"))
    
    result <- enrichViewNet:::removeRootTerm(gostResult=demo)
    
    expect_identical(result, expected)
})


### Tests createMetaDataSectionCXJSON() results

context("createMetaDataSectionCXJSON() results")

test_that("createMetaDataSectionCXJSON() must return expected text", {
    
    set.seed(121)
    
    expected <- paste0(
        "{\"metaData\":[{\"name\":\"nodes\",\"version\":\"1.0\"},", 
        "{\"name\":\"edges\",\"version\":\"1.0\"},",
        "{\"name\":\"edgeAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"nodeAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyHiddenAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyNetworkRelations\",\"version\":\"1.0\"},",
        "{\"name\":\"cyGroups\",\"version\":\"1.0\"},", 
        "{\"name\":\"networkAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyTableColumn\",\"version\":\"1.0\"},",
        "{\"name\":\"cySubNetworks\",\"version\":\"1.0\"}]}")
    
    result <- enrichViewNet:::createMetaDataSectionCXJSON()
    
    expect_identical(as.character(result), expected)
    expect_s3_class(result, "json")
})


### Tests filterResults() results

context("filterResults() results")

test_that("filterResults() must return expected text", {
  
    results <- parentalNapaVsDMSOEnrichment$result
    
    expected <- results[results$source == "WP" & 
                                results$term_id != "WP:000000", ]
    row.names(expected) <- NULL
    
    selected <- enrichViewNet:::filterResults(gostResults=results, source="WP", 
                         termIDs=NULL, removeRoot=TRUE)
    row.names(selected) <- NULL
    
    expect_equal(selected, expected)
})


### Tests extractInformationWhenIntersection() results

context("extractInformationWhenIntersection() results")

test_that("extractInformationWhenIntersection() must return expected text", {
    
    set.seed(1212)
    
    ccDemo <- parentalNapaVsDMSOEnrichment
    
    ccData <- ccDemo$result[ccDemo$result$term_id %in% 
                                    c("WP:WP1742", "WP:WP410"), ]
    
    result <- enrichViewNet:::extractInformationWhenIntersection(
        gostResults=ccData)
    
    expected <- list()
    
    expected[["geneNodes"]] <- data.frame(
        "id"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
                "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
                "ENSG00000172216"),
        "group"=rep("GENE", 7),
        "alias"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
                    "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
                    "ENSG00000172216"),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["termNodes"]] <- data.frame(
        "id"=c("WP:WP1742", "WP:WP410"),
        "group"=c("TERM", "TERM"),
        "alias"=c("TP53 network", "Exercise-induced circadian regulation"),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["edges"]] <- data.frame(
        "source"=c("WP:WP1742", "WP:WP1742", "WP:WP1742", "WP:WP410", 
                    "WP:WP410", "WP:WP410", "WP:WP410"),
        "target"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
                    "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
                    "ENSG00000172216"),
        "interaction"=rep("contains", 7),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expect_identical(result, expected)
})


### Tests extractInformationWhenNoIntersection() results

context("extractInformationWhenNoIntersection() results")

test_that("extractInformationWhenNoIntersection() must return expected text", {
    
    mirnaDemo <- demoGOST
    
    mirnaDemo$meta$query_metadata$queries[[1]] <- 
        mirnaDemo$meta$query_metadata$queries[[1]][1:3]
    
    mirnaData <- demoGOST$result[demoGOST$result$source == "MIRNA", ]
    
    set.seed(121)
    gprofiler2::set_base_url("https://biit.cs.ut.ee/gprofiler_archive3/e111_eg58_p18")
    result <- enrichViewNet:::extractInformationWhenNoIntersection(
                    gostResults=mirnaData, gostObject=mirnaDemo)
    
    expected <- list()
    
    expected[["geneNodes"]] <- data.frame("id"=c("ENSG00000059728", 
                    "ENSG00000077616", "ENSG00000100292", "ENSG00000107968", 
                    "ENSG00000108551", "ENSG00000113369", "ENSG00000051108", 
                    "ENSG00000087074", "ENSG00000105327"),
                    group=rep("GENE", 9), 
                    alias=c("MXD1", "NAALAD2", "HMOX1", "MAP3K8", "RASD1", 
                            "ARRDC3", "HERPUD1", "PPP1R15A", "BBC3"),
                    check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["termNodes"]] <- data.frame(id=c("MIRNA:hsa-miR-335-5p", 
                    "MIRNA:hsa-miR-3180-5p", "MIRNA:hsa-miR-759"),
                    group=rep("TERM", 3), 
                    alias=c("hsa-miR-335-5p", 
                             "hsa-miR-3180-5p", "hsa-miR-759"),
                    check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["edges"]] <- data.frame(
        "source"=c(rep("MIRNA:hsa-miR-335-5p", 7),  
                    rep("MIRNA:hsa-miR-3180-5p", 3), 
                    rep("MIRNA:hsa-miR-759", 3)), 
        target=c("ENSG00000059728", "ENSG00000077616", "ENSG00000100292", 
                    "ENSG00000107968", "ENSG00000108551", "ENSG00000113369",
                    "ENSG00000051108", "ENSG00000087074",
                    "ENSG00000100292", "ENSG00000059728", "ENSG00000051108",
                    "ENSG00000059728", "ENSG00000105327"),
        interaction=rep("contains", 13),
        check.names=FALSE, stringsAsFactors=FALSE)
        
    expect_equal(result$geneNodes, expected$geneNodes)
    expect_equal(result$termNodes, expected$termNodes)
    expect_equal(result$edges, expected$edges)
})


### Tests createCXJSONForCytoscape() results

context("createCXJSONForCytoscape() results")

test_that("createCXJSONForCytoscape() must return expected text", {
    
    mirnaDemo <- demoGOST
    mirnaDemo$meta$query_metadata$queries[[1]] <- 
        mirnaDemo$meta$query_metadata$queries[[1]][1:2]
    mirnaData <- demoGOST$result[demoGOST$result$source == "MIRNA", ]
    
    set.seed(121)
    
    info <- enrichViewNet:::extractNodesAndEdgesInformation(gostResults=mirnaData, 
                                                gostObject=mirnaDemo)
    result <- enrichViewNet:::createCXJSONForCytoscape(
        nodeEdgeInfo=info, title = "MIRNA")
    
    expected <- paste0(
        "[{\"metaData\":[{\"name\":\"nodes\",\"version\":\"1.0\"},", 
        "{\"name\":\"edges\",\"version\":\"1.0\"},{\"name\":\"edgeAttributes\",",
        "\"version\":\"1.0\"},{\"name\":\"nodeAttributes\",\"version\":\"1.0\"},", 
        "{\"name\":\"cyHiddenAttributes\",\"version\":\"1.0\"},", 
        "{\"name\":\"cyNetworkRelations\",\"version\":\"1.0\"},",
        "{\"name\":\"cyGroups\",\"version\":\"1.0\"},{\"name\":\"networkAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyTableColumn\",\"version\":\"1.0\"},{\"name\":\"cySubNetworks\",\"version\":\"1.0\"}]},",
        "{\"networkAttributes\":[{\"n\":\"name\",\"v\":\"MIRNA\"}]},{\"nodes\":[{\"@id\":1,\"n\":\"ENSG00000059728\"},",
        "{\"@id\":2,\"n\":\"ENSG00000077616\"},{\"@id\":3,\"n\":\"ENSG00000100292\"},{\"@id\":4,\"n\":\"ENSG00000107968\"},", 
        "{\"@id\":5,\"n\":\"ENSG00000108551\"},{\"@id\":6,\"n\":\"ENSG00000113369\"},{\"@id\":7,\"n\":\"ENSG00000051108\"},", 
        "{\"@id\":8,\"n\":\"ENSG00000087074\"},{\"@id\":9,\"n\":\"ENSG00000105327\"},{\"@id\":10,\"n\":\"MIRNA:hsa-miR-335-5p\"},",
        "{\"@id\":11,\"n\":\"MIRNA:hsa-miR-3180-5p\"},{\"@id\":12,\"n\":\"MIRNA:hsa-miR-759\"}]},",
        "{\"edges\":[{\"@id\":13,\"s\":11,\"t\":7,\"i\":\"contains\"},{\"@id\":14,\"s\":11,\"t\":7,\"i\":\"contains\"},",
        "{\"@id\":15,\"s\":11,\"t\":1,\"i\":\"contains\"},{\"@id\":16,\"s\":10,\"t\":1,\"i\":\"contains\"},",
        "{\"@id\":17,\"s\":10,\"t\":1,\"i\":\"contains\"},{\"@id\":18,\"s\":10,\"t\":2,\"i\":\"contains\"},",
        "{\"@id\":19,\"s\":10,\"t\":8,\"i\":\"contains\"},{\"@id\":20,\"s\":10,\"t\":3,\"i\":\"contains\"},",
        "{\"@id\":21,\"s\":10,\"t\":3,\"i\":\"contains\"},{\"@id\":22,\"s\":10,\"t\":9,\"i\":\"contains\"},",
        "{\"@id\":23,\"s\":12,\"t\":4,\"i\":\"contains\"},{\"@id\":24,\"s\":12,\"t\":5,\"i\":\"contains\"},",
        "{\"@id\":25,\"s\":12,\"t\":6,\"i\":\"contains\"}]},{\"nodeAttributes\":[{\"po\":1,\"n\":\"alias\",\"v\":\"MXD1\"},",
        "{\"po\":2,\"n\":\"alias\",\"v\":\"NAALAD2\"},{\"po\":3,\"n\":\"alias\",\"v\":\"HMOX1\"},",
        "{\"po\":4,\"n\":\"alias\",\"v\":\"MAP3K8\"},{\"po\":5,\"n\":\"alias\",\"v\":\"RASD1\"},",
        "{\"po\":6,\"n\":\"alias\",\"v\":\"ARRDC3\"},{\"po\":7,\"n\":\"alias\",\"v\":\"HERPUD1\"},",
        "{\"po\":8,\"n\":\"alias\",\"v\":\"PPP1R15A\"},{\"po\":9,\"n\":\"alias\",\"v\":\"BBC3\"},",
        "{\"po\":1,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":2,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":3,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":4,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":5,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":6,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":7,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":8,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":9,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":10,\"n\":\"alias\",\"v\":\"hsa-miR-335-5p\"},{\"po\":11,\"n\":\"alias\",\"v\":\"hsa-miR-3180-5p\"},",
        "{\"po\":12,\"n\":\"alias\",\"v\":\"hsa-miR-759\"},{\"po\":10,\"n\":\"group\",\"v\":\"TERM\"},",
        "{\"po\":11,\"n\":\"group\",\"v\":\"TERM\"},{\"po\":12,\"n\":\"group\",\"v\":\"TERM\"}]},",
        "{\"edgeAttributes\":[{\"po\":13,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000059728\"},",
        "{\"po\":14,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000077616\"},",
        "{\"po\":15,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000100292\"},",
        "{\"po\":16,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000107968\"},",
        "{\"po\":17,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000108551\"},",
        "{\"po\":18,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000113369\"},",
        "{\"po\":19,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-335-5p (contains) ENSG00000051108\"},",
        "{\"po\":20,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-3180-5p (contains) ENSG00000087074\"},",
        "{\"po\":21,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-3180-5p (contains) ENSG00000100292\"},",
        "{\"po\":22,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-3180-5p (contains) ENSG00000059728\"},",
        "{\"po\":23,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-759 (contains) ENSG00000051108\"},",
        "{\"po\":24,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-759 (contains) ENSG00000059728\"},",
        "{\"po\":25,\"n\":\"name\",\"v\":\"MIRNA:hsa-miR-759 (contains) ENSG00000105327\"},{\"po\":13,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},",
        "{\"po\":14,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},{\"po\":15,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},",
        "{\"po\":16,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},{\"po\":17,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},",
        "{\"po\":18,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},{\"po\":19,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-335-5p\"},",
        "{\"po\":20,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-3180-5p\"},{\"po\":21,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-3180-5p\"},",
        "{\"po\":22,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-3180-5p\"},{\"po\":23,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-759\"},",
        "{\"po\":24,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-759\"},{\"po\":25,\"n\":\"source\",\"v\":\"MIRNA:hsa-miR-759\"},",
        "{\"po\":13,\"n\":\"target\",\"v\":\"ENSG00000059728\"},{\"po\":14,\"n\":\"target\",\"v\":\"ENSG00000077616\"},",
        "{\"po\":15,\"n\":\"target\",\"v\":\"ENSG00000100292\"},{\"po\":16,\"n\":\"target\",\"v\":\"ENSG00000107968\"},",
        "{\"po\":17,\"n\":\"target\",\"v\":\"ENSG00000108551\"},{\"po\":18,\"n\":\"target\",\"v\":\"ENSG00000113369\"},",
        "{\"po\":19,\"n\":\"target\",\"v\":\"ENSG00000051108\"},{\"po\":20,\"n\":\"target\",\"v\":\"ENSG00000087074\"},", 
        "{\"po\":21,\"n\":\"target\",\"v\":\"ENSG00000100292\"},{\"po\":22,\"n\":\"target\",\"v\":\"ENSG00000059728\"},", 
        "{\"po\":23,\"n\":\"target\",\"v\":\"ENSG00000051108\"},{\"po\":24,\"n\":\"target\",\"v\":\"ENSG00000059728\"},", 
        "{\"po\":25,\"n\":\"target\",\"v\":\"ENSG00000105327\"}]},{\"cyHiddenAttributes\":[{\"n\":\"layoutAlgorithm\",\"y\":\"yFiles Circular Layout\"}]},",
        "{\"metaData\":[{\"name\":\"nodes\",\"version\":\"1.0\"},{\"name\":\"edges\",\"version\":\"1.0\"},{\"name\":\"edgeAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"nodeAttributes\",\"version\":\"1.0\"},{\"name\":\"cyHiddenAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyNetworkRelations\",\"version\":\"1.0\"},{\"name\":\"cyGroups\",\"version\":\"1.0\"},",
        "{\"name\":\"networkAttributes\",\"version\":\"1.0\"},{\"name\":\"cyTableColumn\",\"version\":\"1.0\"},",
        "{\"name\":\"cySubNetworks\",\"version\":\"1.0\"}]},{\"status\":[{\"error\":\"\",\"success\":true}]}]")
    
    expect_equal(result, expected)
})


test_that("createCXJSONForCytoscape() must return expected text when intersection column present", {
    
    demo <- parentalNapaVsDMSOEnrichment
    demoData <- demo$result[demo$result$source == "REAC", ][c(11, 18, 20),]
    
    set.seed(121)
    
    info <- enrichViewNet:::extractNodesAndEdgesInformation(gostResults=demoData, 
                                                    gostObject=demo)
    
    result <- enrichViewNet:::createCXJSONForCytoscape(
        nodeEdgeInfo = info, title = "DEMO")
    
    expected <- paste0("[{\"metaData\":[{\"name\":\"nodes\",\"version\":\"1.0\"},",
        "{\"name\":\"edges\",\"version\":\"1.0\"},{\"name\":\"edgeAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"nodeAttributes\",\"version\":\"1.0\"},{\"name\":\"cyHiddenAttributes\",\"version\":\"1.0\"},",
        "{\"name\":\"cyNetworkRelations\",\"version\":\"1.0\"},{\"name\":\"cyGroups\",\"version\":\"1.0\"},",
        "{\"name\":\"networkAttributes\",\"version\":\"1.0\"},{\"name\":\"cyTableColumn\",\"version\":\"1.0\"},",
        "{\"name\":\"cySubNetworks\",\"version\":\"1.0\"}]},{\"networkAttributes\":[{\"n\":\"name\",\"v\":\"DEMO\"}]},",
        "{\"nodes\":[{\"@id\":1,\"n\":\"ENSG00000105327\"},{\"@id\":2,\"n\":\"ENSG00000113916\"},",
        "{\"@id\":3,\"n\":\"ENSG00000153094\"},{\"@id\":4,\"n\":\"ENSG00000175197\"},{\"@id\":5,\"n\":\"ENSG00000100292\"},",
        "{\"@id\":6,\"n\":\"ENSG00000124762\"},{\"@id\":7,\"n\":\"ENSG00000170345\"},{\"@id\":8,\"n\":\"ENSG00000171223\"},",
        "{\"@id\":9,\"n\":\"ENSG00000184557\"},{\"@id\":10,\"n\":\"ENSG00000141682\"},{\"@id\":11,\"n\":\"REAC:R-HSA-9614657\"},",
        "{\"@id\":12,\"n\":\"REAC:R-HSA-6785807\"},{\"@id\":13,\"n\":\"REAC:R-HSA-111453\"}]},",
        "{\"edges\":[{\"@id\":14,\"s\":13,\"t\":5,\"i\":\"contains\"},{\"@id\":15,\"s\":13,\"t\":1,\"i\":\"contains\"},",
        "{\"@id\":16,\"s\":13,\"t\":1,\"i\":\"contains\"},{\"@id\":17,\"s\":12,\"t\":2,\"i\":\"contains\"},",
        "{\"@id\":18,\"s\":12,\"t\":2,\"i\":\"contains\"},{\"@id\":19,\"s\":12,\"t\":6,\"i\":\"contains\"},",
        "{\"@id\":20,\"s\":12,\"t\":10,\"i\":\"contains\"},{\"@id\":21,\"s\":12,\"t\":3,\"i\":\"contains\"},",
        "{\"@id\":22,\"s\":12,\"t\":3,\"i\":\"contains\"},{\"@id\":23,\"s\":11,\"t\":7,\"i\":\"contains\"},",
        "{\"@id\":24,\"s\":11,\"t\":8,\"i\":\"contains\"},{\"@id\":25,\"s\":11,\"t\":4,\"i\":\"contains\"},",
        "{\"@id\":26,\"s\":11,\"t\":9,\"i\":\"contains\"}]},",
        "{\"nodeAttributes\":[{\"po\":1,\"n\":\"alias\",\"v\":\"ENSG00000105327\"},{\"po\":2,\"n\":\"alias\",\"v\":\"ENSG00000113916\"},",
        "{\"po\":3,\"n\":\"alias\",\"v\":\"ENSG00000153094\"},{\"po\":4,\"n\":\"alias\",\"v\":\"ENSG00000175197\"},",
        "{\"po\":5,\"n\":\"alias\",\"v\":\"ENSG00000100292\"},{\"po\":6,\"n\":\"alias\",\"v\":\"ENSG00000124762\"},",
        "{\"po\":7,\"n\":\"alias\",\"v\":\"ENSG00000170345\"},{\"po\":8,\"n\":\"alias\",\"v\":\"ENSG00000171223\"},",
        "{\"po\":9,\"n\":\"alias\",\"v\":\"ENSG00000184557\"},{\"po\":10,\"n\":\"alias\",\"v\":\"ENSG00000141682\"},",
        "{\"po\":1,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":2,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":3,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":4,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":5,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":6,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":7,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":8,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":9,\"n\":\"group\",\"v\":\"GENE\"},{\"po\":10,\"n\":\"group\",\"v\":\"GENE\"},",
        "{\"po\":11,\"n\":\"alias\",\"v\":\"FOXO-mediated transcription of cell death genes\"},", 
        "{\"po\":12,\"n\":\"alias\",\"v\":\"Interleukin-4 and Interleukin-13 signaling\"},",
        "{\"po\":13,\"n\":\"alias\",\"v\":\"BH3-only proteins associate with and inactivate anti-apoptotic BCL-2 members\"},",
        "{\"po\":11,\"n\":\"group\",\"v\":\"TERM\"},",
        "{\"po\":12,\"n\":\"group\",\"v\":\"TERM\"},{\"po\":13,\"n\":\"group\",\"v\":\"TERM\"}]},",
        "{\"edgeAttributes\":[{\"po\":14,\"n\":\"name\",\"v\":\"REAC:R-HSA-9614657 (contains) ENSG00000105327\"},",
        "{\"po\":15,\"n\":\"name\",\"v\":\"REAC:R-HSA-9614657 (contains) ENSG00000113916\"},",
        "{\"po\":16,\"n\":\"name\",\"v\":\"REAC:R-HSA-9614657 (contains) ENSG00000153094\"},",
        "{\"po\":17,\"n\":\"name\",\"v\":\"REAC:R-HSA-9614657 (contains) ENSG00000175197\"},",
        "{\"po\":18,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000113916\"},",
        "{\"po\":19,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000100292\"},",
        "{\"po\":20,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000124762\"},",
        "{\"po\":21,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000170345\"},",
        "{\"po\":22,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000171223\"},",
        "{\"po\":23,\"n\":\"name\",\"v\":\"REAC:R-HSA-6785807 (contains) ENSG00000184557\"},",
        "{\"po\":24,\"n\":\"name\",\"v\":\"REAC:R-HSA-111453 (contains) ENSG00000105327\"},",
        "{\"po\":25,\"n\":\"name\",\"v\":\"REAC:R-HSA-111453 (contains) ENSG00000153094\"},",
        "{\"po\":26,\"n\":\"name\",\"v\":\"REAC:R-HSA-111453 (contains) ENSG00000141682\"},",
        "{\"po\":14,\"n\":\"source\",\"v\":\"REAC:R-HSA-9614657\"},{\"po\":15,\"n\":\"source\",\"v\":\"REAC:R-HSA-9614657\"},",
        "{\"po\":16,\"n\":\"source\",\"v\":\"REAC:R-HSA-9614657\"},{\"po\":17,\"n\":\"source\",\"v\":\"REAC:R-HSA-9614657\"},",
        "{\"po\":18,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},{\"po\":19,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},",
        "{\"po\":20,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},{\"po\":21,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},",
        "{\"po\":22,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},{\"po\":23,\"n\":\"source\",\"v\":\"REAC:R-HSA-6785807\"},",
        "{\"po\":24,\"n\":\"source\",\"v\":\"REAC:R-HSA-111453\"},{\"po\":25,\"n\":\"source\",\"v\":\"REAC:R-HSA-111453\"},",
        "{\"po\":26,\"n\":\"source\",\"v\":\"REAC:R-HSA-111453\"},{\"po\":14,\"n\":\"target\",\"v\":\"ENSG00000105327\"},",
        "{\"po\":15,\"n\":\"target\",\"v\":\"ENSG00000113916\"},{\"po\":16,\"n\":\"target\",\"v\":\"ENSG00000153094\"},",
        "{\"po\":17,\"n\":\"target\",\"v\":\"ENSG00000175197\"},{\"po\":18,\"n\":\"target\",\"v\":\"ENSG00000113916\"},",
        "{\"po\":19,\"n\":\"target\",\"v\":\"ENSG00000100292\"},{\"po\":20,\"n\":\"target\",\"v\":\"ENSG00000124762\"},",
        "{\"po\":21,\"n\":\"target\",\"v\":\"ENSG00000170345\"},{\"po\":22,\"n\":\"target\",\"v\":\"ENSG00000171223\"},",
        "{\"po\":23,\"n\":\"target\",\"v\":\"ENSG00000184557\"},{\"po\":24,\"n\":\"target\",\"v\":\"ENSG00000105327\"},",
        "{\"po\":25,\"n\":\"target\",\"v\":\"ENSG00000153094\"},{\"po\":26,\"n\":\"target\",\"v\":\"ENSG00000141682\"}]},",
        "{\"cyHiddenAttributes\":[{\"n\":\"layoutAlgorithm\",\"y\":\"yFiles Circular Layout\"}]},",
                       "{\"metaData\":[{\"name\":\"nodes\",\"version\":\"1.0\"},",
                       "{\"name\":\"edges\",\"version\":\"1.0\"},{\"name\":\"edgeAttributes\",\"version\":\"1.0\"},",
                       "{\"name\":\"nodeAttributes\",\"version\":\"1.0\"},",
                       "{\"name\":\"cyHiddenAttributes\",\"version\":\"1.0\"},{\"name\":\"cyNetworkRelations\",\"version\":\"1.0\"},",
                       "{\"name\":\"cyGroups\",\"version\":\"1.0\"},{\"name\":\"networkAttributes\",\"version\":\"1.0\"},",
                       "{\"name\":\"cyTableColumn\",\"version\":\"1.0\"},{\"name\":\"cySubNetworks\",\"version\":\"1.0\"}]},",
                       "{\"status\":[{\"error\":\"\",\"success\":true}]}]")
    
    expect_equal(result, expected)
})


### Tests extractInformationWhenIntersection() results

context("extractInformationWhenIntersection() results")

test_that("extractInformationWhenIntersection() must return expected text", {
    
    set.seed(1212)
    
    ccDemo <- parentalNapaVsDMSOEnrichment
    
    ccData <- ccDemo$result[ccDemo$result$term_id %in% 
                                c("WP:WP1742", "WP:WP410"), ]
    
    result <- enrichViewNet:::extractInformationWhenIntersection(
        gostResults=ccData)
    
    expected <- list()
    
    expected[["geneNodes"]] <- data.frame(
        "id"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
               "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
               "ENSG00000172216"),
        "group"=rep("GENE", 7),
        "alias"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
                  "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
                  "ENSG00000172216"),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["termNodes"]] <- data.frame(
        "id"=c("WP:WP1742", "WP:WP410"),
        "group"=c("TERM", "TERM"),
        "alias"=c("TP53 network", "Exercise-induced circadian regulation"),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expected[["edges"]] <- data.frame(
        "source"=c("WP:WP1742", "WP:WP1742", "WP:WP1742", "WP:WP410", 
                   "WP:WP410", "WP:WP410", "WP:WP410"),
        "target"=c("ENSG00000105327", "ENSG00000124762", "ENSG00000141682",
                   "ENSG00000051108", "ENSG00000133639", "ENSG00000141232", 
                   "ENSG00000172216"),
        "interaction"=rep("contains", 7),
        check.names=FALSE, stringsAsFactors=FALSE)
    
    expect_identical(result, expected)
})

#' From functional enrichment results to biological networks
#'
#' The \code{enrichViewNet} package enables the visualization 
#' of enrichment results, in a format corresponding to the one generated 
#' by \code{gprofiler2} 
#' (\url{https://cran.r-project.org/web/packages/gprofiler2/index.html})  
#' under the form of \code{Cytoscape} network (\url{https://cytoscape.org/}). 
#' 
#' In those networks, both gene datasets (GO terms/pathways/protein complexes)
#' and genes are represented as nodes. A edge connect a gene to its datasets.
#' In the current version, only genes present in at least one gene dataset 
#' are retained.
#'
#'
#' @name enrichViewNet-package
#'
#' @aliases enrichViewNet-package enrichViewNet
#'
#' @author Astrid Deschênes, Pascal Belleau, Robert L Faure,  
#' Maria J Fernandes, David A Tuveson
#'
#' Maintainer:
#' Astrid Deschênes <adeschen@hotmail.com>
#'
#' @seealso
#' \itemize{
#'     \item{\code{\link{createNetwork}} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\code{\link{createEnrichMap}} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map in 
#'     ggplot format}
#'     \item{\code{\link{createEnrichMapAsIgraph}} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map in 
#'     igraph format}
#'     \item{\code{\link{createEnrichMapMultiComplex}} for transforming 
#'     functional enrichment results from multiple gprofiler2 enrichment 
#'     results into an enrichment map in ggplot format}
#'     \item{\code{\link{createEnrichMapMultiComplexAsIgraph}} for transforming 
#'     functional enrichment results from multiple gprofiler2 enrichment 
#'     results into an enrichment map in igraph format}
#' }
#' 
#' @encoding UTF-8
#' @keywords package
"_PACKAGE"


#' The result of a functional enrichment analysis done with \code{gprofiler2} 
#' (\url{https://cran.r-project.org/web/packages/gprofiler2/vignettes/gprofiler2.html}).
#' 
#' The object is a \code{list} with 2 entries. It contains the results of the
#' enrichment analysis as well as the metadata related to the analysis.
#'
#' This dataset can be
#' used to test the \code{\link{createNetwork}} function.
#'
#' @name demoGOST
#'
#' @docType data
#'
#' @aliases demoGOST
#'
#' @format The \code{list} contains two entries. The \code{result} entry 
#' contains a \code{data.frame} with the significant results obtained by
#' an enrichment analysis done with \code{gprofiler2}. The \code{meta} entry 
#' contains a named list with all the metadata for the query.
#'
#' @return  A \code{list} containing two entries. The \code{result} entry 
#' contains a \code{data.frame} with the significant results obtained by
#' an enrichment analysis done with \code{gprofiler2}. 
#' The \code{meta} entry contains a named list with all the 
#' metadata for the query.
#'
#' @seealso
#' \itemize{
#'     \item{\link{createNetwork} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\link{createEnrichMap} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map}
#' }
#'
#' @usage data(demoGOST)
#'
#' @keywords datasets
#'
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(demoGOST)
#'
#' ## Create network for WikiPathways results 
#' ## in Cytoscape (if the application is open)
#' ## Otherwise, create a CX file in the temporary directory
#' ## The file can be opened in Cytoscape
#' createNetwork(gostObject=demoGOST, source="WP", title="Wikipathways",
#'     fileName=file.path(tempdir(), "Wikipathways_Demo.cx"))
#' 
#'
NULL


#' The result of a differential expression analysis done between 
#' napabucasin treated and DMSO control parental 
#' MiaPaCa2 cells. The cells were treated for 2 hours with 0.5 uM napabucasin.
#' The protocol to generate the RNA-seq is described 
#' in Froeling F.E.M. et al 2019.
#' 
#' The object is a \code{data.frame} with 24184 rows and 4 columns. 
#' Each row correspond to a tested gene.
#'
#' @name parentalNapaVsDMSODEG
#'
#' @docType data
#'
#' @aliases parentalNapaVsDMSODEG
#'
#' @format a \code{data.frame} containing the results of a differential 
#' expression analysis between napabucasin treated and DMSO control parental 
#' MiaPaCa2 cells for all 24184 genes tested. The 4 columns are:
#' \itemize{
#' 
#' \item{\code{"EnsemblID"}: a \code{character} string representing the 
#' unique Ensembl identifier for the tested gene}
#' \item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
#' difference (in log2FoldChange) between the napabucasin treatment and 
#' the DMSO control for the tested gene}
#' \item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
#' associated to the difference in expression for the tested gene}
#' \item{\code{"GeneName"}: a \code{character} string representing the name of 
#' the tested gene}
#' }
#'
#' @return  a \code{data.frame} containing the results of a differential 
#' expression analysis between napabucasin treated and DMSO control parental 
#' MiaPaCa2 cells for all 24184 genes tested. The 4 columns are:
#' \itemize{
#' \item{\code{"EnsemblID"}: a \code{character} string representing the 
#' unique Ensembl identifier for the tested gene}
#' \item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
#' difference (in log2FoldChange) between the napabucasin treatment and 
#' the DMSO control for the tested gene}
#' \item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
#' associated to the difference in expression for the tested gene}
#' \item{\code{"GeneName"}: a \code{character} string representing the name of 
#' the tested gene}
#' }
#'
#' @seealso
#' \itemize{
#'     \item{\link{createNetwork} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\link{createEnrichMap} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map}
#' }
#'
#' @usage data(parentalNapaVsDMSODEG)
#'
#' @keywords datasets
#'
#' @details
#' 
#' The differentially expressed genes between napabucasin-treated 
#' cells (0.5 uM) and DMSO as vehicle control are reprinted from Clinical 
#' Cancer Research, 2019, 25 (23), 7162–7174, Fieke E.M. Froeling, Manojit 
#' Mosur Swamynathan, Astrid Deschênes, Iok In Christine Chio, Erin Brosnan, 
#' Melissa A. Yao, Priya Alagesan, Matthew Lucito, Juying Li, An-Yun Chang, 
#' Lloyd C. Trotman, Pascal Belleau, Youngkyu Park, Harry A. Rogoff, 
#' James D. Watson, David A. Tuveson, Bioactivation of napabucasin triggers 
#' reactive oxygen species–mediated cancer cell death, with permission 
#' from AACR.
#' 
#' @source 
#' 
#' The original RNA-sequencing data is available at the Gene Expression 
#' Omnibus (GEO) under the accession number GSE135352.
#' 
#' @examples
#'
#' ## Required library
#' library(gprofiler2)
#' 
#' ## Loading data set containing the results of a differentially expressed 
#' ## analysis between 2-hour treatment with 0.5 uM napabucasin and 
#' ## DMSO vehicle control parental MiaPaCa2 cells
#' data(parentalNapaVsDMSODEG)
#' 
#' allGenes <- unique(parentalNapaVsDMSODEG$EnsemblID)
#' 
#' ## Select the significantly differentially expressed genes
#' selection <- which(abs(parentalNapaVsDMSODEG$log2FoldChange) > 1 & 
#'                             parentalNapaVsDMSODEG$padj < 0.05)
#'                             
#' selectedGenes <- unique(parentalNapaVsDMSODEG$EnsemblID[selection])
#' 
#' ## Run an enrichment analysis using WikiPathways dataset
#' gostres <- gost(query = list(parental_napa_vs_DMSO=selectedGenes),
#'     organism="hsapiens",
#'     correction_method = "g_SCS",
#'     sources=c("WP"), significant=TRUE, evcodes=TRUE,
#'     custom_bg=allGenes, exclude_iea=TRUE)
#' 
#' 
#'
NULL


#' The result of a differential expression analysis done between 
#' napabucasin treated and DMSO control MiaPaCa2 cells stably expressing 
#' the Rosa26 control vector. The cells were treated for 2 hours  
#' with 0.5 uM napabucasin.
#' The protocol to generate the RNA-seq is described 
#' in Froeling F.E.M. et al 2019.
#' 
#' The object is a \code{data.frame} with 23542 rows and 4 columns. 
#' Each row correspond to a tested gene.
#'
#' @name rosaNapaVsDMSODEG
#'
#' @docType data
#'
#' @aliases rosaNapaVsDMSODEG
#'
#' @format a \code{data.frame} containing the results of a differential 
#' expression analysis between napabucasin treated and DMSO control MiaPaCa2 
#' cells stably expressing the Rosa26 control vector for all 23542 genes 
#' tested. The 4 columns are:
#' \itemize{
#' \item{\code{"EnsemblID"}: a \code{character} string representing the 
#' unique Ensembl identifier for the tested gene}
#' \item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
#' difference (in log2FoldChange) between the napabucasin treatment and 
#' the DMSO control for the tested gene}
#' \item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
#' associated to the difference in expression for the tested gene}
#' \item{\code{"GeneName"}: a \code{character} string representing the name of 
#' the tested gene}
#' }
#'
#' @return  a \code{data.frame} containing the results of a differential 
#' expression analysis between napabucasin treated and DMSO control MiaPaCa2 
#' cells stably expressing the Rosa26 control vector for all 23542 genes 
#' tested. The 4 columns are:
#' \itemize{
#' \item{\code{"EnsemblID"}: a \code{character} string representing the 
#' unique Ensembl identifier for the tested gene}
#' \item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
#' difference (in log2FoldChange) between the napabucasin treatment and 
#' the DMSO control for the tested gene}
#' \item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
#' associated to the difference in expression for the tested gene}
#' \item{\code{"GeneName"}: a \code{character} string representing the name of 
#' the tested gene}
#' }
#'
#' @seealso
#' \itemize{
#'     \item{\link{createNetwork} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\link{createEnrichMap} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map}
#' }
#'
#' @usage data(rosaNapaVsDMSODEG)
#'
#' @keywords datasets
#'
#' @details
#' 
#' The differentially expressed genes between napabucasin-treated 
#' cells (0.5 uM) and DMSO as vehicle control are reprinted from Clinical 
#' Cancer Research, 2019, 25 (23), 7162–7174, Fieke E.M. Froeling, Manojit 
#' Mosur Swamynathan, Astrid Deschênes, Iok In Christine Chio, Erin Brosnan, 
#' Melissa A. Yao, Priya Alagesan, Matthew Lucito, Juying Li, An-Yun Chang, 
#' Lloyd C. Trotman, Pascal Belleau, Youngkyu Park, Harry A. Rogoff, 
#' James D. Watson, David A. Tuveson, Bioactivation of napabucasin triggers 
#' reactive oxygen species–mediated cancer cell death, with permission 
#' from AACR.
#' 
#' @source 
#' 
#' The original RNA-sequencing data is available at the Gene Expression 
#' Omnibus (GEO) under the accession number GSE135352.
#' 
#' @examples
#'
#' ## Required library
#' library(gprofiler2)
#' 
#' ## Loading dataset containing the results of a differentially expressed 
#' ## analysis between 2-hour treatment with 0.5 uM napabucasin and 
#' ## DMSO vehicle control MiaPaCa2 cells stably expressing the 
#' ## Rosa26 control vector
#' data(rosaNapaVsDMSODEG)
#' 
#' allGenes <- unique(rosaNapaVsDMSODEG$EnsemblID)
#' 
#' ## Select the significantly differentially expressed genes
#' selection <- which(abs(rosaNapaVsDMSODEG$log2FoldChange) > 1 & 
#'                             rosaNapaVsDMSODEG$padj < 0.05)
#'                             
#' selectedGenes <- unique(rosaNapaVsDMSODEG$EnsemblID[selection])
#' 
#' ## Run an enrichment analysis using Transfac dataset (transcription factor)
#' gostres <- gost(query = list(rosa_napa_vs_DMSO=selectedGenes),
#'     organism="hsapiens",
#'     correction_method = "g_SCS",
#'     sources=c("TF"), significant=TRUE, evcodes=TRUE,
#'     custom_bg=allGenes, exclude_iea=TRUE)
#' 
#' 
#'
NULL


#' The result of an enrichment analysis has been done using the significantly 
#' differentially expressed genes between napabucasin treated and DMSO 
#' control parental MiaPaCa2 cells. 
#' The cells were treated for 2 hour with 0.5 uM napabucasin.  
#' The protocol to generate the RNA-seq is described 
#' in Froeling F.E.M. et al 2019.
#' 
#' The enrichment analysis was done with gprofile2 package 
#' (Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
#' g:SCS multiple testing correction method applying significance 
#' threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
#' as background.
#' 
#' The object is a named \code{list} with 2 entries. The 'result' entry 
#' contains a \code{data.frame} with the enrichment analysis results and 
#' the 'meta' entry contains metadata information.
#' 
#' @name parentalNapaVsDMSOEnrichment
#'
#' @docType data
#'
#' @aliases parentalNapaVsDMSOEnrichment
#'
#' @format a \code{list} created by gprofiler2 that contains the results 
#' from the enrichment analysis:
#' \itemize{
#'     \item{\code{"result"}: a \code{data.frame} with the significantly 
#'     enriched terms }
#'     \item{\code{"meta"}: a \code{list} with the meta-data information}
#' }
#' 
#' @return  a \code{list} containing 2 entries:
#' \itemize{
#'     \item{\code{"result"}: a \code{data.frame} with the significantly 
#'     enriched terms }
#'     \item{\code{"meta"}: a \code{list} with the meta-data information}
#' }
#'
#' @seealso
#' \itemize{
#'     \item{\link{createNetwork} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\link{createEnrichMap} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map}
#'     \item{\link{createEnrichMapAsIgraph} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map in a igraph 
#'     format}
#' }
#'
#' @usage data(parentalNapaVsDMSOEnrichment)
#'
#' @keywords datasets
#'
#' @details
#' 
#' The dataset used for the enrichment analysis is 
#' associated to this publication:
#' 
#' Froeling F.E.M. et al.Bioactivation of Napabucasin Triggers Reactive Oxygen 
#' Species–Mediated Cancer Cell Death. Clin Cancer Res 
#' 1 December 2019; 25 (23): 7162–7174
#' 
#' The enrichment analysis has been done with gprofile2 package 
#' (Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
#' g:SCS multiple testing correction method applying significance 
#' threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
#' as background.
#' 
#' @source 
#' 
#' The original RNA-sequencing data is available at the Gene Expression 
#' Omnibus (GEO) under the accession number GSE135352.
#' 
#' @examples
#' 
#' ## Loading dataset containing the results of the enrichment analysis 
#' ## done on a differentially expressed 
#' ## analysis between 2-hour treatment with 0.5 uM napabucasin and 
#' ## DMSO vehicle control parental MiaPaCa2 cells
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Create an enrichment map for the GO:CC terms
#' createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
#'     query="parental_napa_vs_DMSO", source="GO:CC")
#'
NULL



#' The result of an enrichment analysis that has been done using the 
#' significantly differentially expressed genes between 
#' napabucasin treated and DMSO control MiaPaCa2 cells stably expressing 
#' the Rosa26 control vector.
#' The cells were treated for 2 hour with 0.5 uM napabucasin.  
#' The protocol to generate the RNA-seq is described 
#' in Froeling F.E.M. et al 2019.
#' 
#' The enrichment analysis was done with gprofile2 package 
#' (Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
#' g:SCS multiple testing correction method applying significance 
#' threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
#' as background.
#' 
#' The object is a named \code{list} with 2 entries. The 'result' entry 
#' contains a \code{data.frame} with the enrichment analysis results and 
#' the 'meta' entry contains metadata information.
#' 
#' @name rosaNapaVsDMSOEnrichment
#'
#' @docType data
#'
#' @aliases rosaNapaVsDMSOEnrichment
#'
#' @format a \code{list} created by gprofiler2 that contains the results 
#' from the enrichment analysis:
#' \itemize{
#'     \item{\code{"result"}: a \code{data.frame} with the significantly 
#'     enriched terms }
#'     \item{\code{"meta"}: a \code{list} with the meta-data information}
#' }
#'
#' @return a \code{list} created by gprofiler2 that contains the results 
#' from the enrichment analysis:
#' \itemize{
#' \item{\code{"result"}: a \code{data.frame} with the significantly enriched 
#' terms }
#' \item{\code{"meta"}: a \code{list} with the meta-data information}
#' }
#'
#' @seealso
#' \itemize{
#'     \item{\link{createNetwork} for transforming functional 
#'     enrichment results from gprofiler2 into a Cytoscape network}
#'     \item{\link{createEnrichMap} for transforming functional 
#'     enrichment results from gprofiler2 into an enrichment map}
#' }
#'
#' @usage data(rosaNapaVsDMSOEnrichment)
#'
#' @keywords datasets
#'
#' @details
#' 
#' The dataset used for the enrichment analysis is 
#' associated to this publication:
#' 
#' Froeling F.E.M. et al.Bioactivation of Napabucasin Triggers Reactive Oxygen 
#' Species–Mediated Cancer Cell Death. Clin Cancer Res 
#' 1 December 2019; 25 (23): 7162–7174
#' 
#' The enrichment analysis has been done with gprofile2 package 
#' (Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
#' g:SCS multiple testing correction method applying significance 
#' threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
#' as background.
#' 
#' @source 
#' 
#' The original RNA-sequencing data is available at the Gene Expression 
#' Omnibus (GEO) under the accession number GSE135352.
#' 
#' @examples
#' 
#' ## Loading dataset containing the enrichment analysis done on the 
#' ## differentially expressed analysis between 2-hour treatment with 0.5 uM 
#' ## napabucasin and DMSO control MiaPaCa2 cells stably expressing 
#' ## the Rosa26 control vector
#' data(rosaNapaVsDMSOEnrichment)
#' 
#' ## Create an enrichment map for the KEGG terms
#' createEnrichMap(gostObject=rosaNapaVsDMSOEnrichment, 
#'     query="rosa_napa_vs_DMSO", source="KEGG")
#'
NULL

#' @title Using functional enrichment results from gprofiler2 to create a 
#' Cytoscape network
#' 
#' @description User selected enrichment terms are used to create a Cytoscape 
#' network where the selected terms and the genes that where part of the 
#' enrichment analysis are all represented as nodes. Edges are linking the 
#' genes to their terms. The selection of the term can by specifying  the 
#' source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
#' term IDs. The network is only generated when there is at least on 
#' significant term to graph. When the enrichment analysis contains more than 
#' one query, only one query can be selected to generate the network.
#' 
#' @param gostObject a \code{list} created by gprofiler2 that contains
#' the results from an enrichment analysis.
#' 
#' @param source a \code{character} string representing the selected source 
#' that will be used to generate the network. To hand-pick the terms to be 
#' used, "TERM_ID" should be used and the list of selected term IDs should
#' be passed through the \code{termIDs} parameter. The possible sources are 
#' "GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
#' Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
#' "KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
#' miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
#' and "WP" for WikiPathways.  Default: "TERM_ID".
#' 
#' @param removeRoot a \code{logical} that specified if the root terms of 
#' the selected source should be removed (when present). Default: \code{TRUE}.
#' 
#' @param query a \code{character} string that specified the retained query to 
#' generate the network. When \code{NULL}, the query present in the result 
#' is retained; \code{NULL} cannot be used when more than one query is present. 
#' Default: \code{NULL}.
#' 
#' @param termIDs a \code{vector} of \code{character} strings that contains the
#' term IDS retained for the creation of the network. Default: \code{NULL}.
#' 
#' @param title a \code{character} string representing the name assigned to 
#' the network. Default: "gprofiler network".
#' 
#' @param collection a \code{character} string representing the collection 
#' name assigned to the network. Default: "enrichment results".
#' 
#' @param fileName a \code{character} string representing the name of the
#' CX JSON file that is created when Cytoscape is not running. The name 
#' must have a '.cx' extension.
#' Default: "gprofilerNetwork_01.cx". 
#' 
#' @return \code{TRUE}
#' 
#' @examples
#'
#' ## Loading dataset containing result from an enrichment analysis done with
#' ## gprofiler2
#' data(parentalNapaVsDMSOEnrichment)
#' 
#' ## Some of the enrichment results present in the dataset
#' head(parentalNapaVsDMSOEnrichment$result)
#'
#' ## Create network for Gene Ontology - Molecular Function related results
#' ## in Cytoscape (when the application is opened)
#' ## Otherwise, create a CX file in the temporary directory
#' ## The file can be opened in Cytoscape
#' createNetwork(gostObject=parentalNapaVsDMSOEnrichment, source="KEGG", 
#'     removeRoot=FALSE, title="KEGG Graph", 
#'     fileName=file.path(tempdir(), "KEGG_demo.cx"))
#' 
#' 
#' @author Astrid Deschênes
#' @importFrom gprofiler2 gconvert
#' @importFrom RCy3 cytoscapePing 
#' @importFrom strex match_arg
#' @importFrom stringr str_remove
#' @encoding UTF-8
#' @export
createNetwork <- function(gostObject, source=c("TERM_ID", "GO:MF", "GO:CC",
    "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA", "CORUM", "HP", "WP"), 
    termIDs=NULL, removeRoot=TRUE, query=NULL, title="gprofiler network", 
    collection="enrichment results", fileName="gprofilerNetwork.cx") {
    
    ## Validate source is among the possible choices
    source <- match_arg(source, ignore_case=TRUE)
    
    ## Validate parameters
    validateCreateNetworkArguments(gostObject=gostObject, source=source,
        termIDs = termIDs, removeRoot=removeRoot, query=query, title=title, 
        collection=collection, fileName=fileName)
    
    ## Extract results
    gostResults <- gostObject$result
    
    ## Filter on query
    if (!is.null(query)) {
        gostResults <- gostResults[gostResults$query  == query,]
        if (nrow(gostResults) == 0) {
            stop("With selected query, there is no enrichment term")
        }
    } else {
        queries <- unique(gostResults$query)
        if (length(queries) > 1) {
            stop("Multiple queries are present in the results, ",
                "the \'query\' parameter should be used to select one")
        }
    }
    
    ## Filter results
    gostResults <- filterResults(gostResults=gostResults, source=source, 
                                    termIDs=termIDs, removeRoot=removeRoot)
    
    if (nrow(gostResults) == 0) {
        stop("After filtering on the enriched terms, there is no ", 
                "enrichment term left")
    }
    
    ## Extract information required to generate network
    info <- extractNodesAndEdgesInformation(gostResults=gostResults, 
                                                    gostObject=gostObject)
    
    ## Test that Cytoscape is running
    isRunning <- isCytoscapeRunning()
    
    ## If cytoscape is running, publish network in Cytoscape
    ## Otherwise, create CX JSON file
    final <- FALSE
    if (isRunning) {
        message("Preparing information for Cytoscape.")
        final <- createNetworkForCytoscape(nodeEdgeInfo=info, title=title, 
                                                collection=collection)
        message("Cystocape Network created.")
    } else {
        message("Preparing information for generating CX JSON file.")
        json <- createCXJSONForCytoscape(nodeEdgeInfo=info, title=title) 
        if (!file.exists(fileName)) {
            write(json, file=fileName, append=FALSE)
        } else {
            id <- 0
            done <- FALSE
            shortFileName <- str_remove(fileName, ".cx$")
            while(!done || id > 99) {
                id <- id + 1
                newFileName <- paste0(shortFileName, "_",
                                        sprintf("%02d", id), ".cx")
                if (!file.exists(newFileName)) {
                    write(json, file=newFileName, append=FALSE)
                    done <- TRUE
                }
            }
        }
        message("CX JSON file \"", fileName, "\" has been created.\n")
        final <- TRUE
    }
    
    return(final)
}
        

---
title: "From functional enrichment results to biological networks"
author: Astrid Deschênes, Pascal Belleau, Robert L Faure and Maria J Fernandes
package: enrichViewNet
output:
  BiocStyle::html_document:
    toc: true
    toc_depth: 3
    number_sections: true
pkgdown:
  as_is: true
bibliography: enrichViewNet.bibtex
vignette: >
  %\VignetteIndexEntry{From functional enrichment results to biological networks}
  %\VignettePackage{enrichViewNet}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r style, echo = FALSE, results = 'hide', warning=FALSE, message=FALSE}
BiocStyle::markdown()

suppressPackageStartupMessages({
    library(knitr)
    library(enrichViewNet)
    library(gprofiler2)
    library(ggplot2)
    library(igraph)
    library(ggtangle)
    library(ggrepel)
})

## Set it globally
options(ggrepel.max.overlaps = 100)

set.seed(1214)
```

<br />
**Package**: `r Rpackage("enrichViewNet")`<br />
**Authors**: `r packageDescription("enrichViewNet")[["Author"]]`<br />
**Version**: `r packageDescription("enrichViewNet")$Version`<br />
**Compiled date**: `r Sys.Date()`<br />
**License**: `r packageDescription("enrichViewNet")[["License"]]`<br />


# Licensing 

The `r Biocpkg("enrichViewNet")` package and the underlying 
`r Biocpkg("enrichViewNet")` code are distributed under the 
Artistic license 2.0. You are free to use and redistribute this software. 

<br>
<br>

# Citing

If you use this package for a publication, we would ask you to cite the 
following:

> Deschênes A, Belleau P, Faure RL, Fernandes MJ, Krasnitz A, 
    Tuveson DA (2023). 
    enrichViewNet: From functional enrichment results to biological networks. 
    doi:10.18129/B9.bioc.enrichViewNet, 
    https://bioconductor.org/packages/enrichViewNet. 

<br>
<br>

# Introduction

High-throughput technologies are routinely used in basic and applied 
research and are key drivers of scientific discovery. A major challenge 
in using these experimental approaches is the analysis of the large amount 
of data generated. These include lists of proteins or genes generated by 
mass spectrometry, single-cell RNA sequencing and/or microarray analysis, 
respectively. There is thus a need for robust bioinformatic and statistical 
tools that can analyze these large datasets and display the data in the form 
of networks that illustrate the biological and conceptual links with findings 
in the literature. This gap has been partially addressed by several 
bioinformatic tools that perform enrichment analysis of the data and/or 
present it in the form of networks.  

Functional enrichment analysis tools, such as _Enrichr_ [@Kuleshov2016] and 
_DAVID_ [@Dennis2003], are specialized in positioning novel findings against 
well curated data sources of biological processes and pathways. 
Most specifically, those tools identify functional gene sets that 
are statistically over- (or under-) represented in a gene list (functional 
enrichment). The traditional output of a significant enrichment analysis 
tool is a table containing 
the significant gene sets with their associated statistics. While those 
results are extremely useful, their interpretation is challenging. The visual 
representation of these results as a network can greatly facilitate the 
interpretation of the data. 

Biological network models are visual representations of various biological 
interacting elements which are based on mathematical graphs. In those 
networks, the biological elements are generally represented by nodes while 
the interactions and relationships are represented by edges. One of the 
widely used network tools in the quantitative biology community is the 
open source software _Cytoscape_ [@PaulShannon2003]. In addition of 
biological data visualization and network
analysis, _Cytoscape_ can be expended through the use of 
specialized plug-ins such as _BiNGO_ that calculates over-represented GO terms 
in a network [@Maere2005] or _CentiScaPe_ that identifies relevant network 
nodes [@Scardoni2009]. 

The _g:Profiler_ enrichment analysis tool [@Raudvere2019] is web based and has 
the particularity of being accompanied by the CRAN package 
_gprofiler2_ [@Kolberg2020]. The _gprofiler2_ package gives the opportunity to 
researchers to incorporate functional enrichment analysis into automated 
analysis pipelines written in R. This greatly facilitates research 
reproducibility. 

The **enrichViewNet** package enables the visualization 
of functional enrichment results as network graphs. Visualization of 
enriched terms aims to 
facilitate the analyses of complex results.
Compared to popular enrichment visualization graphs such as bar plots and 
dot plots, network graphs unveil the connection between the 
terms as significant terms often share one or multiple genes. Moreover, the 
**enrichViewNet** package takes advantage of a powerful network 
visualization tool which is _Cytoscape_. By doing so, all the 
functionalities of this mature software can be used to personalize 
and analyze the enrichment networks. 

First, the **enrichViewNet** package enables the 
visualization of enrichment results, in a format corresponding to the one 
generated by _gprofiler2_, as a 
customizable _Cytoscape_ network [@PaulShannon2003]. In the biological 
networks generated by **enrichViewNet**, both 
gene datasets (GO terms/pathways/protein complexes) and genes associated 
to the datasets are represented as nodes. While the edges connect each gene 
to its dataset(s). Only genes present in the query used for the
enrichment analysis are shown.


```{r graphDemo01, echo = FALSE, fig.align="center", fig.cap="A network where significant GO terms and genes are presented as nodes while edges connect each gene to its associated term(s).", out.width = '90%'}
knitr::include_graphics("demo01.jpeg")
```

The **enrichViewNet** package 
offers the option to generate a network for only a portion of the 
significant terms by selecting the source or by providing a 
specific list of terms.Once the network is created, the user can 
personalize the visual attributes 
and integrate external information such as expression profiles, phenotypes 
and other molecular states. The user can also perform network analysis.

In addition, the **enrichViewNet** package also provides the option to 
create enrichment maps from functional enrichment results. 
The enrichment maps have been introduced in the Bioconductor 
_enrichplot_ package [@Yu2022]. 
Enrichment maps enable the visualization of enriched terms into a network 
with edges connecting overlapping genes. Thus, enriched terms with overlapping 
genes cluster together. This type of graphs facilitate the 
identification of functional modules.

```{r graphDemo02, echo=FALSE, fig.align="center", fig.cap="An enrichment map using significant Kegg terms where edges are connecting terms with overlapping genes.", out.width = '95%'}
knitr::include_graphics("demo_KEGG_emap_v03.jpg")
```


**enrichViewNet** has been submitted to 
[Bioconductor](https://www.bioconductor.org/) to aid researchers in carrying 
out reproducible network analyses using functional enrichment results.

<br>
<br>

# Installation

To install this package 
from [Bioconductor](https://bioconductor.org), start R 
(version 4.3 or later) and enter: 


```{r installDemo01, eval=FALSE, warning=FALSE, message=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
        install.packages("BiocManager")

BiocManager::install("enrichViewNet")
```

<br>
<br>


# General workflow


The following workflow gives an overview of the capabilities of 
**enrichViewNet**:

```{r graphWorkflow, echo=FALSE, fig.align="center", fig.cap="The enrichViewNet general workflow", out.width = '100%'}
knitr::include_graphics("Figure_enrichViewNet_workflow_v05.jpg")
```


The principal input of **enrichViewNet** is a functional enrichment 
result in a format identical to the one generated by the CRAN 
_gprofiler2_ package. 

From an enrichment result, the **enrichViewNet** offers two options:

* generate a gene-term network that can be loaded in *Cytoscape* software
* generate a enrichment map

For the gene-term network, the installation of *Cytoscape* software is 
highly recommended.

<br>
<br>

# Transforming enrichment results into a gene-term network loadable in Cytoscape


The following workflow gives an overview of the steps associated to the 
creation of an gene-term network loadable in *Cytoscape*.  

```{r graphListToGraph01, echo = FALSE, fig.align="left", fig.cap="From an enrichment list (A) to a Cytoscape network (B).", out.width = '100%'}
knitr::include_graphics("FromListToGraph_v03.jpg")
```


The key steps for the workflow are:

Step                             | Function                    
-------------------------------- | --------------------------------------------
Run an enrichment analysis       | `gprofiler2::gost()`
Start *Cytoscape*                |  outside R   
Create a gene-term network       | `createNetwork()`

The `package::function()` notation is used for functions from other packages.

<br>

## Run an enrichment analysis 

The first step consists in running an enrichment analysis with 
`r CRANpkg("gprofiler2")` package. The output of the _gprofiler2::gost()_ 
is a _list_ and should be saved. 


```{r gprofiler, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE}

## Required library
library(gprofiler2)

## The dataset of differentially expressed genes done between 
## napabucasin treated and DMSO control parental (Froeling et al 2019)
## All genes tested are present
data("parentalNapaVsDMSODEG")

## Retain significant results 
## (absolute fold change superior to 1 and adjusted p-value inferior to 0.05)
retained <- which(abs(parentalNapaVsDMSODEG$log2FoldChange) > 1 & 
                            parentalNapaVsDMSODEG$padj < 0.05)
signRes <-  parentalNapaVsDMSODEG[retained, ]

## Run one functional enrichment analysis using all significant genes
## The species is homo sapiens ("hsapiens")
## The g:SCS multiple testing correction method (Raudvere U et al 2019)
## The WikiPathways database is used
## Only the significant results are retained (significant=TRUE)
## The evidence codes are included in the results (evcodes=TRUE)
## A custom background included the tested genes is used
gostres <- gprofiler2::gost(
                query=list(parental_napa_vs_DMSO=unique(signRes$EnsemblID)),
                organism="hsapiens",
                correction_method="g_SCS",
                sources=c("WP"),
                significant=TRUE,
                evcodes=TRUE,
                custom_bg=unique(parentalNapaVsDMSODEG$EnsemblID))
```


<br>

The gost() function returns an named list of 2 entries: 

* The __result__ entry contains the enrichment results.
* The __meta__ entry contains the metadata information.

<br>

```{r gostResult, echo=TRUE, eval=TRUE}
## The 'gostres' object is a list of 2 entries
## The 'result' entry contains the enrichment results
## The 'meta' entry contains the metadata information

## Some columns of interest in the results
gostres$result[1:4, c("query", "p_value", "term_size", 
                    "query_size", "intersection_size", "term_id")]

## The term names can be longer than the one shown
gostres$result[19:22, c("term_id", "source", "term_name")]

```

<br>

## Start Cytoscape

[Cytoscape](https://cytoscape.org/) is an open source software for 
visualizing networks. It enables network integration with any type of attribute
data. The Cytoscape software 
is available at the [Cytoscape website](https://cytoscape.org/).

```{r cytoscapeLogo01, echo = FALSE, fig.align="center", fig.cap="Cytoscape software logo.", out.width = '55%'}
knitr::include_graphics("cy3sticker.png")
```

The Cytoscape network generated by 
`r Githubpkg("adeschen/enrichViewNet")` 
will be automatically loaded into the [Cytoscape](https://cytoscape.org/) 
software when the application is running.

If the application is not running, a CX JSON file will be created (standard 
Cytoscape file format). The file can then be loaded manually into 
the [Cytoscape](https://cytoscape.org/) software.

<br>

## Create a gene-term network 

The gene-term network can be created with the _createNetwork()_ function. If 
_Cytoscape_ is opened, the network should automatically be loaded in the 
application. Otherwise, a CX JSON file is created. The CX JSON can be manually 
be opened in _Cytoscape_.


The following figure shows what the gene-term network looks like 
in _Cytoscape_. As there are numerous significant Reactome terms, the network 
is a bit hectic.

```{r runCreateNetwork, echo=TRUE, eval=TRUE, message=FALSE}
## Load saved enrichment results between parental Napa vs DMSO
data("parentalNapaVsDMSOEnrichment")

## Create network for REACTOME significant terms
## The 'removeRoot=TRUE' parameter removes the root term from the network
## The network will either by created in Cytoscape (if the application is open)
## or a CX file will be created in the temporary directory
createNetwork(gostObject=parentalNapaVsDMSOEnrichment,  source="REAC", 
        removeRoot=TRUE, title="REACTOME_All", 
        collection="parental_napa_vs_DMSO", 
        fileName=file.path(tempdir(), "parentalNapaVsDMSOEnrichment.cx"))
```

<br>

This is an example of the Reactome network in _Cytoscape_.

```{r networkInCytoscape, echo=FALSE, fig.align="center", fig.cap="All reactome terms in a gene-term network loaded in Cytoscape.", out.width = '110%'}
knitr::include_graphics("cytoscape_reactome_all_parental_napa_vs_DMSO.png")
```

<br>

To address this situation, an updated gene-term network containing only 
Reactome terms of interest is created.

<br>

```{r runCreateNetworkSelected, echo=TRUE, eval=TRUE, message=FALSE}
## Load saved enrichment results between parental Napa vs DMSO
data("parentalNapaVsDMSOEnrichment")

## List of terms of interest
reactomeSelected <- c("REAC:R-HSA-9031628", "REAC:R-HSA-198725", 
                        "REAC:R-HSA-9614085", "REAC:R-HSA-9617828",
                        "REAC:R-HSA-9614657", "REAC:R-HSA-73857",
                        "REAC:R-HSA-74160", "REAC:R-HSA-381340")

## All enrichment results
results <- parentalNapaVsDMSOEnrichment$result

## Retain selected results
selectedRes <- results[which(results$term_id %in% reactomeSelected), ]

## Print the first selected terms
selectedRes[, c("term_name")]

```

<br>

```{r runCreateNetworkSelected2, echo=TRUE, eval=TRUE, message=FALSE, fig.align="center", fig.cap="Enrichment map."}

## Create network for REACTOME selected terms
## The 'source="TERM_ID"' parameter enable to specify a personalized 
## list of terms of interest
## The network will either by created in Cytoscape (if the application is open)
## or a CX file will be created in the temporary directory
createNetwork(gostObject=parentalNapaVsDMSOEnrichment,  source="TERM_ID", 
        termIDs=selectedRes$term_id, title="REACTOME_Selected", 
        collection="parental_napa_vs_DMSO",
        fileName=file.path(tempdir(), "parentalNapaVsDMSO_REACTOME.cx"))
```

<br>

The updated Reactome network in _Cytoscape_.

```{r networkInCytoscapeSelected, echo=FALSE, fig.align="center", fig.cap="Selected Reactome terms in a gene-term network loaded in Cytoscape.", out.width = '110%'}
knitr::include_graphics("cytoscape_with_selected_REACTOME_v01.png")
```

<br>

In _Cytoscape_, the appearance of a network is easily customized. As example, 
default color and shape for all nodes can be modified. For this example, 
the nodes have been moved to clarify their relation with the Reactome terms.


```{r networkFinalReactome, echo=FALSE, fig.align="center", fig.cap="Final Reactome network after customization inside Cytoscape.", out.width = '100%'}
knitr::include_graphics("REACTOME_Selected.jpeg")
```

<br>

The final Reactome network, after customization inside Cytoscape, shows that 
multiple transcription enriched terms (*FOXO-mediated transcription*, 
*FOXO-mediated transcription of cell cycle genes*, 
_transcription regulation of white adipocyte differentiation_, 
_RNA polymerase II transcription_ and 
_NGF-stimulated transcription_ terms) are linked through enriched genes.

<br>
<br>


# Transforming enrichment results into an enrichment map


The following workflow gives an overview of the steps associated to the 
creation of an enrichment map. 

The key steps for the workflow are:

Step                             | Function                    
-------------------------------- | ------------------------------------------
Run an enrichment analysis       | `gprofiler2::gost()`
Create an enrichment map         | `createEnrichMap()` or `createEnrichMapAsIgraph()`

The `package::function()` notation is used for functions from other packages.

It is possible to create an enrichment map in a `ggplot` format with the 
`createEnrichMap()` function or in an `igraph` format with the 
`createEnrichMapAsIgraph()` function.

<br>


## Run an enrichment analysis 

The first step consists in running an enrichment analysis with 
`r CRANpkg("gprofiler2")` package. The output of the _gprofiler2::gost()_ 
is a _list_ and should be saved. 


```{r gprofiler2, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE}

## Required library
library(gprofiler2)

## The dataset of differentially expressed genes done between 
## napabucasin treated and DMSO control parental (Froeling et al 2019)
## All genes tested are present
data("parentalNapaVsDMSODEG")

## Retain significant results 
## (absolute fold change superior to 1 and adjusted p-value inferior to 0.05)
retained <- which(abs(parentalNapaVsDMSODEG$log2FoldChange) > 1 & 
                        parentalNapaVsDMSODEG$padj < 0.05)
signRes <- parentalNapaVsDMSODEG[retained, ]

## Run one functional enrichment analysis using all significant genes
## The species is homo sapiens ("hsapiens")
## The g:SCS multiple testing correction method (Raudvere U et al 2019)
## The WikiPathways database is used
## Only the significant results are retained (significant=TRUE)
## The evidence codes are included in the results (evcodes=TRUE)
## A custom background included the tested genes is used
gostres <- gprofiler2::gost(
                query=list(parental_napa_vs_DMSO=unique(signRes$EnsemblID)),
                organism="hsapiens",
                correction_method="g_SCS",
                sources=c("WP"),
                significant=TRUE,
                evcodes=TRUE,
                custom_bg=unique(parentalNapaVsDMSODEG$EnsemblID))
```


<br>

The _gost()_ function returns an named list of 2 entries: 

* The __result__ entry contains the enrichment results.
* The __meta__ entry contains the metadata information.

<br>

```{r gostResult2, echo=TRUE, eval=TRUE}
## The 'gostres' object is a list of 2 entries
## The 'result' entry contains the enrichment results
## The 'meta' entry contains the metadata information

## Some columns of interest in the results
gostres$result[1:4, c("query", "p_value", "term_size", 
                    "query_size", "intersection_size", "term_id")]

## The term names can be longer than the one shown
gostres$result[19:22, c("term_id", "source", "term_name")]

```

<br>


## Create an enrichment map in a `ggplot` format

The enrichment map can be created with the _createEnrichMap()_ function. The 
function generates a _ggplot_ object.

In this enrichment map, terms with overlapping genes are linked 
together by edges. The Jaccard correlation coefficient is used as a metric of 
similarity. Terms with high similarity (similarity metric > 0.2) are linked 
together by edges. The edges are shorter and thicker when the similarity 
metric is high. 

```{r runCreateEmap01, echo=TRUE, eval=TRUE, fig.cap="A Kegg enrichment map where terms with overlapping genes cluster together.", fig.align="center"}

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## Create network for all Kegg terms
## All terms will be shown even if there is overlapping
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", source="KEGG")
    
```


<br>

The Kegg enrichment map shows that the _MAPK signaling pathway_ term is 
highly influential in the network. In addition, the 
_Transcriptional misregulation in cancer_ term is the only isolated node.

<br>


### Using list of term IDs

Instead of using a specific source, the enrichment map can be generated from a 
personalized array of term IDs. To do so, the _source_ parameter must be set 
to _"TERM_ID"_ and an array of term IDs must be passed to the _termIDs_ 
parameter. The terms can be pick-up from different sources. If more than one 
terms have the same description, the term ID will be added at the end of the 
description for clarity.

```{r runCreateEmapTerms, echo=TRUE, eval=TRUE, fig.cap="An enrichment map showing only the user selected terms.", fig.align="center"}

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## The term IDs must correspond to the IDs present in the "term_id" column
head(parentalNapaVsDMSOEnrichment$result[, c("query", "term_id", "term_name")], 
     n=3)

## List of selected terms from different sources
termID <- c("KEGG:04115", "WP:WP4963", "KEGG:04010", 
                "REAC:R-HSA-5675221", "REAC:R-HSA-112409", "WP:WP382")

## Create network for all selected terms
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", 
                    source="TERM_ID", termIDs=termID)
    
```

<br>

As the description "MAPK signaling pathway" is present twice, the ID of each 
term has been added to the end of the description. Hence, the MAPK pathway 
from WikiPathway can be distinguished from the Kegg pathway.

<br>

### Enrichment map customization


The output of the _createEnrichMap()_ function is a _ggplot_ object. 
This means that the graph can be personalized. For example, the default 
colors can be changed:


```{r runCreateEmap03, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with personalized colors.", fig.align="center"}

## The ggplot2 library is required
library(ggplot2)
## Create network for all Kegg terms
graphKegg <- createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", source="KEGG")

## Nodes with lowest p-values will be in orange and highest p-values in black
## The title of the legend is also modified
graphKegg + scale_color_continuous(name="P-value adjusted", low="orange", 
                                    high="black")
    
```

<br>

## Create an enrichment map in an `igraph` format

The enrichment map can be created with the _createEnrichMapAsIgraph()_ 
function. The function generates an _igraph_ object.

The Jaccard correlation coefficient is used as a metric of 
similarity. A specific cut-off can be selected by user (default: 0.2). 
Terms with high similarity (similarity metric > value set by 
user) are linked together by edges.

```{r runCreateEmapIgraph01, echo=TRUE, eval=TRUE, fig.cap="A Reactome (12 top terms) enrichment map where terms with overlapping  genes cluster together.", fig.align="center"}

## Load saved enrichment results between parental Napa vs DMSO
data(parentalNapaVsDMSOEnrichment)

## Create network for all Reactome terms
## All terms will be shown even if there is overlapping
## The similarity cut off is set to 0.3
## The top 10 terms with best p-values are shown
emapGraph <- createEnrichMapAsIgraph(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", similarityCutOff=0.3,
                    source="REAC", showCategory=12)

## Set seed to ensure reproducible results
set.seed(121)

## The igraph library is required
library(igraph)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black", vertex.color="lightblue2")   
```


### Effect of _seed_ value

The layering of the nodes is not always optimal. As the layering is affected by 
the _seed_ value, you might want to test few _seed_ values, using the 
_set.seed()_ function, before selecting the final graph.


```{r runCreateEmapIgraph02, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with a different seed.", fig.align="center"}

## Set seed to ensure reproducible results
set.seed(12)

## The igraph library is required
library(igraph)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black", vertex.color="lightblue2")   
```

<br>

### Enrichment map customization

The output of the _createEnrichMapAsIgraph()_ function is a _igraph_ object. 
This means that the graph can be personalized. Attributes can also be added 
or modified inside the _igraph_ object.


```{r runCreateEmapIgraph03, echo=TRUE, eval=TRUE, message=FALSE, warning=FALSE, fig.cap="An enrichment map with personalized visualization options.", fig.align="center"}

## The required libraries
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)

## Create network for all Reactome terms
## Minimum similarity to have a edge is set to 0.4
## Only the top 15 terms with the bestp-values are shown 
graphReac <- createEnrichMapAsIgraph(gostObject=parentalNapaVsDMSOEnrichment, 
                    query="parental_napa_vs_DMSO", similarityCutOff=0.4,
                    source="REAC", showCategory=10)

## Set seed to ensure reproducible results
set.seed(92)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(graphReac, layout=layout_with_fr)

## Move right the node related to Signal Transduction
graphEmap$data$x[graphEmap$data$label == 
            "Signal Transduction"] <- 2.3

## Using ggtangle and ggrepel libraries to personalize output
## Set the color of the text, the nodes and the edges 
## Set the node size using size value present in the igraph object
## The edge width is associated to the similarity value
## the coord_fixed() function is used to fix 1:1 ratio
graphEmap + geom_edge(aes(linewidth=weight), color="blue1") + 
    geom_point(aes(size=size), colour="gray40") +
    geom_text_repel(aes(x=x, y=y, label=label), nudge_x=0.5, 
                 nudge_y=0.2, col="darkviolet", min.segment.length=0.1, 
                 max.overlaps=10) +
    scale_size_continuous(range=c(4, 12)) + 
    scale_linewidth_binned(range=c(1, 3)) + coord_fixed() 
    
```


<br>
<br>


# Transforming enrichment results into an enrichment map with groups from different enrichment analyses


The following workflow gives an overview of the steps associated to the 
creation of an enrichment map with groups. Groups can be created from the 
same enrichment analysis or can come from different enrichment analyses. This 
section is specifically for enrichment maps created using multiple enrichment 
analyses.

The key steps for the workflow are:

Step                                          | Function                    
--------------------------------------------- | ------------------------------
Run multiple enrichment analyses              | `gprofiler2::gost()`
Create an enrichment map with groups          | `createEnrichMapMultiBasic()` or  `createEnrichMapMultiBasicAsIgraph()`

The `package::function()` notation is used for functions from other packages.

It is possible to create an enrichment map in a `ggplot` format with the 
`createEnrichMapMultiComplex()` function or in an `igraph` format with the 
`createEnrichMapMultiComplexAsIgraph()` function.

<br>

The first step has been presented in the previous section.

<br>

## Create an enrichment map using multiple enrichment analyses in a `ggplot` format

An enrichment map can show enrichment results from multiple enrichment 
analyses with the `createEnrichMapMultiBasic` function. A different color 
is used for each analysis. This enables to 
highlight the similarities and differences between the analyses.


```{r emapMulti01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg enrichment results for 2 different experiments.", fig.align="center"}

## Set seed to ensure reproducible results
set.seed(2121)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control parental and
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("parentalNapaVsDMSOEnrichment")
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## The queryList is a list of query names retained for each of the enrichment 
## object (same order). Beware that a enrichment object can contain more than 
## one query.
query_01 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
queryList <- list(query_01, query_02)

## Enrichment map where the groups are the KEGG results for the 2 different
## experiments
createEnrichMapMultiBasic(gostObjectList=gostObjectList,
    queryList=queryList, source="KEGG", removeRoot=TRUE)
    

```

<br>

There are 4 KEGG enrichment terms that are shared by the 2 experiments. 
In additions, the _Viral carinogenesis_ term is the only term that is not 
related to the other KEGG terms.

<br>

### Enrichment map customization

The output of the _createEnrichMapMultiBasic()_ function is a _ggplot_ object. 
This means that the graph can be personalized. For example, the default 
colors, legend title and legend font can be changed:

```{r emapMultiCustom, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map using KEGG terms from two enrichment analyses with personalized colors and legend."}

## Required library
library(ggplot2)

## Enrichment map where the groups are the KEGG results for the 2 different
## experiments
createEnrichMapMultiBasic(gostObjectList=gostObjectList,
    queryList=queryList, source="KEGG", removeRoot=TRUE) +
        scale_fill_manual(name="Groups",
                breaks=queryList,
                values=c("cyan4", "bisque3"),
                labels=c("parental", "rosa")) +
        theme(legend.title=element_text(face="bold"))

```

<br>

## Create an enrichment map using multiple enrichment analyses in an `igraph` format

The _createEnrichMapMultiBasicAsIgraph()_ function enables enrichment map to 
be generate in an _igraph_ format.

```{r emapMultiAsIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing GO Molecular Function enrichment results (top 10) for 2 different experiments.", fig.align="center"}

## Set seed to ensure reproducible results
set.seed(2121)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control parental and
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("parentalNapaVsDMSOEnrichment")
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
gostObjectList <- list(parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## The queryList is a list of query names retained for each of the enrichment 
## object (same order). Beware that a enrichment object can contain more than 
## one query.
query_01 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
queryList <- list(query_01, query_02)

## Enrichment map where the groups are the GO Molecular Function results 
## for the 2 different experiments
## Only the top 10 terms for each experiments (based on p-value) are shown
## Minimum Jaccard coefficient between 2 nodes is set to 0.6
emapGraph <- createEnrichMapMultiBasicAsIgraph(gostObjectList=gostObjectList,
    queryList=queryList, source="GO:MF", removeRoot=TRUE, showCategory=5,
    similarityCutOff=0.6)
    
library(igraph)
plot(emapGraph)

```

<br>

### Enrichment map customization

The graph representation of an _igraph_ object can be personalized. 
Attributes can also be added or modified inside the igraph object. This is 
an important step to enable a scatter pie representation of the map.

```{r emapMultiAsIgraph02, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map using GO Molecular Function terms from two enrichment analyses with personalized colors and legend."}

## The required libraries
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

set.seed(11)

graphEmap <- ggplot(emapGraph, layout=layout_with_fr) 

## Extract information from igraph object about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapGraph)$pie))
colnames(pieInfo) <- V(emapGraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("darkorange", "darkviolet")

## Using ggtangle, scatterpie and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="black") +
    geom_scatterpie(aes(x=x, y=y, r=size/100), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/100, n=4, 
            x=max(graphEmap$data$x)+1, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*100)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 3)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="blue2", 
            max.overlaps=10) +
    coord_fixed()
```

<br>
<br>

# Transforming enrichment results into an enrichment map with groups from same enrichment analysis or from complex designs

The following workflow gives an overview of the steps associated to the 
creation of an enrichment map with groups. Groups can be created from the 
same enrichment analysis or can come from different enrichment analyses. This 
section is specifically for enrichment maps created using complex designs. 

The key steps for the workflow are:

Step                                        | Function                    
------------------------------------------- | ------------------------------
Run one ro multiple enrichment analyses     | `gprofiler2::gost()`
Create an enrichment map with group         | `createEnrichMapMultiComplex()` or `createEnrichMapMultiComplexAsIgraph()`

The `package::function()` notation is used for functions from other packages.

It is possible to create an enrichment map in a `ggplot` format with the 
`createEnrichMapMultiComplex()` function or in an `igraph` format with the 
`createEnrichMapMultiComplexAsIgraph()` function.

<br>

The first step has been presented in the previous section.

<br>

## Create an enrichment map using mutliple subsections of one enrichment analysis in a `ggplot` format

The _createEnrichMapMultiComplex()_ function enables enrichment map to be 
generate with multiple groups from one enrichment analysis. As an example, 
terms from different sources can be drawn in different colors.

```{r emapMultiComplex01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis.", fig.align="center"}

## Set seed to ensure reproducible results
set.seed(3221)

## The dataset of functional enriched terms for one experiment:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01), 
                            source=c("KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE),
                            termIDs=c("", ""), 
                            groupName=c("Kegg", "Reactome"),
                            stringsAsFactors=FALSE)

## Enrichment map where the groups are the KEGG and Reactome results for the 
## same experiment
createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
        queryInfo=queryInfo)
    
```

<br>

The significant genes are overlapping between the Kegg and Reactome pathways 
as shown by the connections between the pathways. 
The only isolated term is the Kegg Viral carcinogenesis pathway.

<br>

### Create an enrichment map using a complex design

Complex designs can be used with _createEnrichMapMultiComplex()_. Results 
from different analyses as well as split results from the same analysis can 
be showcase together. 

In this example, the enrichment map will contain 4 groups from 2 experiments:
- MAP kinases related terms in rosa napabucasin treated vs DMSO control
- MAP kinases related terms in parental napabucasin treated vs DMSO control
- Interleukin related terms in rosa napabucasin treated vs DMSO control
- Interleukin related terms in parental napabucasin treated vs DMSO control


```{r emapMultiCustom2, echo=TRUE, warning=FALSE, message=FALSE, collapse=FALSE, eval=TRUE, fig.cap="An enrichment map using selected terms related to MAP kinases and interleukin in two different experiments."}

## Set seed to ensure reproducible results
set.seed(28)

## The datasets of functional enriched terms for the two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector and
## napabucasin treated and DMSO control parental MiaPaCa2 cells
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
## The order of the objects must respect the order on the queryInfo data frame
## In this case: 
##   1. rosa dataset (for MAP kinases)
##   2. parental dataset (for MAP kinases)
##   3. rosa dataset (for interleukin)
##   4. parental dataset (for interleukin)
gostObjectList <- list(rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_rosa <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_parental <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]


## List of selected terms that will be shown in each group
rosa_mapk <- "GO:0017017,GO:0033549,KEGG:04010,WP:WP382"
rosa_il <- "KEGG:04657,WP:WP4754" 
parental_mapk <- paste0("GO:0017017,GO:0033549,KEGG:04010,", 
                            "REAC:R-HSA-5675221,REAC:R-HSA-112409,WP:WP382")
parental_il <- "WP:WP4754,WP:WP395"


## The query information is a data frame containing the information required 
## to extract the specific terms for each enrichment object
## The number of rows must correspond to the number of enrichment objects
## The query name must be present in the enrichment object
## The source is set to "TERM_ID" so that the terms present in termIDs column 
##  will be used
## The group name will be used for the legend, the same name cannot be 
##  used twice
queryInfo <- data.frame(queryName=c(query_rosa, query_parental, 
                    query_rosa, query_parental), 
        source=c("TERM_ID", "TERM_ID", "TERM_ID", "TERM_ID"),
        removeRoot=c(FALSE, FALSE, FALSE, FALSE),
        termIDs=c(rosa_mapk, parental_mapk, rosa_il, parental_il),
        groupName=c("rosa - MAP kinases", "parental - MAP kinases", 
                        "rosa - Interleukin", "parental - Interleukin"),
        stringsAsFactors=FALSE)

## Enrichment map where the groups TODO
createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
        queryInfo=queryInfo)

```


While the two experiments have a lot of similar enriched terms, there are 
still terms that are unique to each experiment.

<br>

## Create an enrichment map using mutliple subsections of one enrichment analysis in a `igraph` format

The _createMultiEmapAsIgraph()_ function enables enrichment map to be 
generate with multiple groups from one enrichment analysis in a `igraph` 
format. As an example, 
terms from different sources can be drawn in different colors.

```{r emapMultiComplexIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis.", fig.align="center"}

## The dataset of functional enriched terms for one experiment:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, the same enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01), 
                            source=c("KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE),
                            termIDs=c("", ""), 
                            groupName=c("Kegg", "Reactome"),
                            stringsAsFactors=FALSE)


## Enrichment map where the groups are the KEGG and Reactome results for the 
## same experiment
## Minimum similarity coefficient to have 2 terms linked is set to 0.5
emapGraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, similarityCutOff=0.5)

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(3221)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")   
    
```

In this situation, the default output from the `igraph` library doesn't 
create a scatter pie graph. Enrichment map customization is required to 
generate a scatter pie graph. This is covered in the next topic.

<br>

### Effect of _seed_ value

The layering of the nodes is not always optimal. As the layering is affected 
by the _seed_ value, you might want to test few seed values, using 
the `set.seed()` function, before selecting the final graph.


```{r changeSeedIgraph02, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO analysis with a different seed.", fig.align="center"}

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(911)

## Use library igraph to create the visual representation
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")  

```

<br>

### Enrichment map customization

The `igraph` object can be used to generate personalized graphs.
Attributes can also be added or modified inside the igraph object.

```{r personalizedIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO and parental vs DMSO analyses as a ggplot graph.", fig.align="center"}

## Visualization libraries is required
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

## Set seed to ensure reproducible results
set.seed(21)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(emapGraph, layout=layout_with_fr) 

## Extract information about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapGraph)$pie))
colnames(pieInfo) <- V(emapGraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("blue", "darkviolet")
    
## Using scatterpie, ggtangle and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="lightblue3") +
    geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/50, n=3, 
            x=max(graphEmap$data$x)+0.5, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*50)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 3)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="black", 
            max.overlaps=10) +
    coord_fixed()

```

<br>

## Create an enrichment map using mutliple subsections of multiple enrichment analyses in a `igraph` format

The _createEnrichMapMultiComplexAsIgraph()_ function enables enrichment map to be 
generate with multiple groups from one enrichment analysis in a `igraph` 
format. 

```{r createEnrichMapMultiComplexAsIgraph01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO, and parenteal vs DMSO analyses.", fig.align="center"}

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, each enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01, query_02, query_02), 
                            source=c("GO:BP", "GO:CC", "GO:BP", "GO:CC"),
                            removeRoot=c(TRUE, TRUE, TRUE, TRUE),
                            termIDs=c("", "", "", ""), 
                            groupName=c("GO:BP - Napa", "GO:CC - Napa",
                                    "GO:BP - Parental", "GO:CC - Parental"),
                            stringsAsFactors=FALSE)


## Enrichment map where there are 2 groups generated from each 
## experiment
## Minimum similarity coefficient to have 2 terms linked is set to 0.5
## The 10 terms with the best p-value are selected for each group
emapGraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, similarityCutOff=0.5, showCategory=10)

## The igraph library is required
library(igraph)

## Set seed to ensure reproducible results
set.seed(3221)

## Use library igraph to create the visual representation
## Unfortunately, the output does not generate a scatter pie plot
## See next topic to generate a scatter pie plot
plot(emapGraph, layout=layout_with_fr, vertex.label.cex=0.5, 
        vertex.label.color="black")   
    
```

In this situation, the default output from the `igraph` library doesn't 
create a scatter pie graph. Enrichment map customization is required to 
generate a scatter pie graph. This is covered in the next topic.

<br>

### Enrichment map customization

The `igraph` object can be used to generate personalized graphs.
Attributes can also be added or modified inside the igraph object.

```{r personalized01, echo=TRUE, warning=FALSE, message=FALSE, collapse=F, eval=TRUE, fig.cap="An enrichment map containing Kegg and Reactome results from the rosa Napa vs DMSO and parental vs DMSO analyses as a ggplot graph.", fig.align="center"}

## Visualization libraries is required
library(igraph)
library(ggplot2)
library(ggtangle)
library(ggrepel)
library(scatterpie)

## The dataset of functional enriched terms for two experiments:
## napabucasin treated and DMSO control expressing Rosa26 control vector
## (Froeling et al 2019)
data("rosaNapaVsDMSOEnrichment")
data("parentalNapaVsDMSOEnrichment")

## The gostObjectList is a list containing all 
## the functional enrichment objects
## In this case, each enrichment object is used twice
gostObjectList <- list(rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment, parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment)

## Extract the query name from the enrichment object
query_01 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]
query_02 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]

## The query information is a data frame containing the information required 
##   to extract the specific terms for each enrichment object.
## The number of rows must correspond to the number of enrichment objects/
## The query name must be present in the enrichment object.
## The source can be: "GO:BP" for Gene Ontology Biological Process, 
##   "GO:CC" for Gene Ontology Cellular Component, "GO:MF" for Gene Ontology 
##   Molecular Function, "KEGG" for Kegg, "REAC" for Reactome, 
##   "TF" for TRANSFAC, "MIRNA" for miRTarBase, "CORUM" for CORUM database, 
##   "HP" for Human phenotype ontology and "WP" for WikiPathways or 
##   "TERM_ID" when a list of terms is specified.
## The termsIDs is an empty string except when the source is set to "TERM_ID".
## The group names are going to be used in the legend and should be unique to 
##  each group.
queryInfo <- data.frame(queryName=c(query_01, query_01, query_02, query_02), 
                            source=c("KEGG", "REAC", "KEGG", "REAC"),
                            removeRoot=c(TRUE, TRUE, TRUE, TRUE),
                            termIDs=c("", "", "", ""), 
                            groupName=c("Kegg - Rosa", "Reactome - Rosa",
                                "Kegg - Parental", "Reactome - Parental"),
                            stringsAsFactors=FALSE)

## Enrichment map where the groups are the KEGG and Reactome results for 
## two enrichment analyses
## Minimum similarity coefficient to have 2 terms linked is set to 0.3
## Only the 7 terms with best p-value are going to be shown in each group
emapIgraph <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
        queryInfo=queryInfo, showCategory=5, similarityCutOff=0.3)

## Set seed to ensure reproducible results
set.seed(21)

## Using ggplot2 to generate a ggplot graph
graphEmap <- ggplot(emapIgraph, layout=layout_with_fr) 

## Extract information about group associated to each node
pieInfo <- as.data.frame(do.call(rbind, V(emapIgraph)$pie))
colnames(pieInfo) <- V(emapIgraph)$pieName[[1]]

## Add information into the ggplot object to be able to color nodes
for (i in seq_len(ncol(pieInfo))) {
    graphEmap$data[colnames(pieInfo)[i]] <- pieInfo[, i]
}

## Colors selected for the groups
groupColor <- c("darkorange", "violet", "darkorange4", "darkviolet")
    
## Using scatterpie, ggtangle and ggrepel libraries to personalize output
## geom_scatterpie() allows to have scatter pie plot
## geom_text_repel() allows to have minimum overlying terms
## scale_fill_manual() allows to personalize the color of the nodes
## coord_fixed() forces the plot to have a 1:1 aspect ratio
graphEmap + geom_edge(aes(linewidth=weight), color="blue3") +
    geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name="Group", color=NA) +
    geom_scatterpie_legend(radius=graphEmap$data$size/50, n=3, 
            x=max(graphEmap$data$x)+0.5, y=min(graphEmap$data$y)-0.5,
            labeller=function(x) {round(x*50)}, label_position="right") +
    scale_fill_manual(values=groupColor) +
    scale_size_continuous(range=c(2, 8)) + 
    scale_linewidth_binned(range=c(1, 2)) +
    geom_text_repel(aes(x=x, y=y, label=label), color="black", 
            max.overlaps=10) +
    coord_fixed()

```

<br>
<br>



# Acknowledgments

The differentially expressed genes between napabucasin-treated cells (0.5 uM) 
and DMSO as vehicle control are reprinted from 
Clinical Cancer Research, 2019, 25 (23), 7162–7174, 
Fieke E.M. Froeling, Manojit Mosur Swamynathan, Astrid Deschênes, 
Iok In Christine Chio, Erin Brosnan, Melissa A. Yao, Priya Alagesan, 
Matthew Lucito, Juying Li, An-Yun Chang, Lloyd C. Trotman, Pascal Belleau, 
Youngkyu Park, Harry A. Rogoff, James D. Watson, David A. Tuveson, 
Bioactivation of napabucasin triggers reactive oxygen species–mediated 
cancer cell death, with permission from AACR.

Robert L. Faure is also supported by the National Sciences Engineering 
Research Council of Canada (NSERCC): 155751-1501.

<br>
<br>

# Session info

Here is the output of sessionInfo() on the system on which this document 
was compiled:

```{r sessionInfo, echo=FALSE}
sessionInfo()
```


<br>
<br>

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{isCytoscapeRunning}
\alias{isCytoscapeRunning}
\title{Verifying that Cytoscape is running}
\usage{
isCytoscapeRunning()
}
\value{
a \code{logical} indicating if Cytoscape is running.
}
\description{
Verifying that Cytoscape is running
}
\examples{

## Test if Cytoscape is running
enrichViewNet:::isCytoscapeRunning()

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{formatInformationForCXJSON}
\alias{formatInformationForCXJSON}
\title{Transform the node and edge information into a format easy to process 
to create a CX JSON text file}
\usage{
formatInformationForCXJSON(results)
}
\arguments{
\item{results}{a \code{list} containing the information about the 
nodes and edges present in the network. TODOS}
}
\value{
a \code{list} containing 4 entries:
\itemize{
\item{\code{"nodes"}: a \code{data.frame} containing the information about
the nodes present in the network.}
\item{\code{"edges"}: a \code{data.frame} containing the information about
the edges present in the network.}
\item{\code{"nodeAttributes"}: a \code{data.frame} containing the attributes
associated to the nodes present in the network.}
\item{\code{"edgesAttributes"}: a \code{data.frame} containing the 
attributes associated to the edges present in the network}
}
}
\description{
Extract information about nodes and edges that is necessary
to create the CX JSON text representing the network
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retained the GO Molecular Function results
results <- parentalNapaVsDMSOEnrichment$result[
        parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]

## Extract node and edge information
info <- enrichViewNet:::extractNodesAndEdgesInformation(gostResults=results, 
            gostObject=parentalNapaVsDMSOEnrichment)
            
## Format node and edge information
information <- enrichViewNet:::formatInformationForCXJSON(result=info)

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichViewNet.R
\docType{data}
\name{rosaNapaVsDMSOEnrichment}
\alias{rosaNapaVsDMSOEnrichment}
\title{The result of an enrichment analysis that has been done using the 
significantly differentially expressed genes between 
napabucasin treated and DMSO control MiaPaCa2 cells stably expressing 
the Rosa26 control vector.
The cells were treated for 2 hour with 0.5 uM napabucasin.  
The protocol to generate the RNA-seq is described 
in Froeling F.E.M. et al 2019.}
\format{
a \code{list} created by gprofiler2 that contains the results 
from the enrichment analysis:
\itemize{
    \item{\code{"result"}: a \code{data.frame} with the significantly 
    enriched terms }
    \item{\code{"meta"}: a \code{list} with the meta-data information}
}
}
\source{
The original RNA-sequencing data is available at the Gene Expression 
Omnibus (GEO) under the accession number GSE135352.
}
\usage{
data(rosaNapaVsDMSOEnrichment)
}
\value{
a \code{list} created by gprofiler2 that contains the results 
from the enrichment analysis:
\itemize{
\item{\code{"result"}: a \code{data.frame} with the significantly enriched 
terms }
\item{\code{"meta"}: a \code{list} with the meta-data information}
}
}
\description{
The enrichment analysis was done with gprofile2 package 
(Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
g:SCS multiple testing correction method applying significance 
threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
as background.
}
\details{
The object is a named \code{list} with 2 entries. The 'result' entry 
contains a \code{data.frame} with the enrichment analysis results and 
the 'meta' entry contains metadata information.



The dataset used for the enrichment analysis is 
associated to this publication:

Froeling F.E.M. et al.Bioactivation of Napabucasin Triggers Reactive Oxygen 
Species–Mediated Cancer Cell Death. Clin Cancer Res 
1 December 2019; 25 (23): 7162–7174

The enrichment analysis has been done with gprofile2 package 
(Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
g:SCS multiple testing correction method applying significance 
threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
as background.
}
\examples{

## Loading dataset containing the enrichment analysis done on the 
## differentially expressed analysis between 2-hour treatment with 0.5 uM 
## napabucasin and DMSO control MiaPaCa2 cells stably expressing 
## the Rosa26 control vector
data(rosaNapaVsDMSOEnrichment)

## Create an enrichment map for the KEGG terms
createEnrichMap(gostObject=rosaNapaVsDMSOEnrichment, 
    query="rosa_napa_vs_DMSO", source="KEGG")

}
\seealso{
\itemize{
    \item{\link{createNetwork} for transforming functional 
    enrichment results from gprofiler2 into a Cytoscape network}
    \item{\link{createEnrichMap} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{createCXJSONForCytoscape}
\alias{createCXJSONForCytoscape}
\title{Create CX JSON text representing the network}
\usage{
createCXJSONForCytoscape(nodeEdgeInfo, title)
}
\arguments{
\item{nodeEdgeInfo}{a \code{list} created by gprofiler2 that contains
the results from an enrichment analysis. TODO}

\item{title}{a \code{character} string representing the name assigned to
the network.}
}
\value{
\code{character} string that represent the network in a CX JSON
format.
}
\description{
Create a CX JSON text that represent the network which
includes information about nodes and edges present in the network.
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retained the GO Molecular Function results
results <- parentalNapaVsDMSOEnrichment$result[
        parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]

## Extract node and edge information
information <- enrichViewNet:::extractInformationWhenIntersection(
        gostResults=results)

jsonFormat <- enrichViewNet:::createCXJSONForCytoscape(
                nodeEdgeInfo=information, title="WikiPathways")

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{validateCreateNetworkArguments}
\alias{validateCreateNetworkArguments}
\title{Validate arguments passed to creatNetwork() function}
\usage{
validateCreateNetworkArguments(
  gostObject,
  source,
  termIDs,
  removeRoot,
  query,
  title,
  collection,
  fileName
)
}
\arguments{
\item{gostObject}{a \code{list} created by \code{gprofiler2} that contains
the results from an enrichment analysis.}

\item{source}{a \code{character} string representing the selected source
that will be used to generate the network. To hand-pick the terms to be
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology
Cellular Component, "GO:MF" for Gene Ontology Molecular Function,
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.}

\item{termIDs}{a \code{vector} of \code{character} strings that contains
the term IDs retained for the creation of the network. This parameter is
only used when \code{source} is set to "TERM_ID".}

\item{removeRoot}{a \code{logical} that specified if the root terms of
the selected source should be removed (when present).}

\item{query}{a \code{character} string that specified the retained query to 
generate the network or \code{NULL}.}

\item{title}{a \code{character} string representing the name assigned to 
the network.}

\item{collection}{a \code{character} string representing the collection 
name assigned to the network.}

\item{fileName}{a \code{character} string representing the name of the
CX JSON file that is created when Cytoscape is not running. The name
must have a '.cx' extension.}
}
\value{
\code{TRUE} when all arguments are valid
}
\description{
Validate the arguments passed to creatNetwork() function.
First, the object containing the enrichment results must correspond to a
object created by  \code{gprofiler2} software. Second, the selected
source must at least have one enriched term in the results. Then, if the
source is 'TERM_ID', the listed terms must be present in the enrichment
results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(demoGOST)

## Check that all arguments are valid
enrichViewNet:::validateCreateNetworkArguments(gostObject=demoGOST,
    source="GO:BP", termIDs=NULL, removeRoot=FALSE, query=NULL, 
    title="Network graph Test",
    collection="test collection", fileName="test.cx")

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmap.R
\encoding{UTF-8}
\name{createEnrichMap}
\alias{createEnrichMap}
\title{Using functional enrichment results in  gprofiler2 format to create  
an enrichment map}
\usage{
createEnrichMap(
  gostObject,
  query,
  source = c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA",
    "CORUM", "HP", "WP"),
  termIDs = NULL,
  removeRoot = TRUE,
  showCategory = 30L,
  groupCategory = FALSE,
  categoryLabel = 1,
  categoryNode = 1,
  line = 1,
  ...
)
}
\arguments{
\item{gostObject}{a \code{list} corresponding to gprofiler2 enrichment 
output that contains and that contains 
the results from an enrichment analysis.}

\item{query}{a \code{character} string representing the name of the query 
that is going to be used to generate the graph. The query must exist in the 
\code{gostObject} object.}

\item{source}{a \code{character} string representing the selected source 
that will be used to generate the network. To hand-pick the terms to be 
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID".}

\item{termIDs}{a \code{vector} of \code{character} strings that contains the
term IDS retained for the creation of the network. Default: \code{NULL}.}

\item{removeRoot}{a \code{logical} that specified if the root terms of 
the selected source should be removed (when present). Default: \code{TRUE}.}

\item{showCategory}{a positive \code{integer} representing the maximum 
number of terms to display.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{NULL}, all terms  
will be displayed. Default: \code{30L}.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped. Default: \code{FALSE}.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1). Default: \code{1}.s}

\item{categoryNode}{a positive \code{numeric} representing the amount by 
which plotting category nodes should be scaled relative to the default (1).
Default: \code{1}.}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width. Default: \code{1}.}

\item{...}{additional arguments that will be pass to the 
\code{\link[enrichplot]{emapplot}} function.}
}
\value{
a \code{ggplot} object which is the enrichment map for enrichment 
results.
}
\description{
User selected enrichment terms are used to create an enrichment 
map. The selection of the term can by specifying by the 
source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
term IDs. The map is only generated when there is at least on 
significant term to graph.
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Extract query information (only one in this dataset)
query <- unique(parentalNapaVsDMSOEnrichment$result$query)

## Create graph for Gene Ontology - Cellular Component related results
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
    query=query, source="GO:CC", removeRoot=TRUE)


}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{manageQueryDuplicationInEmap}
\alias{manageQueryDuplicationInEmap}
\title{Change query name when more than one queries have  
the same name}
\usage{
manageQueryDuplicationInEmap(queryList)
}
\arguments{
\item{queryList}{a \code{list} containing the query names.}
}
\value{
a \code{list} with the query names modified for queries   
with duplicated names.
}
\description{
The function adds an unique ID at the name of the query when 
more than one query have the same name.
}
\examples{

## List of query names with duplicated names
queryList <- list("parental_vs_DMSO", "rosa_vs_DMSO", "parental_vs_DMSO", 
    "rosa_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO")

## Change the query names for the duplicated names
enrichViewNet:::manageQueryDuplicationInEmap(queryList=queryList)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmap.R
\encoding{UTF-8}
\name{createEnrichMapMultiComplex}
\alias{createEnrichMapMultiComplex}
\title{Using functional enrichment results in gprofiler2 format to create  
an enrichment map with multiple groups from same or different enrichment 
analyses}
\usage{
createEnrichMapMultiComplex(
  gostObjectList,
  queryInfo,
  showCategory = 30L,
  groupCategory = FALSE,
  categoryLabel = 1,
  categoryNode = 1,
  line = 1,
  ...
)
}
\arguments{
\item{gostObjectList}{a \code{list} of \code{gprofiler2} objects that 
contain the results from an enrichment analysis. The list must contain at 
least 2 entries. The number of entries must correspond to the number of 
entries for the \code{queryList} parameter.}

\item{queryInfo}{a \code{data.frame} contains one row per group being 
displayed. The number of rows must correspond to the 
number of entries for the \code{gostObjectList} parameter. 
The mandatory columns are:
\itemize{
\item{\code{queryName}: a \code{character} string representing the name 
of the query retained for this group). The query names must exist in the 
associated \code{gostObjectList} objects and follow the same order. }
\item{\code{source}: a \code{character} string representing the selected 
source that will be used to generate the network. To hand-pick the terms to 
be used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID". }
\item{\code{removeRoot}: a \code{logical} that specified if the root terms 
of the selected source should be removed (when present). }
\item{\code{termIDs}: a \code{character} strings that contains the
term IDS retained for the creation of the network separated by a comma ',' 
when the "TERM_ID" source is selected. Otherwise, it should be a empty 
string (""). }
\item{\code{groupName}: a \code{character} strings that contains the 
name of the group to be shown in the legend. Each group has to have a 
unique name. }
}}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed. Default: \code{30L}.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped. Default: \code{FALSE}.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1). Default: \code{1}.}

\item{categoryNode}{a positive \code{numeric} representing the amount by 
which plotting category nodes should be scaled relative to the default (1).
Default: \code{1}.}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width. Default: \code{1}.}

\item{...}{additional arguments that will be pass to the 
\code{\link[enrichplot]{emapplot}} function.}
}
\value{
a \code{ggplot} object which is the enrichment map for enrichment 
results.
}
\description{
User selected enrichment terms are used to create an enrichment 
map. The selection of the term can by specifying by the 
source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
term IDs. The map is only generated when there is at least on 
significant term to graph.
}
\examples{

## Loading dataset containing results from 2 enrichment analyses done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

## Create list of enrichment objects required to generate the enrichment map
gostObjectList=list(parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)
    
## Create data frame containing required information enabling the 
## selection of the retained enriched terms for each enrichment analysis.
## One line per enrichment analyses present in the gostObjectList parameter
## With this data frame, the enrichment results will be split in 4 groups:
## 1) KEGG significant terms from parental napa vs DMSO (no root term)
## 2) REACTOME significant terms from parental napa vs DMSO (no root term)
## 3) KEGG significant terms from rosa napa vs DMSO (no root term)
## 4) REACTOME significant terms from rosa napa vs DMSO (no root term)
queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO", "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
    source=c("KEGG", "REAC", "KEGG", "REAC"), 
    removeRoot=c(TRUE, TRUE, TRUE, TRUE), termIDs=c("", "", "", ""), 
    groupName=c("parental - KEGG", "parental - Reactome", 
        "rosa - KEGG", "rosa - Reactome"), stringsAsFactors=FALSE)
    
## Create graph for KEGG and REACTOME significant results from 
## 2 enrichment analyses
createEnrichMapMultiComplex(gostObjectList=gostObjectList, 
    queryInfo=queryDataFrame, line=1.5)

}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{validateCreateEnrichMapMultiComplexAsIgraphArg}
\alias{validateCreateEnrichMapMultiComplexAsIgraphArg}
\title{Validate arguments passed to validateCreateEnrichMapMultiComplex() 
function}
\usage{
validateCreateEnrichMapMultiComplexAsIgraphArg(
  gostObjectList,
  queryInfo,
  showCategory,
  similarityCutOff = similarityCutOff
)
}
\arguments{
\item{gostObjectList}{a \code{list} of \code{gprofiler2} objects that 
contain the results from an enrichment analysis. The list must contain at 
least 2 entries. The number of entries must correspond to the number of 
entries for the \code{queryList} parameter.}

\item{queryInfo}{a \code{data.frame} contains one row per group being 
displayed. The number of rows must correspond to the 
number of entries for the \code{gostObjectList} parameter. 
The mandatory columns are:
\itemize{
\item{\code{queryName}: a \code{character} string representing the name 
of the query retained for this group). The query names must exist in the 
associated \code{gostObjectList} objects and follow the same order. }
\item{\code{source}: a \code{character} string representing the selected 
source that will be used to generate the network. To hand-pick the terms to 
be used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID". }
\item{\code{removeRoot}: a \code{logical} that specified if the root terms 
of the selected source should be removed (when present). }
\item{\code{termIDs}: a \code{character} strings that contains the
term IDS retained for the creation of the network separated by a comma ',' 
when the "TERM_ID" source is selected. Otherwise, it should be a empty 
string (""). }
\item{\code{groupName}: a \code{character} strings that contains the 
name of the group to be shown in the legend. Each group has to have a 
unique name. }
}}

\item{showCategory}{a positive \code{integer} or \code{NULL}. 
If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{NULL}, all terms will be 
displayed.}

\item{similarityCutOff}{a positive \code{numeric}, larger than zero and
small than 1 that represent the minimum similarity level between two 
nodes (terms) to be linked by an edge.}
}
\value{
\code{TRUE} when all arguments are valid
}
\description{
Validate the arguments passed to 
validateCreateEnrichMapMultiComplex() function.
First, the object containing the enrichment results must correspond to a 
object created by  \code{gprofiler2} software. Second, the selected 
source must at least have one enriched term in the results. Then, if the
source is 'TERM_ID', the listed terms must be present in the enrichment
results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
    "rosa_napa_vs_DMSO"), source=c("KEGG", "WP"), removeRoot=c(TRUE, TRUE),
    termIDs=c("", ""), groupName=c("parental - KEGG", "rosa - WP"), 
    stringsAsFactors=FALSE)

## Check that all arguments are valid
enrichViewNet:::validateCreateEnrichMapMultiComplexAsIgraphArg(
    gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                            rosaNapaVsDMSOEnrichment),
    queryInfo=queryDataFrame, showCategory=20, similarityCutOff=0.2)

}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichViewNet.R
\docType{package}
\encoding{UTF-8}
\name{enrichViewNet-package}
\alias{enrichViewNet-package}
\alias{enrichViewNet}
\title{From functional enrichment results to biological networks}
\description{
The \code{enrichViewNet} package enables the visualization 
of enrichment results, in a format corresponding to the one generated 
by \code{gprofiler2} 
(\url{https://cran.r-project.org/web/packages/gprofiler2/index.html})  
under the form of \code{Cytoscape} network (\url{https://cytoscape.org/}).
}
\details{
In those networks, both gene datasets (GO terms/pathways/protein complexes)
and genes are represented as nodes. A edge connect a gene to its datasets.
In the current version, only genes present in at least one gene dataset 
are retained.
}
\seealso{
\itemize{
    \item{\code{\link{createNetwork}} for transforming functional 
    enrichment results from gprofiler2 into a Cytoscape network}
    \item{\code{\link{createEnrichMap}} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map in 
    ggplot format}
    \item{\code{\link{createEnrichMapAsIgraph}} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map in 
    igraph format}
    \item{\code{\link{createEnrichMapMultiComplex}} for transforming 
    functional enrichment results from multiple gprofiler2 enrichment 
    results into an enrichment map in ggplot format}
    \item{\code{\link{createEnrichMapMultiComplexAsIgraph}} for transforming 
    functional enrichment results from multiple gprofiler2 enrichment 
    results into an enrichment map in igraph format}
}
}
\author{
Astrid Deschênes, Pascal Belleau, Robert L Faure,  
Maria J Fernandes, David A Tuveson

Maintainer:
Astrid Deschênes <adeschen@hotmail.com>
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichViewNet.R
\docType{data}
\name{parentalNapaVsDMSOEnrichment}
\alias{parentalNapaVsDMSOEnrichment}
\title{The result of an enrichment analysis has been done using the significantly 
differentially expressed genes between napabucasin treated and DMSO 
control parental MiaPaCa2 cells. 
The cells were treated for 2 hour with 0.5 uM napabucasin.  
The protocol to generate the RNA-seq is described 
in Froeling F.E.M. et al 2019.}
\format{
a \code{list} created by gprofiler2 that contains the results 
from the enrichment analysis:
\itemize{
    \item{\code{"result"}: a \code{data.frame} with the significantly 
    enriched terms }
    \item{\code{"meta"}: a \code{list} with the meta-data information}
}
}
\source{
The original RNA-sequencing data is available at the Gene Expression 
Omnibus (GEO) under the accession number GSE135352.
}
\usage{
data(parentalNapaVsDMSOEnrichment)
}
\value{
a \code{list} containing 2 entries:
\itemize{
    \item{\code{"result"}: a \code{data.frame} with the significantly 
    enriched terms }
    \item{\code{"meta"}: a \code{list} with the meta-data information}
}
}
\description{
The enrichment analysis was done with gprofile2 package 
(Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
g:SCS multiple testing correction method applying significance 
threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
as background.
}
\details{
The object is a named \code{list} with 2 entries. The 'result' entry 
contains a \code{data.frame} with the enrichment analysis results and 
the 'meta' entry contains metadata information.



The dataset used for the enrichment analysis is 
associated to this publication:

Froeling F.E.M. et al.Bioactivation of Napabucasin Triggers Reactive Oxygen 
Species–Mediated Cancer Cell Death. Clin Cancer Res 
1 December 2019; 25 (23): 7162–7174

The enrichment analysis has been done with gprofile2 package 
(Kolberg L et al 2020) with database version 'e109_eg56_p17_1d3191d' and 
g:SCS multiple testing correction method applying significance 
threshold of 0.05 (Raudvere U et al 2019). All tested genes were used 
as background.
}
\examples{

## Loading dataset containing the results of the enrichment analysis 
## done on a differentially expressed 
## analysis between 2-hour treatment with 0.5 uM napabucasin and 
## DMSO vehicle control parental MiaPaCa2 cells
data(parentalNapaVsDMSOEnrichment)

## Create an enrichment map for the GO:CC terms
createEnrichMap(gostObject=parentalNapaVsDMSOEnrichment, 
    query="parental_napa_vs_DMSO", source="GO:CC")

}
\seealso{
\itemize{
    \item{\link{createNetwork} for transforming functional 
    enrichment results from gprofiler2 into a Cytoscape network}
    \item{\link{createEnrichMap} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map}
    \item{\link{createEnrichMapAsIgraph} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map in a igraph 
    format}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichViewNet.R
\docType{data}
\name{rosaNapaVsDMSODEG}
\alias{rosaNapaVsDMSODEG}
\title{The result of a differential expression analysis done between 
napabucasin treated and DMSO control MiaPaCa2 cells stably expressing 
the Rosa26 control vector. The cells were treated for 2 hours  
with 0.5 uM napabucasin.
The protocol to generate the RNA-seq is described 
in Froeling F.E.M. et al 2019.}
\format{
a \code{data.frame} containing the results of a differential 
expression analysis between napabucasin treated and DMSO control MiaPaCa2 
cells stably expressing the Rosa26 control vector for all 23542 genes 
tested. The 4 columns are:
\itemize{
\item{\code{"EnsemblID"}: a \code{character} string representing the 
unique Ensembl identifier for the tested gene}
\item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
difference (in log2FoldChange) between the napabucasin treatment and 
the DMSO control for the tested gene}
\item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
associated to the difference in expression for the tested gene}
\item{\code{"GeneName"}: a \code{character} string representing the name of 
the tested gene}
}
}
\source{
The original RNA-sequencing data is available at the Gene Expression 
Omnibus (GEO) under the accession number GSE135352.
}
\usage{
data(rosaNapaVsDMSODEG)
}
\value{
a \code{data.frame} containing the results of a differential 
expression analysis between napabucasin treated and DMSO control MiaPaCa2 
cells stably expressing the Rosa26 control vector for all 23542 genes 
tested. The 4 columns are:
\itemize{
\item{\code{"EnsemblID"}: a \code{character} string representing the 
unique Ensembl identifier for the tested gene}
\item{\code{"log2FoldChange"}: a \code{numeric} representing the expression 
difference (in log2FoldChange) between the napabucasin treatment and 
the DMSO control for the tested gene}
\item{\code{"padj"}: a \code{numeric} representing the adjusted p-value 
associated to the difference in expression for the tested gene}
\item{\code{"GeneName"}: a \code{character} string representing the name of 
the tested gene}
}
}
\description{
The object is a \code{data.frame} with 23542 rows and 4 columns. 
Each row correspond to a tested gene.
}
\details{
The differentially expressed genes between napabucasin-treated 
cells (0.5 uM) and DMSO as vehicle control are reprinted from Clinical 
Cancer Research, 2019, 25 (23), 7162–7174, Fieke E.M. Froeling, Manojit 
Mosur Swamynathan, Astrid Deschênes, Iok In Christine Chio, Erin Brosnan, 
Melissa A. Yao, Priya Alagesan, Matthew Lucito, Juying Li, An-Yun Chang, 
Lloyd C. Trotman, Pascal Belleau, Youngkyu Park, Harry A. Rogoff, 
James D. Watson, David A. Tuveson, Bioactivation of napabucasin triggers 
reactive oxygen species–mediated cancer cell death, with permission 
from AACR.
}
\examples{

## Required library
library(gprofiler2)

## Loading dataset containing the results of a differentially expressed 
## analysis between 2-hour treatment with 0.5 uM napabucasin and 
## DMSO vehicle control MiaPaCa2 cells stably expressing the 
## Rosa26 control vector
data(rosaNapaVsDMSODEG)

allGenes <- unique(rosaNapaVsDMSODEG$EnsemblID)

## Select the significantly differentially expressed genes
selection <- which(abs(rosaNapaVsDMSODEG$log2FoldChange) > 1 & 
                            rosaNapaVsDMSODEG$padj < 0.05)
                            
selectedGenes <- unique(rosaNapaVsDMSODEG$EnsemblID[selection])

## Run an enrichment analysis using Transfac dataset (transcription factor)
gostres <- gost(query = list(rosa_napa_vs_DMSO=selectedGenes),
    organism="hsapiens",
    correction_method = "g_SCS",
    sources=c("TF"), significant=TRUE, evcodes=TRUE,
    custom_bg=allGenes, exclude_iea=TRUE)



}
\seealso{
\itemize{
    \item{\link{createNetwork} for transforming functional 
    enrichment results from gprofiler2 into a Cytoscape network}
    \item{\link{createEnrichMap} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmap.R
\encoding{UTF-8}
\name{createEnrichMapMultiComplexAsIgraph}
\alias{createEnrichMapMultiComplexAsIgraph}
\title{Using functional enrichment results in gprofiler2 format to create  
an enrichment map with multiple groups from same or different enrichment 
analyses in an igraph format}
\usage{
createEnrichMapMultiComplexAsIgraph(
  gostObjectList,
  queryInfo,
  showCategory = 30L,
  similarityCutOff = 0.2
)
}
\arguments{
\item{gostObjectList}{a \code{list} of \code{gprofiler2} objects that 
contain the results from an enrichment analysis. The list must contain at 
least 2 entries. The number of entries must correspond to the number of 
entries for the \code{queryList} parameter.}

\item{queryInfo}{a \code{data.frame} contains one row per group being 
displayed. The number of rows must correspond to the 
number of entries for the \code{gostObjectList} parameter. 
The mandatory columns are:
\itemize{
\item{\code{queryName}: a \code{character} string representing the name 
of the query retained for this group). The query names must exist in the 
associated \code{gostObjectList} objects and follow the same order. }
\item{\code{source}: a \code{character} string representing the selected 
source that will be used to generate the network. To hand-pick the terms to 
be used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID". }
\item{\code{removeRoot}: a \code{logical} that specified if the root terms 
of the selected source should be removed (when present). }
\item{\code{termIDs}: a \code{character} strings that contains the
term IDS retained for the creation of the network separated by a comma ',' 
when the "TERM_ID" source is selected. Otherwise, it should be a empty 
string (""). }
\item{\code{groupName}: a \code{character} strings that contains the 
name of the group to be shown in the legend. Each group has to have a 
unique name. }
}}

\item{showCategory}{a positive \code{integer} or \code{NULL}. 
If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{NULL}, all terms will be 
displayed. Default: \code{30L}.}

\item{similarityCutOff}{a positive \code{numeric}, larger than zero and
small than 1 that represent the minimum similarity level between two 
nodes (terms) to be linked by an edge. Default: \code{0.2}.}
}
\value{
a \code{igraph} object which is the enrichment map for enrichment 
results. The node have 5 attributes: "name", "size", "pie", "cluster", 
and "pieName". The "name" corresponds to the term description. While the 
"size" corresponds to the number of unique genes found in the specific 
gene set when looking at all the experiments. 
The edges have 3 attributes: "similarity", "width", and 
"weight". All those 3 attributes correspond to the Jaccard coefficient.
}
\description{
User selected enrichment terms are used to create an enrichment 
map. The selection of the term can by specifying by the 
source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
term IDs. The map is only generated when there is at least on 
significant term to graph.
}
\examples{

## Loading dataset containing results from 2 enrichment analyses done with
## gprofiler2 queries
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

## The graph will be split in 4 groups
## Groups 1 and 2 are using the parental Napa vs DMSO dataset
## Group 3 and 4 are using the rosa Napa vs DMSO dataset
gostObjectList=list(parentalNapaVsDMSOEnrichment, 
    parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment, 
    rosaNapaVsDMSOEnrichment)
    
## Create data frame containing required information enabling the 
## selection of the retained enriched terms for each enrichment analysis.
## One line per enrichment analyses present in the gostObjectList parameter
## With this data frame, the enrichment results will be split in 4 groups:
## 1) KEGG significant terms from parental napa vs DMSO (no root term)
## 2) REACTOME significant terms from parental napa vs DMSO (no root term)
## 3) KEGG significant terms from rosa napa vs DMSO (no root term)
## 4) REACTOME significant terms from rosa napa vs DMSO (no root term)
queryDataFrame <- data.frame(queryName=c("parental_napa_vs_DMSO", 
        "parental_napa_vs_DMSO", "rosa_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
    source=c("KEGG", "REAC", "KEGG", "REAC"), 
    removeRoot=c(TRUE, TRUE, TRUE, TRUE), termIDs=c("", "", "", ""), 
    groupName=c("parental - KEGG", "parental - Reactome", 
        "rosa - KEGG", "rosa - Reactome"), stringsAsFactors=FALSE)
    
## Create graph for KEGG and REACTOME significant results from 
## 2 enrichment analyses in an igraph format
emap <- createEnrichMapMultiComplexAsIgraph(gostObjectList=gostObjectList, 
    queryInfo=queryDataFrame, showCategory=5)

if (requireNamespace("ggplot2", quietly=TRUE) && 
        requireNamespace("igraph", quietly=TRUE) && 
        requireNamespace("scatterpie", quietly=TRUE) && 
        requireNamespace("ggtangle", quietly=TRUE) && 
        requireNamespace("ggrepel", quietly=TRUE)) {
    ## Create a visual representation of the enrichment map
    ## by default
    library(igraph)
    plot(emap)
    
    ## Add see to reproduce the same graph
    set.seed(12)
    
    library(ggplot2)
    library(ggtangle)
    library(scatterpie)
    library(ggrepel)
    
    emapG <- ggplot(emap, layout=layout_with_fr) + 
                geom_edge(color="gray", linewidth=1)
    
    pieInfo <- as.data.frame(do.call(rbind, V(emap)$pie))
    colnames(pieInfo) <- V(emap)$pieName[[1]]
    
    ## Add information about the groups associated with each node in the 
    ## ggplot object so that the node can be colored accordingly
    for (i in seq_len(ncol(pieInfo))) {
        emapG$data[colnames(pieInfo)[i]] <- pieInfo[, i]
    }
    
    ## Using scatterpie, ggtangle and ggrepel to generate the graph
    ## geom_scatterpie() allows to have scatter pie plot
    ## geom_text_repel() allows to have minimum overlying terms
    ## coord_fixed() forces the plot to have a 1:1 aspect ratio
    emapG + 
        geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name = "Group", color=NA) +
        geom_scatterpie_legend(radius=emapG$data$size/50, n=4, 
            x=max(emapG$data$x), y=max(emapG$data$y),
            labeller=function(x) {round(x*50)}, label_position="right") +
        geom_text_repel(aes(x=x, y=y, label=label), max.overlaps=20) +
        coord_fixed()
}

}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{createBasicEmap}
\alias{createBasicEmap}
\title{Create a basic enrichment map}
\usage{
createBasicEmap(
  gostResults,
  backgroundGenes,
  showCategory,
  groupCategory,
  categoryLabel,
  categoryNode,
  significantMethod,
  line,
  ...
)
}
\arguments{
\item{gostResults}{a \code{data.frame} containing the enrichment 
results to be plot.}

\item{backgroundGenes}{a \code{vector} of \code{character} string 
representing the name of the genes present in the request.}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1).}

\item{categoryNode}{a positive \code{numeric} representing the amount by 
which plotting category nodes should be scaled relative to the default (1).}

\item{significantMethod}{a \code{character} string representing the name 
of the multiple testing correction method used on the results.}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width.}

\item{...}{additional arguments that will be pass to the 
\code{\link[enrichplot]{emapplot}} function.}
}
\value{
a \code{ggplot} object representing the enrichment map.
}
\description{
The function creates a basic enrichment map using functional 
enrichment results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retain the results section
gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)

## Limit the results to Wikipathways
## and remove the root term
gostResults <- gostResults[which(gostResults$source == "WP"),]
gostResults <- gostResults[which(gostResults$term_name != "WIKIPATHWAYS"),]

## Extract meta data information
meta <- parentalNapaVsDMSOEnrichment$meta

## Get all background genes
backgroundGenes <- meta$query_metadata$queries[["parental_napa_vs_DMSO"]]

## Get significant method
significantMethod <- meta$query_metadata$significance_threshold_method

## Create basic enrichment map using Wikipathways terms
enrichViewNet:::createBasicEmap(gostResults=gostResults, 
    backgroundGenes=backgroundGenes, showCategory=30L, 
    groupCategory=FALSE, categoryLabel=1, categoryNode=1,
    significantMethod=significantMethod, line=1)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methods.R
\encoding{UTF-8}
\name{createNetwork}
\alias{createNetwork}
\title{Using functional enrichment results from gprofiler2 to create a 
Cytoscape network}
\usage{
createNetwork(
  gostObject,
  source = c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA",
    "CORUM", "HP", "WP"),
  termIDs = NULL,
  removeRoot = TRUE,
  query = NULL,
  title = "gprofiler network",
  collection = "enrichment results",
  fileName = "gprofilerNetwork.cx"
)
}
\arguments{
\item{gostObject}{a \code{list} created by gprofiler2 that contains
the results from an enrichment analysis.}

\item{source}{a \code{character} string representing the selected source 
that will be used to generate the network. To hand-pick the terms to be 
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID".}

\item{termIDs}{a \code{vector} of \code{character} strings that contains the
term IDS retained for the creation of the network. Default: \code{NULL}.}

\item{removeRoot}{a \code{logical} that specified if the root terms of 
the selected source should be removed (when present). Default: \code{TRUE}.}

\item{query}{a \code{character} string that specified the retained query to 
generate the network. When \code{NULL}, the query present in the result 
is retained; \code{NULL} cannot be used when more than one query is present. 
Default: \code{NULL}.}

\item{title}{a \code{character} string representing the name assigned to 
the network. Default: "gprofiler network".}

\item{collection}{a \code{character} string representing the collection 
name assigned to the network. Default: "enrichment results".}

\item{fileName}{a \code{character} string representing the name of the
CX JSON file that is created when Cytoscape is not running. The name 
must have a '.cx' extension.
Default: "gprofilerNetwork_01.cx".}
}
\value{
\code{TRUE}
}
\description{
User selected enrichment terms are used to create a Cytoscape 
network where the selected terms and the genes that where part of the 
enrichment analysis are all represented as nodes. Edges are linking the 
genes to their terms. The selection of the term can by specifying  the 
source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
term IDs. The network is only generated when there is at least on 
significant term to graph. When the enrichment analysis contains more than 
one query, only one query can be selected to generate the network.
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Some of the enrichment results present in the dataset
head(parentalNapaVsDMSOEnrichment$result)

## Create network for Gene Ontology - Molecular Function related results
## in Cytoscape (when the application is opened)
## Otherwise, create a CX file in the temporary directory
## The file can be opened in Cytoscape
createNetwork(gostObject=parentalNapaVsDMSOEnrichment, source="KEGG", 
    removeRoot=FALSE, title="KEGG Graph", 
    fileName=file.path(tempdir(), "KEGG_demo.cx"))


}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{extractNodesAndEdgesInformation}
\alias{extractNodesAndEdgesInformation}
\title{Extract node and edge information from the enrichment results}
\usage{
extractNodesAndEdgesInformation(gostResults, gostObject)
}
\arguments{
\item{gostResults}{a \code{data.frame} containing the terms retained
for the creation of the network. The \code{data.frame} does not contain a
column called "intersection".}

\item{gostObject}{a \code{list} created by gprofiler2 that contains
the results from an enrichment analysis.}
}
\value{
\code{list} containing 2 entries:
\itemize{
\item{\code{"geneNodes"}: a \code{data.frame} containing the information 
about the nodes present in the network. The nodes are genes.}
\item{\code{"termNodes"}: a \code{data.frame} containing the information 
about the nodes present in the network. The nodes are terms.}
\item{\code{"edges"}: a \code{data.frame} containing the information about
the edges present in the network. The edges connect one gene to one term.}
}
}
\description{
Create a list containing all node and edge information needed
to create the network
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retained the GO Molecular Function results
results <- parentalNapaVsDMSOEnrichment$result[
        parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]

## Extract node and edge information
information <-
    enrichViewNet:::extractNodesAndEdgesInformation(
        gostResults=results, gostObject=parentalNapaVsDMSOEnrichment)

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{validateCreateEnrichMapMultiBasicArgs}
\alias{validateCreateEnrichMapMultiBasicArgs}
\title{Validate arguments passed to createEnrichMapMultiBasic() function}
\usage{
validateCreateEnrichMapMultiBasicArgs(
  gostObjectList,
  queryList,
  source,
  termIDs,
  removeRoot,
  showCategory,
  groupCategory,
  categoryLabel,
  categoryNode,
  line
)
}
\arguments{
\item{gostObjectList}{a \code{list} of \code{gprofiler2} objects that 
contain the results from an enrichment analysis. The list must contain at 
least 2 entries. The number of entries must correspond to the number of 
entries for the \code{queryList} parameter.}

\item{queryList}{a \code{list} of \code{character} strings representing the 
names of the queries that are going to be used to generate the graph. 
The query names must exist in the associated \code{gostObjectList} objects 
and follow the same order. The number of entries must correspond to the 
number of entries for the \code{gostObjectList} parameter.}

\item{source}{a \code{character} string representing the selected source 
that will be used to generate the network. To hand-pick the terms to be 
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.}

\item{termIDs}{a \code{vector} of \code{character} strings that contains 
the term IDs retained for the creation of the network. This parameter is 
only used when \code{source} is set to "TERM_ID".}

\item{removeRoot}{a \code{logical} that specified if the root terms of 
the selected source should be removed (when present).}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1).}

\item{categoryNode}{a positive \code{numeric} representing he amount by 
which plotting category nodes should be scaled relative to the default (1).}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width.}
}
\value{
\code{TRUE} when all arguments are valid
}
\description{
Validate the arguments passed to createEnrichMapMultiBasic() 
function.
First, the object containing the enrichment results must correspond to a 
object created by  \code{gprofiler2} software. Second, the selected 
source must at least have one enriched term in the results. Then, if the
source is 'TERM_ID', the listed terms must be present in the enrichment
results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

## Check that all arguments are valid
enrichViewNet:::validateCreateEnrichMapMultiBasicArgs(
    gostObjectList=list(parentalNapaVsDMSOEnrichment, 
                            rosaNapaVsDMSOEnrichment),
    queryList=list("parental_napa_vs_DMSO", "rosa_napa_vs_DMSO"), 
    source="GO:BP", termIDs=NULL, removeRoot=FALSE, 
    showCategory=20, groupCategory=FALSE, 
    categoryLabel=1.1, categoryNode=1, line=1.2)

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{createMultiEmap}
\alias{createMultiEmap}
\title{Create a basic enrichment map}
\usage{
createMultiEmap(
  gostResultsList,
  queryList,
  showCategory,
  groupCategory,
  categoryLabel,
  categoryNode,
  line,
  ...
)
}
\arguments{
\item{gostResultsList}{a \code{list} of \code{data.frame} containing 
the enrichment results to be plot with different group identification.}

\item{queryList}{a \code{list} of \code{character} string 
representing the name of query retained for each enrichment results present 
in the \code{gostResultsList} parameter. The query should be present in its 
associated enrichment results.}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1).}

\item{categoryNode}{a positive \code{numeric} representing the amount by 
which plotting category nodes should be scaled relative to the default (1).}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width.}

\item{...}{additional arguments that will be pass to the 
\code{\link[enrichplot]{emapplot}} function.}
}
\value{
a \code{ggplot} object representing the enrichment map with 
different colors for each group of enrichment results.
}
\description{
The function creates a basic enrichment map using functional 
enrichment results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retain the results section
gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)

## Limit the results subsection of REACTOME and KEGG
gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
gostResultsREAC <- gostResultsREAC[1:13, ]
gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]

## Extract meta data information
queryList <- list("parental - REACTOME", "parental - KEGG")

## Create basic enrichment map using Wikipathways terms
enrichViewNet:::createMultiEmap(gostResultsList=list(gostResultsREAC, 
    gostResultsKEGG), queryList=queryList, showCategory=30L, 
    groupCategory=FALSE, categoryLabel=1, categoryNode=1, line=1.4)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{filterResults}
\alias{filterResults}
\title{Filter the results to retain only the selected terms}
\usage{
filterResults(gostResults, source, termIDs, removeRoot)
}
\arguments{
\item{gostResults}{a \code{data.frame} containing the enriched terms that 
should be filtered.}

\item{source}{a \code{character} string representing the selected source 
that will be used to generate the network. To hand-pick the terms to be 
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.}

\item{termIDs}{a \code{vector} of \code{character} strings that contains the
term IDS retained for the creation of the network or \code{NULL}.}

\item{removeRoot}{a \code{logical} that specified if the root terms of 
the selected source should be removed (when present).}
}
\value{
a \code{data.frame} of filtered terms with or without the root term.
}
\description{
Filter the enrichment results to retain only the selected 
terms and remove root term if requested.
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(demoGOST)

## Only retained the GO - Molecular Function results
results <- demoGOST$result

## Remove WIKIPATHWAYS root term
selected <- enrichViewNet:::filterResults(gostResults=results, source="WP", 
    termIDs=NULL, removeRoot=TRUE)


}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{similarityJaccard}
\alias{similarityJaccard}
\title{Calculate the Jaccard similarity coefficient for the terms present
in a data frame}
\usage{
similarityJaccard(resultDF)
}
\arguments{
\item{resultDF}{a \code{data.frame} containing the enrichment 
terms that are going to be graphed as an enrichment map. The 
\code{data.frame} must contain the \code{geneID} and \code{Description} 
columns.}
}
\value{
a \code{matrix} with the lower triangle section containing the 
Jaccard similarity coefficients as \code{numeric}. The upper triangle 
section is filled with \code{NA} as well as the diagonal.
}
\description{
The function calculates the Jaccard similarity coefficient for 
the enriched terms present i a data frame.
}
\examples{

## Data frame with the enriched terms
resultData <- data.frame( 
    ID=c("REAC:R-HSA-9031628", "REAC:R-HSA-9648895", "REAC:R-HSA-9614085",
            "REAC:R-HSA-166520"),
    Description=c("NGF-stimulated transcription", 
            "Response of EIF2AK1 (HRI) to heme deficiency",
            "FOXO-mediated transcription", "Signaling by NTRKs"),
    geneID=c(paste0("ENSG00000120738/ENSG00000122877/ENSG00000125740/",
        "ENSG00000135625/ENSG00000170345/ENSG00000171223/ENSG00000173334/", 
        "ENSG00000179388/ENSG0000019857"),
        paste0("ENSG00000087074/ENSG00000128272/ENSG00000128965/", 
        "ENSG00000162772/ENSG00000172216/ENSG00000175197"),
        paste0("ENSG00000105327/ENSG00000113916/ENSG00000124762/", 
        "ENSG00000133639/ENSG00000136826/ENSG00000153094/ENSG00000175197"),
        paste0("ENSG00000105327/ENSG00000113916/ENSG00000124762/", 
        "ENSG00000133639/ENSG00000136826/ENSG00000153094/ENSG0000017519/",
        "ENSG00000120738/ENSG00000122877/ENSG00000125740/ENSG00000135625/",
        "ENSG00000170345/ENSG00000171223/ENSG00000173334/ENSG00000179388/", 
        "ENSG00000198576")))

## Calculate the Jaccard similarity coefficient for all pairwise 
## term combination
enrichViewNet:::similarityJaccard(resultDF=resultData)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{createNetworkForCytoscape}
\alias{createNetworkForCytoscape}
\title{Create network and load it into Cytoscape}
\usage{
createNetworkForCytoscape(nodeEdgeInfo, title, collection)
}
\arguments{
\item{nodeEdgeInfo}{a TODO}

\item{title}{a \code{character} string representing the name assigned to
the network.}

\item{collection}{a \code{character} string representing the collection
name assigned to the network.}
}
\value{
\code{TRUE}
}
\description{
Create network from gprofiler2 results and load it
into Cytoscape
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retained the GO Molecular Function results
results <- parentalNapaVsDMSOEnrichment$result[
        parentalNapaVsDMSOEnrichment$result$source == "GO:MF", ]

## Extract node and edge information
information <- enrichViewNet:::extractInformationWhenIntersection(
        gostResults=results)
    
## The creation of the network can only be done when Cytoscape
## is up and running
## A network using GO - Molecular Function enriched terms will be
## generated and loaded into Cytoscape
if (enrichViewNet:::isCytoscapeRunning()) {
    enrichViewNet:::createNetworkForCytoscape(nodeEdgeInfo=information, 
        title="Test", collection="New Collection")
}

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{createMetaDataSectionCXJSON}
\alias{createMetaDataSectionCXJSON}
\title{Create meta data section for the CX JSON file}
\usage{
createMetaDataSectionCXJSON()
}
\value{
a \code{JSON} object that contains the meta data section related
to the network
}
\description{
Create meta data section for the CX JSON file that contains
the network information
}
\examples{

## Create the JSON object that contains the meta data information
enrichViewNet:::createMetaDataSectionCXJSON()

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{removeRootTerm}
\alias{removeRootTerm}
\title{Remove root term if present in the list of selected terms}
\usage{
removeRootTerm(gostResult)
}
\arguments{
\item{gostResult}{a \code{data.frame} containing the terms retained
for the creation of the network.}
}
\value{
a \code{data.frame} of selected terms without the root term.
}
\description{
Remove root term if present in the list of selected terms
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(demoGOST)

## Only retained the WikiPathways results
results <- demoGOST$result[demoGOST$result$source == "WP", ]

## Remove WIKIPATHWAYS root term
enrichViewNet:::removeRootTerm(gostResult=results)


}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{manageNameDuplicationInEmap}
\alias{manageNameDuplicationInEmap}
\title{Change name description in data frame when more than one term as 
the same name}
\usage{
manageNameDuplicationInEmap(clProfDF)
}
\arguments{
\item{clProfDF}{a \code{data.frame} containing the enrichment 
terms that are going to be graphed as an enrichment map. The 
\code{data.frame} must contain at least one case of duplicated name 
descriptions for different term IDs.}
}
\value{
a \code{data.frame} with the name descriptions modified for terms 
with duplicated name descriptions but different term IDs.
}
\description{
The function adds the ID of the term at the name of the name 
description when terms with different ID share the same name. For example, 
"MAPK pathway" would become "MAPK pathway (KEGG:04010)".
}
\examples{

## Data frame with duplicated name descriptions for different IDs
clustData <- data.frame(Cluster=c("group 1" , "group 1", "group 2"), 
    ID=c("WP:WP4925", "WP:WP382", "KEGG:04010"),
    Description=c("Unfolded protein response", 
                    rep("MAPK signaling pathway", 2)),
    GeneRatio=c("4/157", "3/157", "3/157"),
    BgRatio=c("4/24022", "3/24022", "3/24022"),
    pvalues=c(1.55e-4, 8.13e-8, 4.33e-5),
    p.adjust=c(1e-3, 1e-3, 1.4e-3), qvalue=c(1e-3, 1e-3, 1.4e-3), 
    geneID=c("ENSG000107968/ENSG000120129/ENSG000123358/ENSG000158050",
        "ENSG000107968/ENSG000120129/ENSG000158050",
        "ENSG000107968/ENSG000120129/ENSG000158050"),
    Count=c(4, 3, 3))

## Change the name descriptions for the duplicated terms
enrichViewNet:::manageNameDuplicationInEmap(clProfDF=clustData)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{createCompareResultDataFrame}
\alias{createCompareResultDataFrame}
\title{Create a data frame containing the compiled enrichment results from
multiple queries}
\usage{
createCompareResultDataFrame(queryList, gostResultsList)
}
\arguments{
\item{queryList}{a \code{list} containing the query names.}

\item{gostResultsList}{a \code{list} of \code{data.frame} containing 
the enrichment results to be plot with different group identification.}
}
\value{
a \code{data.frame} object
}
\description{
The function creates a data frame object using the
list of queries and list of enrichment results given be the user.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retain the results section
gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)

## Limit the results subsection of REACTOME and KEGG
## Kegg is replicated to show shared results between queries
gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
gostResultsREAC <- gostResultsREAC[1:13, ]
gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]
gostResultsKEGG2 <- gostResultsKEGG[1:6,]

## List of query names with duplicated names
queryList <- list("parental_vs_DMSO", "rosa_vs_DMSO", "parental_vs_DMSO", 
    "rosa_vs_DMSO", "parental_vs_Control", "rosa_vs_DMSO")
    
## Extract meta data information
queryList <- list("parental - REACTOME", "parental - KEGG - v1", 
    "parental - KEGG - v2")

## Change the query names for the duplicated names
enrichViewNet:::createCompareResultDataFrame(queryList=queryList,
    gostResultsList=list(gostResultsREAC, gostResultsKEGG, 
            gostResultsKEGG2))
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmap.R
\encoding{UTF-8}
\name{createEnrichMapMultiBasicAsIgraph}
\alias{createEnrichMapMultiBasicAsIgraph}
\title{Using functional enrichment results in gprofiler2 format to create  
an enrichment map with multiple groups from different enrichment analyses as
an igraph}
\usage{
createEnrichMapMultiBasicAsIgraph(
  gostObjectList,
  queryList,
  source = c("TERM_ID", "GO:MF", "GO:CC", "GO:BP", "KEGG", "REAC", "TF", "MIRNA", "HPA",
    "CORUM", "HP", "WP"),
  termIDs = NULL,
  removeRoot = TRUE,
  showCategory = 30L,
  similarityCutOff = 0.2
)
}
\arguments{
\item{gostObjectList}{a \code{list} of \code{gprofiler2} objects that 
contain the results from an enrichment analysis. The list must contain at 
least 2 entries. The number of entries must correspond to the number of 
entries for the \code{queryList} parameter.}

\item{queryList}{a \code{list} of \code{character} strings representing the 
names of the queries that are going to be used to generate the graph. 
The query names must exist in the associated \code{gostObjectList} objects 
and follow the same order. The number of entries must correspond to the 
number of entries for the \code{gostObjectList} parameter.}

\item{source}{a \code{character} string representing the selected source 
that will be used to generate the network. To hand-pick the terms to be 
used, "TERM_ID" should be used and the list of selected term IDs should
be passed through the \code{termIDs} parameter. The possible sources are 
"GO:BP" for Gene Ontology Biological Process, "GO:CC" for Gene Ontology  
Cellular Component, "GO:MF" for Gene Ontology Molecular Function, 
"KEGG" for Kegg, "REAC" for Reactome, "TF" for TRANSFAC, "MIRNA" for 
miRTarBase, "CORUM" for CORUM database, "HP" for Human phenotype ontology
and "WP" for WikiPathways.  Default: "TERM_ID".}

\item{termIDs}{a \code{vector} of \code{character} strings that contains the
term IDS retained for the creation of the network. Default: \code{NULL}.}

\item{removeRoot}{a \code{logical} that specified if the root terms of 
the selected source should be removed (when present). Default: \code{TRUE}.}

\item{showCategory}{a positive \code{integer} representing the maximum 
number of terms to display.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{NULL}, all terms  
will be displayed. Default: \code{30L}.}

\item{similarityCutOff}{a positive \code{numeric} between 0 and 1 indicating 
the minimum level of similarity between two terms, calculated 
using the Jaccard coefficient, to have an edge linking 
the terms. Default: \code{0.20}.}
}
\value{
a \code{igraph} object which is the enrichment map for enrichment 
results. The node have 5 attributes: "name", "size", "pie", "cluster", 
and "pieName". The "name" corresponds to the term description. While the 
"size" corresponds to the number of unique genes found in the specific 
gene set when looking at all the experiments.
The edges have 3 attributes: "similarity", "width", and 
"weight". All those 3 attributes correspond to the Jaccard coefficient.
}
\description{
User selected enrichment terms are used to create an enrichment 
map. The selection of the term can by specifying by the 
source of the terms (GO:MF, REAC, TF, etc.) or by listing the selected 
term IDs. The map is only generated when there is at least on 
significant term to graph. The output is an enrichment map in igraph format.
}
\examples{

## Loading dataset containing results from 2 enrichment analyses done with
## gprofiler2
data(parentalNapaVsDMSOEnrichment)
data(rosaNapaVsDMSOEnrichment)

## Extract query information (only one in each dataset)
query1 <- unique(parentalNapaVsDMSOEnrichment$result$query)[1]
query2 <- unique(rosaNapaVsDMSOEnrichment$result$query)[1]

## Create graph for KEGG related results from 
## 2 enrichment analyses
emapG <- createEnrichMapMultiBasicAsIgraph(gostObjectList=
    list(parentalNapaVsDMSOEnrichment, rosaNapaVsDMSOEnrichment), 
    queryList=list(query1, query2), source="KEGG", removeRoot=TRUE, 
    similarityCutOff=0.3)

if (requireNamespace("ggplot2", quietly=TRUE) && 
        requireNamespace("igraph", quietly=TRUE) && 
        requireNamespace("scatterpie", quietly=TRUE) && 
        requireNamespace("ggtangle", quietly=TRUE) && 
        requireNamespace("ggrepel", quietly=TRUE)) {
    ## Create a visual representation of the enrichment map
    ## by default
    library(igraph)
    plot(emapG)
    
    ## Add see to reproduce the same graph
    set.seed(12)
    
    library(ggplot2)
    library(ggtangle)
    library(scatterpie)
    library(ggrepel)
    
    emapGraph <- ggplot(emapG, layout=layout_with_fr) + 
                geom_edge(color="gray", linewidth=1)
    
    pieInfo <- as.data.frame(do.call(rbind, V(emapG)$pie))
    colnames(pieInfo) <- V(emapG)$pieName[[1]]
    
    ## Add information about the groups associated with each node in the 
    ## ggplot object so that the node can be colored accordingly
    for (i in seq_len(ncol(pieInfo))) {
        emapGraph$data[colnames(pieInfo)[i]] <- pieInfo[, i]
    }
    
    ## Using scatterpie, ggtangle and ggrepel to generate the graph
    ## geom_scatterpie() allows to have scatter pie plot
    ## geom_text_repel() allows to have minimum overlying terms
    ## coord_fixed() forces the plot to have a 1:1 aspect ratio
    emapGraph + 
        geom_scatterpie(aes(x=x, y=y, r=size/50), 
            cols=c(colnames(pieInfo)), legend_name = "Group", color=NA) +
        geom_scatterpie_legend(radius=emapGraph$data$size/50, n=4, 
            x=max(emapGraph$data$x), y=min(emapGraph$data$y),
            labeller=function(x) {round(x*50)}, label_position="right") +
        geom_text_repel(aes(x=x, y=y, label=label), max.overlaps=20) +
        coord_fixed()
}

}
\author{
Astrid Deschênes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsInternal.R
\encoding{UTF-8}
\name{extractInformationWhenNoIntersection}
\alias{extractInformationWhenNoIntersection}
\title{Extract information about nodes and edges to be used to create 
network when interaction column is missing}
\usage{
extractInformationWhenNoIntersection(gostResults, gostObject)
}
\arguments{
\item{gostResults}{a \code{data.frame} containing the terms retained
for the creation of the network. The \code{data.frame} does not contain a
column called "intersection".}

\item{gostObject}{a \code{list} created by gprofiler2 that contains
the results and meta-data from an enrichment analysis.}
}
\value{
\code{list} containing 2 entries:
\itemize{
\item{\code{"geneNodes"}: a \code{data.frame} containing the information 
about the nodes present in the network. The nodes are genes.}
\item{\code{"termNodes"}: a \code{data.frame} containing the information 
about the nodes present in the network. The nodes are terms.}
\item{\code{"edges"}: a \code{data.frame} containing the information about
the edges present in the network. The edges connect one gene to one term.}
}
}
\description{
Create a list containing all node and edge information needed
to create the network
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(demoGOST)

## Only retained the WikiPathways results
results <- demoGOST$result[demoGOST$result$source == "WP", ]

information <- enrichViewNet:::extractInformationWhenNoIntersection(
                gostResults=results, gostObject=demoGOST)

}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{createBasicEmapAsIgraph}
\alias{createBasicEmapAsIgraph}
\title{Create a basic enrichment map}
\usage{
createBasicEmapAsIgraph(
  gostResults,
  backgroundGenes,
  showCategory,
  similarityCutOff
)
}
\arguments{
\item{gostResults}{a \code{data.frame} containing the enrichment 
results to be plot.}

\item{backgroundGenes}{a \code{vector} of \code{character} string 
representing the name of the genes present in the request.}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed.}

\item{similarityCutOff}{a positive \code{numeric} between 0 and 1 indicating 
the minimum level of similarity between two terms to have an edge linking 
the terms.}
}
\value{
a \code{igraph} object representing the enrichment map.
}
\description{
The function creates a basic enrichment map using functional 
enrichment results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retain the results section
gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)

## Limit the results to Wikipathways
## and remove the root term
gostResults <- gostResults[which(gostResults$source == "WP"),]
gostResults <- gostResults[which(gostResults$term_name != "WIKIPATHWAYS"),]

## Extract meta data information
meta <- parentalNapaVsDMSOEnrichment$meta

## Get all background genes
backgroundGenes <- meta$query_metadata$queries[["parental_napa_vs_DMSO"]]

## Create basic enrichment map, as an igraph, using Wikipathways terms
enrichViewNet:::createBasicEmapAsIgraph(gostResults=gostResults, 
    backgroundGenes=backgroundGenes, showCategory=30L, 
    similarityCutOff=0.2)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/enrichViewNet.R
\docType{data}
\name{demoGOST}
\alias{demoGOST}
\title{The result of a functional enrichment analysis done with \code{gprofiler2} 
(\url{https://cran.r-project.org/web/packages/gprofiler2/vignettes/gprofiler2.html}).}
\format{
The \code{list} contains two entries. The \code{result} entry 
contains a \code{data.frame} with the significant results obtained by
an enrichment analysis done with \code{gprofiler2}. The \code{meta} entry 
contains a named list with all the metadata for the query.
}
\usage{
data(demoGOST)
}
\value{
A \code{list} containing two entries. The \code{result} entry 
contains a \code{data.frame} with the significant results obtained by
an enrichment analysis done with \code{gprofiler2}. 
The \code{meta} entry contains a named list with all the 
metadata for the query.
}
\description{
The object is a \code{list} with 2 entries. It contains the results of the
enrichment analysis as well as the metadata related to the analysis.
}
\details{
This dataset can be
used to test the \code{\link{createNetwork}} function.
}
\examples{

## Loading dataset containing result from an enrichment analysis done with
## gprofiler2
data(demoGOST)

## Create network for WikiPathways results 
## in Cytoscape (if the application is open)
## Otherwise, create a CX file in the temporary directory
## The file can be opened in Cytoscape
createNetwork(gostObject=demoGOST, source="WP", title="Wikipathways",
    fileName=file.path(tempdir(), "Wikipathways_Demo.cx"))


}
\seealso{
\itemize{
    \item{\link{createNetwork} for transforming functional 
    enrichment results from gprofiler2 into a Cytoscape network}
    \item{\link{createEnrichMap} for transforming functional 
    enrichment results from gprofiler2 into an enrichment map}
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{createMultiEmapAsIgraph}
\alias{createMultiEmapAsIgraph}
\title{Create a complex enrichment map as an igraph}
\usage{
createMultiEmapAsIgraph(
  gostResultsList,
  queryList,
  showCategory,
  similarityCutOff
)
}
\arguments{
\item{gostResultsList}{a \code{list} of \code{data.frame} containing 
the enrichment results to be plot with different group identification.}

\item{queryList}{a \code{list} of \code{character} string 
representing the name of query retained for each enrichment results present 
in the \code{gostResultsList} parameter. The query should be present in its 
associated enrichment results.}

\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{NULL}, 
all terms will be displayed.}

\item{similarityCutOff}{a positive \code{numeric}, larger than zero and
small than 1 that represent the minimum similarity level between two 
nodes (terms) to be linked by an edge.}
}
\value{
a \code{igraph} object representing the enrichment map with 
different colors for each group of enrichment results.
}
\description{
The function creates a complex enrichment map, as an igraph, 
using functional enrichment results.
}
\examples{

## Load the result of an enrichment analysis done with gprofiler2
data(parentalNapaVsDMSOEnrichment)

## Only retain the results section
gostResults <- as.data.frame(parentalNapaVsDMSOEnrichment$result)

## Limit the results subsection of REACTOME and KEGG
## Kegg is replicated to show shared results between queries
gostResultsREAC <- gostResults[which(gostResults$source == "REAC"),]
gostResultsREAC <- gostResultsREAC[1:13, ]
gostResultsKEGG <- gostResults[which(gostResults$source == "KEGG"),]
gostResultsKEGG2 <- gostResultsKEGG[1:6,]

## Extract meta data information
queryList <- list("parental - REACTOME", "parental - KEGG - v1", 
    "parental - KEGG - v2")

## Create basic enrichment map using Wikipathways terms
igraph <- enrichViewNet:::createMultiEmapAsIgraph(
    gostResultsList=list(gostResultsREAC, gostResultsKEGG, 
            gostResultsKEGG2), 
    queryList=queryList, showCategory=30L, similarityCutOff=0.5)
    
}
\author{
Astrid Deschênes
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/methodsEmapInternal.R
\encoding{UTF-8}
\name{validateCreateEnrichMapSubSectionArguments}
\alias{validateCreateEnrichMapSubSectionArguments}
\title{Validate common arguments passed to createEnrichMap() and 
createEnrichMapMultiBasic() functions}
\usage{
validateCreateEnrichMapSubSectionArguments(
  showCategory,
  groupCategory,
  categoryLabel,
  categoryNode,
  line
)
}
\arguments{
\item{showCategory}{a positive \code{integer} or a \code{vector} of 
\code{characters} representing terms.  If a \code{integer}, the first 
\code{n} terms will be displayed. If \code{vector} of terms, 
the selected terms will be displayed.}

\item{groupCategory}{a \code{logical} indicating if the categories should 
be grouped.}

\item{categoryLabel}{a positive \code{numeric} representing the amount by 
which plotting category nodes label size should be scaled relative 
to the default (1).}

\item{categoryNode}{a positive \code{numeric} representing he amount by 
which plotting category nodes should be scaled relative to the default (1).}

\item{line}{a non-negative \code{numeric} representing the scale of line 
width.}
}
\value{
\code{TRUE} when all arguments are valid
}
\description{
Validate the common arguments passed to createEnrichMap() and 
createEnrichMapMultiBasic() functions.
}
\examples{

## Check that all arguments are valid
enrichViewNet:::validateCreateEnrichMapSubSectionArguments(
    showCategory=20, groupCategory=FALSE, categoryLabel=1.1, categoryNode=1, 
    line=0.5)

}
\author{
Astrid Deschênes
}
\keyword{internal}
